//----------------------------------------------------------
// name: "mTDelHarmo16"
//
// Code generated with Faust 0.9.96 (http://faust.grame.fr)
//----------------------------------------------------------

/* link with  */
#include <math.h>
/************************************************************************

    IMPORTANT NOTE : this file contains two clearly delimited sections :
    the ARCHITECTURE section (in two parts) and the USER section. Each section
    is governed by its own copyright and license. Please check individually
    each section for license and copyright information.
*************************************************************************/

/*******************BEGIN ARCHITECTURE SECTION (part 1/2)****************/

/************************************************************************
    FAUST Architecture File
    Copyright (C) 2004-2011 GRAME, Centre National de Creation Musicale
    ---------------------------------------------------------------------
    This Architecture section is free software; you can redistribute it
    and/or modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either version 3
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program; If not, see <http://www.gnu.org/licenses/>.

    EXCEPTION : As a special exception, you may create a larger work
    that contains this FAUST architecture section and distribute
    that work under terms of your choice, so long as this FAUST
    architecture section is not modified.

    MAX MSP SDK : in order to compile a MaxMSP external with this
    architecture file you will need the official MaxMSP SDK from
    cycling'74. Please check the corresponding license.

 ************************************************************************
 ************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <math.h>
#include <errno.h>
#include <time.h>
#include <unistd.h>
#include <fcntl.h>
#include <assert.h>
#include <string>
#include <vector>
#include <map>
#include <math.h>
#include <iostream>
#include <fstream>
#include <sstream>

#ifdef __APPLE__
#include <Carbon/Carbon.h>
#include <unistd.h>
#endif

#ifdef WIN32
#ifndef NAN
    static const unsigned long __nan[2] = {0xffffffff, 0x7fffffff};
    #define NAN (*(const float *) __nan)
#endif
#endif

#define FAUSTFLOAT double

/************************************************************************
    FAUST Architecture File
    Copyright (C) 2003-2017 GRAME, Centre National de Creation Musicale
    ---------------------------------------------------------------------
    This Architecture section is free software; you can redistribute it
    and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 3 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; If not, see <http://www.gnu.org/licenses/>.

    EXCEPTION : As a special exception, you may create a larger work
    that contains this FAUST architecture section and distribute
    that work under terms of your choice, so long as this FAUST
    architecture section is not modified.


 ************************************************************************
 ************************************************************************/

#ifndef FAUST_UI_H
#define FAUST_UI_H

#ifndef FAUSTFLOAT
#define FAUSTFLOAT float
#endif

/*******************************************************************************
 * UI : Faust DSP User Interface
 * User Interface as expected by the buildUserInterface() method of a DSP.
 * This abstract class contains only the method that the Faust compiler can
 * generate to describe a DSP user interface.
 ******************************************************************************/

class UI
{

    public:

        UI() {}

        virtual ~UI() {}

        // -- widget's layouts

        virtual void openTabBox(const char* label) = 0;
        virtual void openHorizontalBox(const char* label) = 0;
        virtual void openVerticalBox(const char* label) = 0;
        virtual void closeBox() = 0;

        // -- active widgets

        virtual void addButton(const char* label, FAUSTFLOAT* zone) = 0;
        virtual void addCheckButton(const char* label, FAUSTFLOAT* zone) = 0;
        virtual void addVerticalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step) = 0;
        virtual void addHorizontalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step) = 0;
        virtual void addNumEntry(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step) = 0;

        // -- passive widgets

        virtual void addHorizontalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max) = 0;
        virtual void addVerticalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max) = 0;

        // -- metadata declarations

        virtual void declare(FAUSTFLOAT*, const char*, const char*) {}
};

#endif
/************************************************************************
    FAUST Architecture File
    Copyright (C) 2003-2011 GRAME, Centre National de Creation Musicale
    ---------------------------------------------------------------------
    This Architecture section is free software; you can redistribute it
    and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 3 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; If not, see <http://www.gnu.org/licenses/>.

    EXCEPTION : As a special exception, you may create a larger work
    that contains this FAUST architecture section and distribute
    that work under terms of your choice, so long as this FAUST
    architecture section is not modified.


 ************************************************************************
 ************************************************************************/
 
#ifndef FAUST_JSONUI_H
#define FAUST_JSONUI_H

#ifndef FAUSTFLOAT
#define FAUSTFLOAT float
#endif

/************************************************************************
    FAUST Architecture File
    Copyright (C) 2003-2011 GRAME, Centre National de Creation Musicale
    ---------------------------------------------------------------------
    This Architecture section is free software; you can redistribute it
    and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 3 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; If not, see <http://www.gnu.org/licenses/>.

    EXCEPTION : As a special exception, you may create a larger work
    that contains this FAUST architecture section and distribute
    that work under terms of your choice, so long as this FAUST
    architecture section is not modified.


 ************************************************************************
 ************************************************************************/

#ifndef FAUST_PATHBUILDER_H
#define FAUST_PATHBUILDER_H

#include <vector>
#include <string>
#include <algorithm>

/*******************************************************************************
 * PathBuilder : Faust User Interface
 * Helper class to build complete hierarchical path for UI items.
 ******************************************************************************/

class PathBuilder
{

    protected:
    
        std::vector<std::string> fControlsLevel;
       
    public:
    
        PathBuilder() {}
        virtual ~PathBuilder() {}
    
        std::string buildPath(const std::string& label) 
        {
            std::string res = "/";
            for (size_t i = 0; i < fControlsLevel.size(); i++) {
                res += fControlsLevel[i];
                res += "/";
            }
            res += label;
            replace(res.begin(), res.end(), ' ', '_');
            return res;
        }
    
};

#endif  // FAUST_PATHBUILDER_H
/************************************************************************
 ************************************************************************
    FAUST Architecture File
	Copyright (C) 2003-2011 GRAME, Centre National de Creation Musicale
    ---------------------------------------------------------------------
    This Architecture section is free software; you can redistribute it
    and/or modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3 of
	the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
	along with this program; If not, see <http://www.gnu.org/licenses/>.

 ************************************************************************
 ************************************************************************/
 
#ifndef __meta__
#define __meta__

struct Meta
{
    virtual void declare(const char* key, const char* value) = 0;
    virtual ~Meta() {};
};

#endif

#include <vector>
#include <map>
#include <string>
#include <iostream>
#include <sstream>
#include <assert.h>

/*******************************************************************************
 * JSONUI : Faust User Interface
 * This class produce a complete JSON decription of the DSP instance.
 ******************************************************************************/

class JSONUI : public PathBuilder, public Meta, public UI
{

    protected:
    
        std::stringstream fJSON;
        std::stringstream fUI;
        std::stringstream fMeta;
        std::vector<std::pair <std::string, std::string> > fMetaAux;
        std::string fName;
        std::string fExpandedCode;
        std::string fSHAKey;
    
        char fCloseUIPar;
        char fCloseMetaPar;
        int fTab;
    
        int fInputs, fOutputs;
         
        void tab(int n, std::ostream& fout)
        {
            fout << '\n';
            while (n-- > 0) {
                fout << '\t';
            }
        }
    
        void addMeta(int tab_val, bool quote = true)
        {
            if (fMetaAux.size() > 0) {
                tab(tab_val, fUI); fUI << "\"meta\": [";
                std::string sep = "";
                for (size_t i = 0; i < fMetaAux.size(); i++) {
                    fUI << sep;
                    tab(tab_val + 1, fUI); fUI << "{ \"" << fMetaAux[i].first << "\": \"" << fMetaAux[i].second << "\" }";
                    sep = ",";
                }
                tab(tab_val, fUI); fUI << ((quote) ? "],": "]");
                fMetaAux.clear();
            }
        }
        
        void init(const std::string& name, int inputs, int outputs, const std::string& sha_key, const std::string& dsp_code)
        {
            fTab = 1;
            
            // Start Meta generation
            tab(fTab, fMeta); fMeta << "\"meta\": [";
            fCloseMetaPar = ' ';
            
            // Start UI generation
            tab(fTab, fUI); fUI << "\"ui\": [";
            fCloseUIPar = ' ';
            fTab += 1;
            
            fName = name;
            fInputs = inputs;
            fOutputs = outputs;
            fExpandedCode = dsp_code;
            fSHAKey = sha_key;
        }
        
        inline std::string flatten(const std::string& src)
        {
            std::stringstream dst;
            for (size_t i = 0; i < src.size(); i++) {
                switch (src[i]) {
                    case '\n':
                    case '\t':
                        dst << ' ';
                        break;
                    case '"':
                        dst << "\\" << '"';
                        break;
                    default:
                        dst << src[i];
                        break;
                }
            }
            return dst.str();
        }
      
     public:
     
        JSONUI(const std::string& name, int inputs, int outputs, const std::string& sha_key, const std::string& dsp_code)
        {
            init(name, inputs, outputs, sha_key, dsp_code);
        }

        JSONUI(const std::string& name, int inputs, int outputs)
        {
            init(name, inputs, outputs, "", "");
        }

        JSONUI(int inputs, int outputs)
        {
            init("", inputs, outputs, "", "");
        }
        
        JSONUI()
        {
            init("", -1, -1, "", "");
        }
 
        virtual ~JSONUI() {}

        // -- widget's layouts
    
        virtual void openGenericGroup(const char* label, const char* name)
        {
            fControlsLevel.push_back(label);
            fUI << fCloseUIPar;
            tab(fTab, fUI); fUI << "{";
            fTab += 1;
            tab(fTab, fUI); fUI << "\"type\": \"" << name << "\",";
            tab(fTab, fUI); fUI << "\"label\": \"" << label << "\",";
            addMeta(fTab + 1);
            tab(fTab, fUI); fUI << "\"items\": [";
            fCloseUIPar = ' ';
            fTab += 1;
        }

        virtual void openTabBox(const char* label)
        {
            openGenericGroup(label, "tgroup");
        }
    
        virtual void openHorizontalBox(const char* label)
        {
            openGenericGroup(label, "hgroup");
        }
    
        virtual void openVerticalBox(const char* label)
        {
            openGenericGroup(label, "vgroup");
        }
    
        virtual void closeBox()
        {
            fControlsLevel.pop_back();
            fTab -= 1;
            tab(fTab, fUI); fUI << "]";
            fTab -= 1;
            tab(fTab, fUI); fUI << "}";
            fCloseUIPar = ',';
        }
    
        // -- active widgets
    
        virtual void addGenericButton(const char* label, const char* name)
        {
            fUI << fCloseUIPar;
            tab(fTab, fUI); fUI << "{";
            tab(fTab + 1, fUI); fUI << "\"type\": \"" << name << "\",";
            tab(fTab + 1, fUI); fUI << "\"label\": \"" << label << "\"" << ",";
            tab(fTab + 1, fUI); fUI << "\"address\": \"" << buildPath(label) << "\"" << ((fMetaAux.size() > 0) ? "," : "");
            addMeta(fTab + 1, false);
            tab(fTab, fUI); fUI << "}";
            fCloseUIPar = ',';
        }

        virtual void addButton(const char* label, FAUSTFLOAT* zone)
        {
            addGenericButton(label, "button");
        }
    
        virtual void addCheckButton(const char* label, FAUSTFLOAT* zone)
        {
            addGenericButton(label, "checkbox");
        }

        virtual void addGenericEntry(const char* label, const char* name, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step)
        {
            fUI << fCloseUIPar;
            tab(fTab, fUI); fUI << "{";
            tab(fTab + 1, fUI); fUI << "\"type\": \"" << name << "\",";
            tab(fTab + 1, fUI); fUI << "\"label\": \"" << label << "\"" << ",";
            tab(fTab + 1, fUI); fUI << "\"address\": \"" << buildPath(label) << "\"" << ",";
            addMeta(fTab + 1);
            tab(fTab + 1, fUI); fUI << "\"init\": \"" << init << "\",";
            tab(fTab + 1, fUI); fUI << "\"min\": \"" << min << "\",";
            tab(fTab + 1, fUI); fUI << "\"max\": \"" << max << "\",";
            tab(fTab + 1, fUI); fUI << "\"step\": \"" << step << "\"";
            tab(fTab, fUI); fUI << "}";
            fCloseUIPar = ',';
        }
    
        virtual void addVerticalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step)
        {
            addGenericEntry(label, "vslider", init, min, max, step);
        }
    
        virtual void addHorizontalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step)
        {
            addGenericEntry(label, "hslider", init, min, max, step);
        }
    
        virtual void addNumEntry(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step)
        {
            addGenericEntry(label, "nentry", init, min, max, step);
        }

        // -- passive widgets
    
        virtual void addGenericBargraph(const char* label, const char* name, FAUSTFLOAT min, FAUSTFLOAT max) 
        {
            fUI << fCloseUIPar;
            tab(fTab, fUI); fUI << "{";
            tab(fTab + 1, fUI); fUI << "\"type\": \"" << name << "\",";
            tab(fTab + 1, fUI); fUI << "\"label\": \"" << label << "\"" << ",";
            tab(fTab + 1, fUI); fUI << "\"address\": \"" << buildPath(label) << "\"" << ",";
            addMeta(fTab + 1);
            tab(fTab + 1, fUI); fUI << "\"min\": \"" << min << "\",";
            tab(fTab + 1, fUI); fUI << "\"max\": \"" << max << "\"";
            tab(fTab, fUI); fUI << "}";
            fCloseUIPar = ',';
        }

        virtual void addHorizontalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max) 
        {
            addGenericBargraph(label, "hbargraph", min, max);
        }
    
        virtual void addVerticalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max)
        {
            addGenericBargraph(label, "vbargraph", min, max);
        }

        // -- metadata declarations

        virtual void declare(FAUSTFLOAT* zone, const char* key, const char* val)
        {
            fMetaAux.push_back(std::make_pair(key, val));
        }
    
        // Meta interface
        virtual void declare(const char* key, const char* value)
        {
            fMeta << fCloseMetaPar;
            if ((strcmp(key, "name") == 0) && (fName == "")) fName = value;
            tab(fTab, fMeta); fMeta << "{ " << "\"" << key << "\"" << ": " << "\"" << value << "\" }";
            fCloseMetaPar = ',';
        }
    
        std::string JSON(bool flat = false)
        {
            fTab = 0;
            fJSON << "{";
            fTab += 1;
            tab(fTab, fJSON); fJSON << "\"name\": \"" << fName << "\",";
            if (fSHAKey != "") { tab(fTab, fJSON); fJSON << "\"sha_key\": \"" << fSHAKey << "\","; }
            if (fExpandedCode != "") { tab(fTab, fJSON); fJSON << "\"code\": \"" << fExpandedCode << "\","; }
            tab(fTab, fJSON); fJSON << "\"inputs\": \"" << fInputs << "\","; 
            tab(fTab, fJSON); fJSON << "\"outputs\": \"" << fOutputs << "\",";
            tab(fTab, fMeta); fMeta << "],";
            tab(fTab, fUI); fUI << "]";
            fTab -= 1;
            if (fCloseMetaPar == ',') { // If "declare" has been called, fCloseMetaPar state is now ','
                fJSON << fMeta.str() << fUI.str();
            } else {
                fJSON << fUI.str();
            }
            tab(fTab, fJSON); fJSON << "}" << std::endl;
            return (flat) ? flatten(fJSON.str()) : fJSON.str();
        }
    
};

#endif // FAUST_JSONUI_H
/************************************************************************
    IMPORTANT NOTE : this file contains two clearly delimited sections :
    the ARCHITECTURE section (in two parts) and the USER section. Each section
    is governed by its own copyright and license. Please check individually
    each section for license and copyright information.
*************************************************************************/

/*******************BEGIN ARCHITECTURE SECTION (part 1/2)****************/

/************************************************************************
    FAUST Architecture File
    Copyright (C) 2003-2011 GRAME, Centre National de Creation Musicale
    ---------------------------------------------------------------------
    This Architecture section is free software; you can redistribute it
    and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 3 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; If not, see <http://www.gnu.org/licenses/>.

    EXCEPTION : As a special exception, you may create a larger work
    that contains this FAUST architecture section and distribute
    that work under terms of your choice, so long as this FAUST
    architecture section is not modified.

 ************************************************************************
 ************************************************************************/
 
/******************************************************************************
*******************************************************************************

								FAUST DSP

*******************************************************************************
*******************************************************************************/

#ifndef __dsp__
#define __dsp__

#ifndef FAUSTFLOAT
#define FAUSTFLOAT float
#endif

class UI;
struct Meta;

/**
* Signal processor definition.
*/

class dsp {

    public:

        dsp() {}
        virtual ~dsp() {}

        /* Return instance number of audio inputs */
        virtual int getNumInputs() = 0;
    
        /* Return instance number of audio outputs */
        virtual int getNumOutputs() = 0;
    
        /**
         * Trigger the UI* parameter with instance specific calls
         * to 'addBtton', 'addVerticalSlider'... in order to build the UI.
         *
         * @param ui_interface - the UI* user interface builder
         */
        virtual void buildUserInterface(UI* ui_interface) = 0;
    
        /* Returns the sample rate currently used by the instance */
        virtual int getSampleRate() = 0;
    
        /** Global init, calls the following methods:
         * - static class 'classInit': static table initialisation
         * - 'instanceInit': constants and instance table initialisation
         *
         * @param samplingRate - the sampling rate in Herz
         */
        virtual void init(int samplingRate) = 0;
    
        /** Init instance state
         *
         * @param samplingRate - the sampling rate in Herz
         */
        virtual void instanceInit(int samplingRate) = 0;
    
        /** Init instance constant state
         *
         * @param samplingRate - the sampling rate in Herz
         */
        virtual void instanceConstants(int samplingRate) = 0;
    
        /* Init default control parameters values */
        virtual void instanceResetUserInterface() = 0;
    
        /* Init instance state (delay lines...) */
        virtual void instanceClear() = 0;
    
        /**  
         * Return a clone of the instance.
         *
         * @return a copy of the instance on success, otherwise a null pointer.
         */
        virtual dsp* clone() = 0;
    
        /**
         * Trigger the Meta* parameter with instance specific calls to 'declare' (key, value metadata).
         *
         * @param m - the Meta* meta user
         */
        virtual void metadata(Meta* m) = 0;
    
        /**
         * DSP instance computation, to be called with sucessive in/out audio buffers.
         *
         * @param count - the nomber of frames to compute
         * @param inputs - the input audio buffers as an array of non-interleaved FAUSTFLOAT samples (eiher float, double or quad)
         * @param outputs - the output audio buffers as an array of non-interleaved FAUSTFLOAT samples (eiher float, double or quad)
         *
         */
        virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) = 0;
    
        /**
         * DSP instance computation: alternative method to be used by subclasses.
         *
         * @param date_usec - the timestamp in microsec given by audio driver.
         * @param count - the nomber of frames to compute
         * @param inputs - the input audio buffers as an array of non-interleaved FAUSTFLOAT samples (eiher float, double or quad)
         * @param outputs - the output audio buffers as an array of non-interleaved FAUSTFLOAT samples (eiher float, double or quad)
         *
         */
        virtual void compute(double date_usec, int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) { compute(count, inputs, outputs); }
       
};

/**
 * Generic DSP decorator.
 */

class decorator_dsp : public dsp {

    protected:

        dsp* fDSP;

    public:

        decorator_dsp(dsp* dsp = 0):fDSP(dsp) {}
        virtual ~decorator_dsp() { delete fDSP; }

        virtual int getNumInputs() { return fDSP->getNumInputs(); }
        virtual int getNumOutputs() { return fDSP->getNumOutputs(); }
        virtual void buildUserInterface(UI* ui_interface) { fDSP->buildUserInterface(ui_interface); }
        virtual int getSampleRate() { return fDSP->getSampleRate(); }
        virtual void init(int samplingRate) { fDSP->init(samplingRate); }
        virtual void instanceInit(int samplingRate) { fDSP->instanceInit(samplingRate); }
        virtual void instanceConstants(int samplingRate) { fDSP->instanceConstants(samplingRate); }
        virtual void instanceResetUserInterface() { fDSP->instanceResetUserInterface(); }
        virtual void instanceClear() { fDSP->instanceClear(); }
        virtual decorator_dsp* clone() { return new decorator_dsp(fDSP->clone()); }
        virtual void metadata(Meta* m) { return fDSP->metadata(m); }
        // Beware: subclasses usually have to overload the two 'compute' methods
        virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) { fDSP->compute(count, inputs, outputs); }
        virtual void compute(double date_usec, int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) { fDSP->compute(date_usec, count, inputs, outputs); }
       
};

/**
 * On Intel set FZ (Flush to Zero) and DAZ (Denormals Are Zero)
 * flags to avoid costly denormals.
 */

#ifdef __SSE__
    #include <xmmintrin.h>
    #ifdef __SSE2__
        #define AVOIDDENORMALS _mm_setcsr(_mm_getcsr() | 0x8040)
    #else
        #define AVOIDDENORMALS _mm_setcsr(_mm_getcsr() | 0x8000)
    #endif
#else
    #define AVOIDDENORMALS
#endif

#endif
/************************************************************************
 ************************************************************************
    FAUST Architecture File
	Copyright (C) 2003-2011 GRAME, Centre National de Creation Musicale
    ---------------------------------------------------------------------
    This Architecture section is free software; you can redistribute it
    and/or modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3 of
	the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
	along with this program; If not, see <http://www.gnu.org/licenses/>.

 ************************************************************************
 ************************************************************************/
 
#ifndef __misc__
#define __misc__

#include <algorithm>
#include <map>
#include <string.h>
#include <stdlib.h>


using std::max;
using std::min;

struct XXXX_Meta : std::map<const char*, const char*>
{
    void declare(const char* key, const char* value) { (*this)[key]=value; }
};

struct MY_Meta : Meta, std::map<const char*, const char*>
{
    void declare(const char* key, const char* value) { (*this)[key]=value; }
};

inline int lsr(int x, int n)	{ return int(((unsigned int)x) >> n); }

inline int int2pow2(int x)		{ int r = 0; while ((1<<r) < x) r++; return r; }

inline long lopt(char* argv[], const char* name, long def)
{
	int	i;
	for (i = 0; argv[i]; i++) if (!strcmp(argv[i], name)) return atoi(argv[i+1]);
	return def;
}

inline bool isopt(char* argv[], const char* name)
{
	int	i;
	for (i = 0; argv[i]; i++) if (!strcmp(argv[i], name)) return true;
	return false;
}

inline const char* lopts(char* argv[], const char* name, const char* def)
{
	int	i;
	for (i = 0; argv[i]; i++) if (!strcmp(argv[i], name)) return argv[i+1];
	return def;
}

#endif


#ifdef POLY2
/************************************************************************
    IMPORTANT NOTE : this file contains two clearly delimited sections :
    the ARCHITECTURE section (in two parts) and the USER section. Each section
    is governed by its own copyright and license. Please check individually
    each section for license and copyright information.
*************************************************************************/

/*******************BEGIN ARCHITECTURE SECTION (part 1/2)****************/

/************************************************************************
    FAUST Architecture File
    Copyright (C) 2003-2011 GRAME, Centre National de Creation Musicale
    ---------------------------------------------------------------------
    This Architecture section is free software; you can redistribute it
    and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 3 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; If not, see <http://www.gnu.org/licenses/>.

    EXCEPTION : As a special exception, you may create a larger work
    that contains this FAUST architecture section and distribute
    that work under terms of your choice, so long as this FAUST
    architecture section is not modified.

 ************************************************************************
 ************************************************************************/

#ifndef __dsp_combiner__
#define __dsp_combiner__

#include <string.h>
#include <assert.h>

// Combine two DSP in sequence

class dsp_sequencer : public dsp {
    
    private:
        
        dsp* fDSP1;
        dsp* fDSP2;
        FAUSTFLOAT** fSeqBuffer;
         
    public:
        
        dsp_sequencer(dsp* dsp1, dsp* dsp2, int buffer_size = 4096)
            :fDSP1(dsp1), fDSP2(dsp2)
        {
            assert(fDSP1->getNumOutputs() == fDSP2->getNumInputs());
            fSeqBuffer = new FAUSTFLOAT*[fDSP1->getNumOutputs()];
            for (int i = 0; i < fDSP1->getNumOutputs(); i++) {
                fSeqBuffer[i] = new FAUSTFLOAT[buffer_size];
            }
        }
        
        virtual ~dsp_sequencer()
        {
            for (int i = 0; i < fDSP1->getNumOutputs(); i++) {
               delete [] fSeqBuffer[i];
            }
            
            delete [] fSeqBuffer;
            delete fDSP1;
            delete fDSP2;
        }
               
        virtual int getNumInputs() { return fDSP1->getNumInputs(); }
        virtual int getNumOutputs() { return fDSP2->getNumOutputs(); }
    
        virtual void buildUserInterface(UI* ui_interface)
        {
            ui_interface->openTabBox("Sequencer");
            ui_interface->openVerticalBox("DSP1");
            fDSP1->buildUserInterface(ui_interface);
            ui_interface->closeBox();
            ui_interface->openVerticalBox("DSP2");
            fDSP2->buildUserInterface(ui_interface);
            ui_interface->closeBox();
            ui_interface->closeBox();
        }
        
        virtual int getSampleRate()
        {
            return fDSP1->getSampleRate();
        }
    
        virtual void init(int samplingRate)
        {
            fDSP1->init(samplingRate);
            fDSP2->init(samplingRate);
        }
    
        virtual void instanceInit(int samplingRate)
        {
            fDSP1->instanceInit(samplingRate);
            fDSP2->instanceInit(samplingRate);
        }
    
        virtual void instanceConstants(int samplingRate)
        {
            fDSP1->instanceConstants(samplingRate);
            fDSP2->instanceConstants(samplingRate);
        }
    
        virtual void instanceResetUserInterface()
        {
            fDSP1->instanceResetUserInterface();
            fDSP2->instanceResetUserInterface();
        }
    
        virtual void instanceClear()
        {
            fDSP1->instanceClear();
            fDSP2->instanceClear();
        }
        
        virtual dsp* clone()
        {
            return new dsp_sequencer(fDSP1->clone(), fDSP2->clone());
        }
    
        virtual void metadata(Meta* m)
        {
            fDSP1->metadata(m);
            fDSP2->metadata(m);
        }
 
        virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
        {
            fDSP1->compute(count, inputs, fSeqBuffer);
            fDSP2->compute(count, fSeqBuffer, outputs);
        }
        virtual void compute(double date_usec, int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) { compute(count, inputs, outputs); }
};

// Combine two DSP in parallel

class dsp_parallelizer : public dsp {
    
    private:
        
        dsp* fDSP1;
        dsp* fDSP2;
         
    public:
        
        dsp_parallelizer(dsp* dsp1, dsp* dsp2, int buffer_size = 4096)
            :fDSP1(dsp1), fDSP2(dsp2)
        {}
        
        virtual ~dsp_parallelizer()
        {
            delete fDSP1;
            delete fDSP2;
        }
               
        virtual int getNumInputs() { return fDSP1->getNumInputs() + fDSP2->getNumInputs(); }
        virtual int getNumOutputs() { return fDSP1->getNumOutputs() + fDSP2->getNumOutputs(); }
    
        virtual void buildUserInterface(UI* ui_interface)
        {
            ui_interface->openTabBox("Parallelizer");
            ui_interface->openVerticalBox("DSP1");
            fDSP1->buildUserInterface(ui_interface);
            ui_interface->closeBox();
            ui_interface->openVerticalBox("DSP2");
            fDSP2->buildUserInterface(ui_interface);
            ui_interface->closeBox();
            ui_interface->closeBox();
        }
        
        virtual int getSampleRate()
        {
            return fDSP1->getSampleRate();
        }
    
        virtual void init(int samplingRate)
        {
            fDSP1->init(samplingRate);
            fDSP2->init(samplingRate);
        }
    
        virtual void instanceInit(int samplingRate)
        {
            fDSP1->instanceInit(samplingRate);
            fDSP2->instanceInit(samplingRate);
        }
    
        virtual void instanceConstants(int samplingRate)
        {
            fDSP1->instanceConstants(samplingRate);
            fDSP2->instanceConstants(samplingRate);
        }
        
        virtual void instanceResetUserInterface()
        {
            fDSP1->instanceResetUserInterface();
            fDSP2->instanceResetUserInterface();
        }
    
        virtual void instanceClear()
        {
            fDSP1->instanceClear();
            fDSP2->instanceClear();
        }
        
        virtual dsp* clone()
        {
            return new dsp_parallelizer(fDSP1->clone(), fDSP2->clone());
        }

        virtual void metadata(Meta* m)
        {
            fDSP1->metadata(m);
            fDSP2->metadata(m);
        }
    
        virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
        {
            fDSP1->compute(count, inputs, outputs);
            
            // Shift inputs/outputs channels for fDSP2
            FAUSTFLOAT** inputs_dsp2 = (FAUSTFLOAT**)alloca(fDSP2->getNumInputs() * sizeof(FAUSTFLOAT*));
            for (int chan = 0; chan < fDSP2->getNumInputs(); chan++) {
                inputs_dsp2[chan] = inputs[fDSP1->getNumInputs() + chan];
            }
            
            FAUSTFLOAT** outputs_dsp2 = (FAUSTFLOAT**)alloca(fDSP2->getNumOutputs() * sizeof(FAUSTFLOAT*));
            for (int chan = 0; chan < fDSP2->getNumOutputs(); chan++) {
                outputs_dsp2[chan] = inputs[fDSP1->getNumOutputs() + chan];
            }
            
            fDSP2->compute(count, inputs_dsp2, outputs_dsp2);
        }
        virtual void compute(double date_usec, int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) { compute(count, inputs, outputs); }
};

#endif
#include "effect.cpp"
#endif

using namespace std;

/******************************************************************************
*******************************************************************************

							       VECTOR INTRINSICS

*******************************************************************************
*******************************************************************************/


/********************END ARCHITECTURE SECTION (part 1/2)****************/

/**************************BEGIN USER SECTION **************************/

#ifndef FAUSTFLOAT
#define FAUSTFLOAT float
#endif  


#ifndef FAUSTCLASS 
#define FAUSTCLASS mydsp
#endif

class mydsp : public dsp {
  private:
	class SIG0 {
	  private:
		int fSamplingFreq;
		int 	iRec16[2];
	  public:
		int getNumInputs() { return 0; }
		int getNumOutputs() { return 1; }
		void init(int samplingFreq) {
			fSamplingFreq = samplingFreq;
			for (int i=0; i<2; i++) iRec16[i] = 0;
		}
		void fill (int count, double output[]) {
			for (int i=0; i<count; i++) {
				iRec16[0] = (iRec16[1] + 1);
				output[i] = sin((9.587379924285257e-05 * double((iRec16[0] + -1))));
				// post processing
				iRec16[1] = iRec16[0];
			}
		}
	};


	FAUSTFLOAT 	fslider0;
	static double 	ftbl0[65536];
	double 	fConst0;
	double 	fConst1;
	double 	fConst2;
	double 	fRec17[2];
	double 	fVec0[2];
	FAUSTFLOAT 	fcheckbox0;
	FAUSTFLOAT 	fslider1;
	double 	fConst3;
	FAUSTFLOAT 	fslider2;
	double 	fRec18[2];
	FAUSTFLOAT 	fcheckbox1;
	FAUSTFLOAT 	fslider3;
	FAUSTFLOAT 	fslider4;
	double 	fRec19[2];
	FAUSTFLOAT 	fcheckbox2;
	FAUSTFLOAT 	fslider5;
	FAUSTFLOAT 	fslider6;
	double 	fRec20[2];
	FAUSTFLOAT 	fcheckbox3;
	FAUSTFLOAT 	fslider7;
	FAUSTFLOAT 	fslider8;
	double 	fRec21[2];
	FAUSTFLOAT 	fcheckbox4;
	FAUSTFLOAT 	fslider9;
	FAUSTFLOAT 	fslider10;
	double 	fRec22[2];
	FAUSTFLOAT 	fcheckbox5;
	FAUSTFLOAT 	fslider11;
	FAUSTFLOAT 	fslider12;
	double 	fRec23[2];
	FAUSTFLOAT 	fcheckbox6;
	FAUSTFLOAT 	fslider13;
	FAUSTFLOAT 	fslider14;
	double 	fRec24[2];
	FAUSTFLOAT 	fcheckbox7;
	FAUSTFLOAT 	fslider15;
	FAUSTFLOAT 	fslider16;
	double 	fRec25[2];
	FAUSTFLOAT 	fcheckbox8;
	FAUSTFLOAT 	fslider17;
	FAUSTFLOAT 	fslider18;
	double 	fRec26[2];
	FAUSTFLOAT 	fcheckbox9;
	FAUSTFLOAT 	fslider19;
	FAUSTFLOAT 	fslider20;
	double 	fRec27[2];
	FAUSTFLOAT 	fcheckbox10;
	FAUSTFLOAT 	fslider21;
	FAUSTFLOAT 	fslider22;
	double 	fRec28[2];
	FAUSTFLOAT 	fcheckbox11;
	FAUSTFLOAT 	fslider23;
	FAUSTFLOAT 	fslider24;
	double 	fRec29[2];
	FAUSTFLOAT 	fcheckbox12;
	FAUSTFLOAT 	fslider25;
	FAUSTFLOAT 	fslider26;
	double 	fRec30[2];
	FAUSTFLOAT 	fcheckbox13;
	FAUSTFLOAT 	fslider27;
	FAUSTFLOAT 	fslider28;
	double 	fRec31[2];
	FAUSTFLOAT 	fcheckbox14;
	FAUSTFLOAT 	fslider29;
	FAUSTFLOAT 	fslider30;
	double 	fRec32[2];
	FAUSTFLOAT 	fcheckbox15;
	FAUSTFLOAT 	fslider31;
	FAUSTFLOAT 	fslider32;
	double 	fRec33[2];
	FAUSTFLOAT 	fslider33;
	double 	fRec34[2];
	int 	IOTA;
	double 	fVec1[1048576];
	double 	fConst4;
	FAUSTFLOAT 	fslider34;
	FAUSTFLOAT 	fslider35;
	int 	iRec35[2];
	double 	fVec2[2];
	int 	iRec36[2];
	double 	fVec3[262144];
	double 	fConst5;
	FAUSTFLOAT 	fslider36;
	FAUSTFLOAT 	fslider37;
	FAUSTFLOAT 	fslider38;
	double 	fVec4[2];
	double 	fConst6;
	double 	fRec38[2];
	double 	fRec39[2];
	double 	fRec37[2];
	double 	fVec5[2];
	double 	fRec40[2];
	double 	fVec6[2];
	double 	fRec41[2];
	double 	fVec7[2];
	double 	fRec42[2];
	double 	fVec8[2];
	double 	fRec43[2];
	double 	fRec0[2];
	FAUSTFLOAT 	fcheckbox16;
	FAUSTFLOAT 	fcheckbox17;
	FAUSTFLOAT 	fcheckbox18;
	FAUSTFLOAT 	fcheckbox19;
	FAUSTFLOAT 	fcheckbox20;
	FAUSTFLOAT 	fcheckbox21;
	FAUSTFLOAT 	fcheckbox22;
	FAUSTFLOAT 	fcheckbox23;
	FAUSTFLOAT 	fcheckbox24;
	FAUSTFLOAT 	fcheckbox25;
	FAUSTFLOAT 	fcheckbox26;
	FAUSTFLOAT 	fcheckbox27;
	FAUSTFLOAT 	fcheckbox28;
	FAUSTFLOAT 	fcheckbox29;
	FAUSTFLOAT 	fcheckbox30;
	FAUSTFLOAT 	fcheckbox31;
	FAUSTFLOAT 	fslider39;
	double 	fRec44[2];
	double 	fVec9[1048576];
	FAUSTFLOAT 	fslider40;
	int 	iRec45[2];
	int 	iRec46[2];
	double 	fVec10[262144];
	FAUSTFLOAT 	fslider41;
	double 	fRec47[2];
	double 	fVec11[2];
	double 	fRec48[2];
	double 	fVec12[2];
	double 	fRec49[2];
	double 	fVec13[2];
	double 	fRec50[2];
	double 	fVec14[2];
	double 	fRec51[2];
	double 	fRec1[2];
	FAUSTFLOAT 	fcheckbox32;
	FAUSTFLOAT 	fcheckbox33;
	FAUSTFLOAT 	fcheckbox34;
	FAUSTFLOAT 	fcheckbox35;
	FAUSTFLOAT 	fcheckbox36;
	FAUSTFLOAT 	fcheckbox37;
	FAUSTFLOAT 	fcheckbox38;
	FAUSTFLOAT 	fcheckbox39;
	FAUSTFLOAT 	fcheckbox40;
	FAUSTFLOAT 	fcheckbox41;
	FAUSTFLOAT 	fcheckbox42;
	FAUSTFLOAT 	fcheckbox43;
	FAUSTFLOAT 	fcheckbox44;
	FAUSTFLOAT 	fcheckbox45;
	FAUSTFLOAT 	fcheckbox46;
	FAUSTFLOAT 	fcheckbox47;
	FAUSTFLOAT 	fslider42;
	double 	fRec52[2];
	double 	fVec15[1048576];
	FAUSTFLOAT 	fslider43;
	int 	iRec53[2];
	int 	iRec54[2];
	double 	fVec16[262144];
	FAUSTFLOAT 	fslider44;
	double 	fRec55[2];
	double 	fVec17[2];
	double 	fRec56[2];
	double 	fVec18[2];
	double 	fRec57[2];
	double 	fVec19[2];
	double 	fRec58[2];
	double 	fVec20[2];
	double 	fRec59[2];
	double 	fRec2[2];
	FAUSTFLOAT 	fcheckbox48;
	FAUSTFLOAT 	fcheckbox49;
	FAUSTFLOAT 	fcheckbox50;
	FAUSTFLOAT 	fcheckbox51;
	FAUSTFLOAT 	fcheckbox52;
	FAUSTFLOAT 	fcheckbox53;
	FAUSTFLOAT 	fcheckbox54;
	FAUSTFLOAT 	fcheckbox55;
	FAUSTFLOAT 	fcheckbox56;
	FAUSTFLOAT 	fcheckbox57;
	FAUSTFLOAT 	fcheckbox58;
	FAUSTFLOAT 	fcheckbox59;
	FAUSTFLOAT 	fcheckbox60;
	FAUSTFLOAT 	fcheckbox61;
	FAUSTFLOAT 	fcheckbox62;
	FAUSTFLOAT 	fcheckbox63;
	FAUSTFLOAT 	fslider45;
	double 	fRec60[2];
	double 	fVec21[1048576];
	FAUSTFLOAT 	fslider46;
	int 	iRec61[2];
	int 	iRec62[2];
	double 	fVec22[262144];
	FAUSTFLOAT 	fslider47;
	double 	fRec63[2];
	double 	fVec23[2];
	double 	fRec64[2];
	double 	fVec24[2];
	double 	fRec65[2];
	double 	fVec25[2];
	double 	fRec66[2];
	double 	fVec26[2];
	double 	fRec67[2];
	double 	fRec3[2];
	FAUSTFLOAT 	fcheckbox64;
	FAUSTFLOAT 	fcheckbox65;
	FAUSTFLOAT 	fcheckbox66;
	FAUSTFLOAT 	fcheckbox67;
	FAUSTFLOAT 	fcheckbox68;
	FAUSTFLOAT 	fcheckbox69;
	FAUSTFLOAT 	fcheckbox70;
	FAUSTFLOAT 	fcheckbox71;
	FAUSTFLOAT 	fcheckbox72;
	FAUSTFLOAT 	fcheckbox73;
	FAUSTFLOAT 	fcheckbox74;
	FAUSTFLOAT 	fcheckbox75;
	FAUSTFLOAT 	fcheckbox76;
	FAUSTFLOAT 	fcheckbox77;
	FAUSTFLOAT 	fcheckbox78;
	FAUSTFLOAT 	fcheckbox79;
	FAUSTFLOAT 	fslider48;
	double 	fRec68[2];
	double 	fVec27[1048576];
	FAUSTFLOAT 	fslider49;
	int 	iRec69[2];
	int 	iRec70[2];
	double 	fVec28[262144];
	FAUSTFLOAT 	fslider50;
	double 	fRec71[2];
	double 	fVec29[2];
	double 	fRec72[2];
	double 	fVec30[2];
	double 	fRec73[2];
	double 	fVec31[2];
	double 	fRec74[2];
	double 	fVec32[2];
	double 	fRec75[2];
	double 	fRec4[2];
	FAUSTFLOAT 	fcheckbox80;
	FAUSTFLOAT 	fcheckbox81;
	FAUSTFLOAT 	fcheckbox82;
	FAUSTFLOAT 	fcheckbox83;
	FAUSTFLOAT 	fcheckbox84;
	FAUSTFLOAT 	fcheckbox85;
	FAUSTFLOAT 	fcheckbox86;
	FAUSTFLOAT 	fcheckbox87;
	FAUSTFLOAT 	fcheckbox88;
	FAUSTFLOAT 	fcheckbox89;
	FAUSTFLOAT 	fcheckbox90;
	FAUSTFLOAT 	fcheckbox91;
	FAUSTFLOAT 	fcheckbox92;
	FAUSTFLOAT 	fcheckbox93;
	FAUSTFLOAT 	fcheckbox94;
	FAUSTFLOAT 	fcheckbox95;
	FAUSTFLOAT 	fslider51;
	double 	fRec76[2];
	double 	fVec33[1048576];
	FAUSTFLOAT 	fslider52;
	int 	iRec77[2];
	int 	iRec78[2];
	double 	fVec34[262144];
	FAUSTFLOAT 	fslider53;
	double 	fRec79[2];
	double 	fVec35[2];
	double 	fRec80[2];
	double 	fVec36[2];
	double 	fRec81[2];
	double 	fVec37[2];
	double 	fRec82[2];
	double 	fVec38[2];
	double 	fRec83[2];
	double 	fRec5[2];
	FAUSTFLOAT 	fcheckbox96;
	FAUSTFLOAT 	fcheckbox97;
	FAUSTFLOAT 	fcheckbox98;
	FAUSTFLOAT 	fcheckbox99;
	FAUSTFLOAT 	fcheckbox100;
	FAUSTFLOAT 	fcheckbox101;
	FAUSTFLOAT 	fcheckbox102;
	FAUSTFLOAT 	fcheckbox103;
	FAUSTFLOAT 	fcheckbox104;
	FAUSTFLOAT 	fcheckbox105;
	FAUSTFLOAT 	fcheckbox106;
	FAUSTFLOAT 	fcheckbox107;
	FAUSTFLOAT 	fcheckbox108;
	FAUSTFLOAT 	fcheckbox109;
	FAUSTFLOAT 	fcheckbox110;
	FAUSTFLOAT 	fcheckbox111;
	FAUSTFLOAT 	fslider54;
	double 	fRec84[2];
	double 	fVec39[1048576];
	FAUSTFLOAT 	fslider55;
	int 	iRec85[2];
	int 	iRec86[2];
	double 	fVec40[262144];
	FAUSTFLOAT 	fslider56;
	double 	fRec87[2];
	double 	fVec41[2];
	double 	fRec88[2];
	double 	fVec42[2];
	double 	fRec89[2];
	double 	fVec43[2];
	double 	fRec90[2];
	double 	fVec44[2];
	double 	fRec91[2];
	double 	fRec6[2];
	FAUSTFLOAT 	fcheckbox112;
	FAUSTFLOAT 	fcheckbox113;
	FAUSTFLOAT 	fcheckbox114;
	FAUSTFLOAT 	fcheckbox115;
	FAUSTFLOAT 	fcheckbox116;
	FAUSTFLOAT 	fcheckbox117;
	FAUSTFLOAT 	fcheckbox118;
	FAUSTFLOAT 	fcheckbox119;
	FAUSTFLOAT 	fcheckbox120;
	FAUSTFLOAT 	fcheckbox121;
	FAUSTFLOAT 	fcheckbox122;
	FAUSTFLOAT 	fcheckbox123;
	FAUSTFLOAT 	fcheckbox124;
	FAUSTFLOAT 	fcheckbox125;
	FAUSTFLOAT 	fcheckbox126;
	FAUSTFLOAT 	fcheckbox127;
	FAUSTFLOAT 	fslider57;
	double 	fRec92[2];
	double 	fVec45[1048576];
	FAUSTFLOAT 	fslider58;
	int 	iRec93[2];
	int 	iRec94[2];
	double 	fVec46[262144];
	FAUSTFLOAT 	fslider59;
	double 	fRec95[2];
	double 	fVec47[2];
	double 	fRec96[2];
	double 	fVec48[2];
	double 	fRec97[2];
	double 	fVec49[2];
	double 	fRec98[2];
	double 	fVec50[2];
	double 	fRec99[2];
	double 	fRec7[2];
	FAUSTFLOAT 	fslider60;
	double 	fRec100[2];
	double 	fVec51[2];
	double 	fRec101[2];
	FAUSTFLOAT 	fcheckbox128;
	FAUSTFLOAT 	fcheckbox129;
	FAUSTFLOAT 	fcheckbox130;
	FAUSTFLOAT 	fcheckbox131;
	FAUSTFLOAT 	fcheckbox132;
	FAUSTFLOAT 	fcheckbox133;
	FAUSTFLOAT 	fcheckbox134;
	FAUSTFLOAT 	fcheckbox135;
	FAUSTFLOAT 	fcheckbox136;
	FAUSTFLOAT 	fcheckbox137;
	FAUSTFLOAT 	fcheckbox138;
	FAUSTFLOAT 	fcheckbox139;
	FAUSTFLOAT 	fcheckbox140;
	FAUSTFLOAT 	fcheckbox141;
	FAUSTFLOAT 	fcheckbox142;
	FAUSTFLOAT 	fcheckbox143;
	FAUSTFLOAT 	fslider61;
	double 	fRec102[2];
	double 	fVec52[1048576];
	FAUSTFLOAT 	fslider62;
	int 	iRec103[2];
	int 	iRec104[2];
	double 	fVec53[262144];
	double 	fVec54[2];
	double 	fRec105[2];
	double 	fVec55[2];
	double 	fRec106[2];
	double 	fVec56[2];
	double 	fRec107[2];
	double 	fRec8[2];
	FAUSTFLOAT 	fcheckbox144;
	FAUSTFLOAT 	fcheckbox145;
	FAUSTFLOAT 	fcheckbox146;
	FAUSTFLOAT 	fcheckbox147;
	FAUSTFLOAT 	fcheckbox148;
	FAUSTFLOAT 	fcheckbox149;
	FAUSTFLOAT 	fcheckbox150;
	FAUSTFLOAT 	fcheckbox151;
	FAUSTFLOAT 	fcheckbox152;
	FAUSTFLOAT 	fcheckbox153;
	FAUSTFLOAT 	fcheckbox154;
	FAUSTFLOAT 	fcheckbox155;
	FAUSTFLOAT 	fcheckbox156;
	FAUSTFLOAT 	fcheckbox157;
	FAUSTFLOAT 	fcheckbox158;
	FAUSTFLOAT 	fcheckbox159;
	FAUSTFLOAT 	fslider63;
	double 	fRec108[2];
	double 	fVec57[1048576];
	FAUSTFLOAT 	fslider64;
	int 	iRec109[2];
	int 	iRec110[2];
	double 	fVec58[262144];
	FAUSTFLOAT 	fslider65;
	double 	fRec111[2];
	double 	fVec59[2];
	double 	fRec112[2];
	double 	fVec60[2];
	double 	fRec113[2];
	double 	fVec61[2];
	double 	fRec114[2];
	double 	fVec62[2];
	double 	fRec115[2];
	double 	fRec9[2];
	FAUSTFLOAT 	fcheckbox160;
	FAUSTFLOAT 	fcheckbox161;
	FAUSTFLOAT 	fcheckbox162;
	FAUSTFLOAT 	fcheckbox163;
	FAUSTFLOAT 	fcheckbox164;
	FAUSTFLOAT 	fcheckbox165;
	FAUSTFLOAT 	fcheckbox166;
	FAUSTFLOAT 	fcheckbox167;
	FAUSTFLOAT 	fcheckbox168;
	FAUSTFLOAT 	fcheckbox169;
	FAUSTFLOAT 	fcheckbox170;
	FAUSTFLOAT 	fcheckbox171;
	FAUSTFLOAT 	fcheckbox172;
	FAUSTFLOAT 	fcheckbox173;
	FAUSTFLOAT 	fcheckbox174;
	FAUSTFLOAT 	fcheckbox175;
	FAUSTFLOAT 	fslider66;
	double 	fRec116[2];
	double 	fVec63[1048576];
	FAUSTFLOAT 	fslider67;
	int 	iRec117[2];
	int 	iRec118[2];
	double 	fVec64[262144];
	FAUSTFLOAT 	fslider68;
	double 	fRec119[2];
	double 	fVec65[2];
	double 	fRec120[2];
	double 	fVec66[2];
	double 	fRec121[2];
	double 	fVec67[2];
	double 	fRec122[2];
	double 	fVec68[2];
	double 	fRec123[2];
	double 	fRec10[2];
	FAUSTFLOAT 	fcheckbox176;
	FAUSTFLOAT 	fcheckbox177;
	FAUSTFLOAT 	fcheckbox178;
	FAUSTFLOAT 	fcheckbox179;
	FAUSTFLOAT 	fcheckbox180;
	FAUSTFLOAT 	fcheckbox181;
	FAUSTFLOAT 	fcheckbox182;
	FAUSTFLOAT 	fcheckbox183;
	FAUSTFLOAT 	fcheckbox184;
	FAUSTFLOAT 	fcheckbox185;
	FAUSTFLOAT 	fcheckbox186;
	FAUSTFLOAT 	fcheckbox187;
	FAUSTFLOAT 	fcheckbox188;
	FAUSTFLOAT 	fcheckbox189;
	FAUSTFLOAT 	fcheckbox190;
	FAUSTFLOAT 	fcheckbox191;
	FAUSTFLOAT 	fslider69;
	double 	fRec124[2];
	double 	fVec69[1048576];
	FAUSTFLOAT 	fslider70;
	int 	iRec125[2];
	int 	iRec126[2];
	double 	fVec70[262144];
	FAUSTFLOAT 	fslider71;
	double 	fRec127[2];
	double 	fVec71[2];
	double 	fRec128[2];
	double 	fVec72[2];
	double 	fRec129[2];
	double 	fVec73[2];
	double 	fRec130[2];
	double 	fVec74[2];
	double 	fRec131[2];
	double 	fRec11[2];
	FAUSTFLOAT 	fcheckbox192;
	FAUSTFLOAT 	fcheckbox193;
	FAUSTFLOAT 	fcheckbox194;
	FAUSTFLOAT 	fcheckbox195;
	FAUSTFLOAT 	fcheckbox196;
	FAUSTFLOAT 	fcheckbox197;
	FAUSTFLOAT 	fcheckbox198;
	FAUSTFLOAT 	fcheckbox199;
	FAUSTFLOAT 	fcheckbox200;
	FAUSTFLOAT 	fcheckbox201;
	FAUSTFLOAT 	fcheckbox202;
	FAUSTFLOAT 	fcheckbox203;
	FAUSTFLOAT 	fcheckbox204;
	FAUSTFLOAT 	fcheckbox205;
	FAUSTFLOAT 	fcheckbox206;
	FAUSTFLOAT 	fcheckbox207;
	FAUSTFLOAT 	fslider72;
	double 	fRec132[2];
	double 	fVec75[1048576];
	FAUSTFLOAT 	fslider73;
	int 	iRec133[2];
	int 	iRec134[2];
	double 	fVec76[262144];
	FAUSTFLOAT 	fslider74;
	double 	fRec135[2];
	double 	fVec77[2];
	double 	fRec136[2];
	double 	fVec78[2];
	double 	fRec137[2];
	double 	fVec79[2];
	double 	fRec138[2];
	double 	fVec80[2];
	double 	fRec139[2];
	double 	fRec12[2];
	FAUSTFLOAT 	fcheckbox208;
	FAUSTFLOAT 	fcheckbox209;
	FAUSTFLOAT 	fcheckbox210;
	FAUSTFLOAT 	fcheckbox211;
	FAUSTFLOAT 	fcheckbox212;
	FAUSTFLOAT 	fcheckbox213;
	FAUSTFLOAT 	fcheckbox214;
	FAUSTFLOAT 	fcheckbox215;
	FAUSTFLOAT 	fcheckbox216;
	FAUSTFLOAT 	fcheckbox217;
	FAUSTFLOAT 	fcheckbox218;
	FAUSTFLOAT 	fcheckbox219;
	FAUSTFLOAT 	fcheckbox220;
	FAUSTFLOAT 	fcheckbox221;
	FAUSTFLOAT 	fcheckbox222;
	FAUSTFLOAT 	fcheckbox223;
	FAUSTFLOAT 	fslider75;
	double 	fRec140[2];
	double 	fVec81[1048576];
	FAUSTFLOAT 	fslider76;
	int 	iRec141[2];
	int 	iRec142[2];
	double 	fVec82[262144];
	FAUSTFLOAT 	fslider77;
	double 	fRec143[2];
	double 	fVec83[2];
	double 	fRec144[2];
	double 	fVec84[2];
	double 	fRec145[2];
	double 	fVec85[2];
	double 	fRec146[2];
	double 	fVec86[2];
	double 	fRec147[2];
	double 	fRec13[2];
	FAUSTFLOAT 	fcheckbox224;
	FAUSTFLOAT 	fcheckbox225;
	FAUSTFLOAT 	fcheckbox226;
	FAUSTFLOAT 	fcheckbox227;
	FAUSTFLOAT 	fcheckbox228;
	FAUSTFLOAT 	fcheckbox229;
	FAUSTFLOAT 	fcheckbox230;
	FAUSTFLOAT 	fcheckbox231;
	FAUSTFLOAT 	fcheckbox232;
	FAUSTFLOAT 	fcheckbox233;
	FAUSTFLOAT 	fcheckbox234;
	FAUSTFLOAT 	fcheckbox235;
	FAUSTFLOAT 	fcheckbox236;
	FAUSTFLOAT 	fcheckbox237;
	FAUSTFLOAT 	fcheckbox238;
	FAUSTFLOAT 	fcheckbox239;
	FAUSTFLOAT 	fslider78;
	double 	fRec148[2];
	double 	fVec87[1048576];
	FAUSTFLOAT 	fslider79;
	int 	iRec149[2];
	int 	iRec150[2];
	double 	fVec88[262144];
	FAUSTFLOAT 	fslider80;
	double 	fRec151[2];
	double 	fVec89[2];
	double 	fRec152[2];
	double 	fVec90[2];
	double 	fRec153[2];
	double 	fVec91[2];
	double 	fRec154[2];
	double 	fVec92[2];
	double 	fRec155[2];
	double 	fRec14[2];
	FAUSTFLOAT 	fslider81;
	double 	fRec156[2];
	FAUSTFLOAT 	fcheckbox240;
	FAUSTFLOAT 	fcheckbox241;
	FAUSTFLOAT 	fcheckbox242;
	FAUSTFLOAT 	fcheckbox243;
	FAUSTFLOAT 	fcheckbox244;
	FAUSTFLOAT 	fcheckbox245;
	FAUSTFLOAT 	fcheckbox246;
	FAUSTFLOAT 	fcheckbox247;
	FAUSTFLOAT 	fcheckbox248;
	FAUSTFLOAT 	fcheckbox249;
	FAUSTFLOAT 	fcheckbox250;
	FAUSTFLOAT 	fcheckbox251;
	FAUSTFLOAT 	fcheckbox252;
	FAUSTFLOAT 	fcheckbox253;
	FAUSTFLOAT 	fcheckbox254;
	FAUSTFLOAT 	fcheckbox255;
	double 	fVec93[1048576];
	FAUSTFLOAT 	fslider82;
	int 	iRec157[2];
	int 	iRec158[2];
	double 	fVec94[262144];
	FAUSTFLOAT 	fslider83;
	double 	fRec159[2];
	double 	fVec95[2];
	double 	fRec160[2];
	double 	fVec96[2];
	double 	fRec161[2];
	double 	fVec97[2];
	double 	fRec162[2];
	double 	fVec98[2];
	double 	fRec163[2];
	double 	fRec15[2];
	FAUSTFLOAT 	fslider84;
	double 	fRec164[2];
	FAUSTFLOAT 	fslider85;
	double 	fRec165[2];
	FAUSTFLOAT 	fslider86;
	double 	fRec166[2];
	FAUSTFLOAT 	fslider87;
	double 	fRec167[2];
	FAUSTFLOAT 	fslider88;
	double 	fRec168[2];
	FAUSTFLOAT 	fslider89;
	double 	fRec169[2];
	FAUSTFLOAT 	fslider90;
	double 	fRec170[2];
	FAUSTFLOAT 	fslider91;
	double 	fRec171[2];
	FAUSTFLOAT 	fslider92;
	double 	fRec172[2];
	FAUSTFLOAT 	fslider93;
	double 	fRec173[2];
	FAUSTFLOAT 	fslider94;
	double 	fRec174[2];
	FAUSTFLOAT 	fslider95;
	double 	fRec175[2];
	FAUSTFLOAT 	fslider96;
	double 	fRec176[2];
	FAUSTFLOAT 	fslider97;
	double 	fRec177[2];
	FAUSTFLOAT 	fslider98;
	double 	fRec178[2];
	FAUSTFLOAT 	fslider99;
	double 	fRec179[2];
	int fSamplingFreq;

  public:
	virtual void metadata(Meta* m) { 
		m->declare("compilation_options", "-single -scal");
		m->declare("library_path", "mTDelHarmo16");
		m->declare("basics_lib_name", "Faust Basic Element Library");
		m->declare("basics_lib_version", "0.0");
		m->declare("delays_lib_name", "Faust Delay Library");
		m->declare("delays_lib_version", "0.0");
		m->declare("maths_lib_author", "GRAME");
		m->declare("maths_lib_copyright", "GRAME");
		m->declare("maths_lib_license", "LGPL with exception");
		m->declare("maths_lib_name", "Faust Math Library");
		m->declare("maths_lib_version", "2.0");
		m->declare("name", "mTDelHarmo16");
		m->declare("oscillators_lib_name", "Faust Oscillator Library");
		m->declare("oscillators_lib_version", "0.0");
		m->declare("signals_lib_name", "Faust Signal Routing Library");
		m->declare("signals_lib_version", "0.0");
	}

	virtual int getNumInputs() { return 16; }
	virtual int getNumOutputs() { return 16; }
	static void classInit(int samplingFreq) {
		SIG0 sig0;
		sig0.init(samplingFreq);
		sig0.fill(65536,ftbl0);
	}
	virtual void instanceConstants(int samplingFreq) {
		fSamplingFreq = samplingFreq;
		fConst0 = min(1.92e+05, max(1.0, (double)fSamplingFreq));
		fConst1 = double(fConst0);
		fConst2 = (double(30) / fConst1);
		fConst3 = (1e+03 / fConst0);
		fConst4 = (0.001 * fConst0);
		fConst5 = (1.0 / fConst1);
		fConst6 = (0.03 * fConst0);
	}
	virtual void instanceResetUserInterface() {
		fslider0 = 1.0;
		fcheckbox0 = 0.0;
		fslider1 = 0.0;
		fslider2 = 2e+01;
		fcheckbox1 = 0.0;
		fslider3 = 1.0;
		fslider4 = 0.0;
		fcheckbox2 = 0.0;
		fslider5 = 1.0;
		fslider6 = 0.0;
		fcheckbox3 = 0.0;
		fslider7 = 1.0;
		fslider8 = 0.0;
		fcheckbox4 = 0.0;
		fslider9 = 1.0;
		fslider10 = 0.0;
		fcheckbox5 = 0.0;
		fslider11 = 1.0;
		fslider12 = 0.0;
		fcheckbox6 = 0.0;
		fslider13 = 1.0;
		fslider14 = 0.0;
		fcheckbox7 = 0.0;
		fslider15 = 1.0;
		fslider16 = 0.0;
		fcheckbox8 = 0.0;
		fslider17 = 1.0;
		fslider18 = 0.0;
		fcheckbox9 = 0.0;
		fslider19 = 1.0;
		fslider20 = 0.0;
		fcheckbox10 = 0.0;
		fslider21 = 1.0;
		fslider22 = 0.0;
		fcheckbox11 = 0.0;
		fslider23 = 1.0;
		fslider24 = 0.0;
		fcheckbox12 = 0.0;
		fslider25 = 1.0;
		fslider26 = 0.0;
		fcheckbox13 = 0.0;
		fslider27 = 1.0;
		fslider28 = 0.0;
		fcheckbox14 = 0.0;
		fslider29 = 1.0;
		fslider30 = 0.0;
		fcheckbox15 = 0.0;
		fslider31 = 1.0;
		fslider32 = 0.0;
		fslider33 = 1.0;
		fslider34 = 1e+02;
		fslider35 = 1.0;
		fslider36 = 0.0;
		fslider37 = 1.0;
		fslider38 = 64.0;
		fcheckbox16 = 0.0;
		fcheckbox17 = 0.0;
		fcheckbox18 = 0.0;
		fcheckbox19 = 0.0;
		fcheckbox20 = 0.0;
		fcheckbox21 = 0.0;
		fcheckbox22 = 0.0;
		fcheckbox23 = 0.0;
		fcheckbox24 = 0.0;
		fcheckbox25 = 0.0;
		fcheckbox26 = 0.0;
		fcheckbox27 = 0.0;
		fcheckbox28 = 0.0;
		fcheckbox29 = 0.0;
		fcheckbox30 = 0.0;
		fcheckbox31 = 0.0;
		fslider39 = 1.0;
		fslider40 = 2e+02;
		fslider41 = 0.0;
		fcheckbox32 = 0.0;
		fcheckbox33 = 0.0;
		fcheckbox34 = 0.0;
		fcheckbox35 = 0.0;
		fcheckbox36 = 0.0;
		fcheckbox37 = 0.0;
		fcheckbox38 = 0.0;
		fcheckbox39 = 0.0;
		fcheckbox40 = 0.0;
		fcheckbox41 = 0.0;
		fcheckbox42 = 0.0;
		fcheckbox43 = 0.0;
		fcheckbox44 = 0.0;
		fcheckbox45 = 0.0;
		fcheckbox46 = 0.0;
		fcheckbox47 = 0.0;
		fslider42 = 1.0;
		fslider43 = 3e+02;
		fslider44 = 0.0;
		fcheckbox48 = 0.0;
		fcheckbox49 = 0.0;
		fcheckbox50 = 0.0;
		fcheckbox51 = 0.0;
		fcheckbox52 = 0.0;
		fcheckbox53 = 0.0;
		fcheckbox54 = 0.0;
		fcheckbox55 = 0.0;
		fcheckbox56 = 0.0;
		fcheckbox57 = 0.0;
		fcheckbox58 = 0.0;
		fcheckbox59 = 0.0;
		fcheckbox60 = 0.0;
		fcheckbox61 = 0.0;
		fcheckbox62 = 0.0;
		fcheckbox63 = 0.0;
		fslider45 = 1.0;
		fslider46 = 4e+02;
		fslider47 = 0.0;
		fcheckbox64 = 0.0;
		fcheckbox65 = 0.0;
		fcheckbox66 = 0.0;
		fcheckbox67 = 0.0;
		fcheckbox68 = 0.0;
		fcheckbox69 = 0.0;
		fcheckbox70 = 0.0;
		fcheckbox71 = 0.0;
		fcheckbox72 = 0.0;
		fcheckbox73 = 0.0;
		fcheckbox74 = 0.0;
		fcheckbox75 = 0.0;
		fcheckbox76 = 0.0;
		fcheckbox77 = 0.0;
		fcheckbox78 = 0.0;
		fcheckbox79 = 0.0;
		fslider48 = 1.0;
		fslider49 = 5e+02;
		fslider50 = 0.0;
		fcheckbox80 = 0.0;
		fcheckbox81 = 0.0;
		fcheckbox82 = 0.0;
		fcheckbox83 = 0.0;
		fcheckbox84 = 0.0;
		fcheckbox85 = 0.0;
		fcheckbox86 = 0.0;
		fcheckbox87 = 0.0;
		fcheckbox88 = 0.0;
		fcheckbox89 = 0.0;
		fcheckbox90 = 0.0;
		fcheckbox91 = 0.0;
		fcheckbox92 = 0.0;
		fcheckbox93 = 0.0;
		fcheckbox94 = 0.0;
		fcheckbox95 = 0.0;
		fslider51 = 1.0;
		fslider52 = 6e+02;
		fslider53 = 0.0;
		fcheckbox96 = 0.0;
		fcheckbox97 = 0.0;
		fcheckbox98 = 0.0;
		fcheckbox99 = 0.0;
		fcheckbox100 = 0.0;
		fcheckbox101 = 0.0;
		fcheckbox102 = 0.0;
		fcheckbox103 = 0.0;
		fcheckbox104 = 0.0;
		fcheckbox105 = 0.0;
		fcheckbox106 = 0.0;
		fcheckbox107 = 0.0;
		fcheckbox108 = 0.0;
		fcheckbox109 = 0.0;
		fcheckbox110 = 0.0;
		fcheckbox111 = 0.0;
		fslider54 = 1.0;
		fslider55 = 7e+02;
		fslider56 = 0.0;
		fcheckbox112 = 0.0;
		fcheckbox113 = 0.0;
		fcheckbox114 = 0.0;
		fcheckbox115 = 0.0;
		fcheckbox116 = 0.0;
		fcheckbox117 = 0.0;
		fcheckbox118 = 0.0;
		fcheckbox119 = 0.0;
		fcheckbox120 = 0.0;
		fcheckbox121 = 0.0;
		fcheckbox122 = 0.0;
		fcheckbox123 = 0.0;
		fcheckbox124 = 0.0;
		fcheckbox125 = 0.0;
		fcheckbox126 = 0.0;
		fcheckbox127 = 0.0;
		fslider57 = 1.0;
		fslider58 = 8e+02;
		fslider59 = 0.0;
		fslider60 = 0.0;
		fcheckbox128 = 0.0;
		fcheckbox129 = 0.0;
		fcheckbox130 = 0.0;
		fcheckbox131 = 0.0;
		fcheckbox132 = 0.0;
		fcheckbox133 = 0.0;
		fcheckbox134 = 0.0;
		fcheckbox135 = 0.0;
		fcheckbox136 = 0.0;
		fcheckbox137 = 0.0;
		fcheckbox138 = 0.0;
		fcheckbox139 = 0.0;
		fcheckbox140 = 0.0;
		fcheckbox141 = 0.0;
		fcheckbox142 = 0.0;
		fcheckbox143 = 0.0;
		fslider61 = 1.0;
		fslider62 = 9e+02;
		fcheckbox144 = 0.0;
		fcheckbox145 = 0.0;
		fcheckbox146 = 0.0;
		fcheckbox147 = 0.0;
		fcheckbox148 = 0.0;
		fcheckbox149 = 0.0;
		fcheckbox150 = 0.0;
		fcheckbox151 = 0.0;
		fcheckbox152 = 0.0;
		fcheckbox153 = 0.0;
		fcheckbox154 = 0.0;
		fcheckbox155 = 0.0;
		fcheckbox156 = 0.0;
		fcheckbox157 = 0.0;
		fcheckbox158 = 0.0;
		fcheckbox159 = 0.0;
		fslider63 = 1.0;
		fslider64 = 1e+03;
		fslider65 = 0.0;
		fcheckbox160 = 0.0;
		fcheckbox161 = 0.0;
		fcheckbox162 = 0.0;
		fcheckbox163 = 0.0;
		fcheckbox164 = 0.0;
		fcheckbox165 = 0.0;
		fcheckbox166 = 0.0;
		fcheckbox167 = 0.0;
		fcheckbox168 = 0.0;
		fcheckbox169 = 0.0;
		fcheckbox170 = 0.0;
		fcheckbox171 = 0.0;
		fcheckbox172 = 0.0;
		fcheckbox173 = 0.0;
		fcheckbox174 = 0.0;
		fcheckbox175 = 0.0;
		fslider66 = 1.0;
		fslider67 = 1.1e+03;
		fslider68 = 0.0;
		fcheckbox176 = 0.0;
		fcheckbox177 = 0.0;
		fcheckbox178 = 0.0;
		fcheckbox179 = 0.0;
		fcheckbox180 = 0.0;
		fcheckbox181 = 0.0;
		fcheckbox182 = 0.0;
		fcheckbox183 = 0.0;
		fcheckbox184 = 0.0;
		fcheckbox185 = 0.0;
		fcheckbox186 = 0.0;
		fcheckbox187 = 0.0;
		fcheckbox188 = 0.0;
		fcheckbox189 = 0.0;
		fcheckbox190 = 0.0;
		fcheckbox191 = 0.0;
		fslider69 = 1.0;
		fslider70 = 1.2e+03;
		fslider71 = 0.0;
		fcheckbox192 = 0.0;
		fcheckbox193 = 0.0;
		fcheckbox194 = 0.0;
		fcheckbox195 = 0.0;
		fcheckbox196 = 0.0;
		fcheckbox197 = 0.0;
		fcheckbox198 = 0.0;
		fcheckbox199 = 0.0;
		fcheckbox200 = 0.0;
		fcheckbox201 = 0.0;
		fcheckbox202 = 0.0;
		fcheckbox203 = 0.0;
		fcheckbox204 = 0.0;
		fcheckbox205 = 0.0;
		fcheckbox206 = 0.0;
		fcheckbox207 = 0.0;
		fslider72 = 1.0;
		fslider73 = 1.3e+03;
		fslider74 = 0.0;
		fcheckbox208 = 0.0;
		fcheckbox209 = 0.0;
		fcheckbox210 = 0.0;
		fcheckbox211 = 0.0;
		fcheckbox212 = 0.0;
		fcheckbox213 = 0.0;
		fcheckbox214 = 0.0;
		fcheckbox215 = 0.0;
		fcheckbox216 = 0.0;
		fcheckbox217 = 0.0;
		fcheckbox218 = 0.0;
		fcheckbox219 = 0.0;
		fcheckbox220 = 0.0;
		fcheckbox221 = 0.0;
		fcheckbox222 = 0.0;
		fcheckbox223 = 0.0;
		fslider75 = 1.0;
		fslider76 = 1.4e+03;
		fslider77 = 0.0;
		fcheckbox224 = 0.0;
		fcheckbox225 = 0.0;
		fcheckbox226 = 0.0;
		fcheckbox227 = 0.0;
		fcheckbox228 = 0.0;
		fcheckbox229 = 0.0;
		fcheckbox230 = 0.0;
		fcheckbox231 = 0.0;
		fcheckbox232 = 0.0;
		fcheckbox233 = 0.0;
		fcheckbox234 = 0.0;
		fcheckbox235 = 0.0;
		fcheckbox236 = 0.0;
		fcheckbox237 = 0.0;
		fcheckbox238 = 0.0;
		fcheckbox239 = 0.0;
		fslider78 = 1.0;
		fslider79 = 1.5e+03;
		fslider80 = 0.0;
		fslider81 = 1.0;
		fcheckbox240 = 0.0;
		fcheckbox241 = 0.0;
		fcheckbox242 = 0.0;
		fcheckbox243 = 0.0;
		fcheckbox244 = 0.0;
		fcheckbox245 = 0.0;
		fcheckbox246 = 0.0;
		fcheckbox247 = 0.0;
		fcheckbox248 = 0.0;
		fcheckbox249 = 0.0;
		fcheckbox250 = 0.0;
		fcheckbox251 = 0.0;
		fcheckbox252 = 0.0;
		fcheckbox253 = 0.0;
		fcheckbox254 = 0.0;
		fcheckbox255 = 0.0;
		fslider82 = 1.6e+03;
		fslider83 = 0.0;
		fslider84 = 1.0;
		fslider85 = 1.0;
		fslider86 = 1.0;
		fslider87 = 1.0;
		fslider88 = 1.0;
		fslider89 = 1.0;
		fslider90 = 1.0;
		fslider91 = 1.0;
		fslider92 = 1.0;
		fslider93 = 1.0;
		fslider94 = 1.0;
		fslider95 = 1.0;
		fslider96 = 1.0;
		fslider97 = 1.0;
		fslider98 = 1.0;
		fslider99 = 1.0;
	}
	virtual void instanceClear() {
		for (int i=0; i<2; i++) fRec17[i] = 0;
		for (int i=0; i<2; i++) fVec0[i] = 0;
		for (int i=0; i<2; i++) fRec18[i] = 0;
		for (int i=0; i<2; i++) fRec19[i] = 0;
		for (int i=0; i<2; i++) fRec20[i] = 0;
		for (int i=0; i<2; i++) fRec21[i] = 0;
		for (int i=0; i<2; i++) fRec22[i] = 0;
		for (int i=0; i<2; i++) fRec23[i] = 0;
		for (int i=0; i<2; i++) fRec24[i] = 0;
		for (int i=0; i<2; i++) fRec25[i] = 0;
		for (int i=0; i<2; i++) fRec26[i] = 0;
		for (int i=0; i<2; i++) fRec27[i] = 0;
		for (int i=0; i<2; i++) fRec28[i] = 0;
		for (int i=0; i<2; i++) fRec29[i] = 0;
		for (int i=0; i<2; i++) fRec30[i] = 0;
		for (int i=0; i<2; i++) fRec31[i] = 0;
		for (int i=0; i<2; i++) fRec32[i] = 0;
		for (int i=0; i<2; i++) fRec33[i] = 0;
		for (int i=0; i<2; i++) fRec34[i] = 0;
		IOTA = 0;
		for (int i=0; i<1048576; i++) fVec1[i] = 0;
		for (int i=0; i<2; i++) iRec35[i] = 0;
		for (int i=0; i<2; i++) fVec2[i] = 0;
		for (int i=0; i<2; i++) iRec36[i] = 0;
		for (int i=0; i<262144; i++) fVec3[i] = 0;
		for (int i=0; i<2; i++) fVec4[i] = 0;
		for (int i=0; i<2; i++) fRec38[i] = 0;
		for (int i=0; i<2; i++) fRec39[i] = 0;
		for (int i=0; i<2; i++) fRec37[i] = 0;
		for (int i=0; i<2; i++) fVec5[i] = 0;
		for (int i=0; i<2; i++) fRec40[i] = 0;
		for (int i=0; i<2; i++) fVec6[i] = 0;
		for (int i=0; i<2; i++) fRec41[i] = 0;
		for (int i=0; i<2; i++) fVec7[i] = 0;
		for (int i=0; i<2; i++) fRec42[i] = 0;
		for (int i=0; i<2; i++) fVec8[i] = 0;
		for (int i=0; i<2; i++) fRec43[i] = 0;
		for (int i=0; i<2; i++) fRec0[i] = 0;
		for (int i=0; i<2; i++) fRec44[i] = 0;
		for (int i=0; i<1048576; i++) fVec9[i] = 0;
		for (int i=0; i<2; i++) iRec45[i] = 0;
		for (int i=0; i<2; i++) iRec46[i] = 0;
		for (int i=0; i<262144; i++) fVec10[i] = 0;
		for (int i=0; i<2; i++) fRec47[i] = 0;
		for (int i=0; i<2; i++) fVec11[i] = 0;
		for (int i=0; i<2; i++) fRec48[i] = 0;
		for (int i=0; i<2; i++) fVec12[i] = 0;
		for (int i=0; i<2; i++) fRec49[i] = 0;
		for (int i=0; i<2; i++) fVec13[i] = 0;
		for (int i=0; i<2; i++) fRec50[i] = 0;
		for (int i=0; i<2; i++) fVec14[i] = 0;
		for (int i=0; i<2; i++) fRec51[i] = 0;
		for (int i=0; i<2; i++) fRec1[i] = 0;
		for (int i=0; i<2; i++) fRec52[i] = 0;
		for (int i=0; i<1048576; i++) fVec15[i] = 0;
		for (int i=0; i<2; i++) iRec53[i] = 0;
		for (int i=0; i<2; i++) iRec54[i] = 0;
		for (int i=0; i<262144; i++) fVec16[i] = 0;
		for (int i=0; i<2; i++) fRec55[i] = 0;
		for (int i=0; i<2; i++) fVec17[i] = 0;
		for (int i=0; i<2; i++) fRec56[i] = 0;
		for (int i=0; i<2; i++) fVec18[i] = 0;
		for (int i=0; i<2; i++) fRec57[i] = 0;
		for (int i=0; i<2; i++) fVec19[i] = 0;
		for (int i=0; i<2; i++) fRec58[i] = 0;
		for (int i=0; i<2; i++) fVec20[i] = 0;
		for (int i=0; i<2; i++) fRec59[i] = 0;
		for (int i=0; i<2; i++) fRec2[i] = 0;
		for (int i=0; i<2; i++) fRec60[i] = 0;
		for (int i=0; i<1048576; i++) fVec21[i] = 0;
		for (int i=0; i<2; i++) iRec61[i] = 0;
		for (int i=0; i<2; i++) iRec62[i] = 0;
		for (int i=0; i<262144; i++) fVec22[i] = 0;
		for (int i=0; i<2; i++) fRec63[i] = 0;
		for (int i=0; i<2; i++) fVec23[i] = 0;
		for (int i=0; i<2; i++) fRec64[i] = 0;
		for (int i=0; i<2; i++) fVec24[i] = 0;
		for (int i=0; i<2; i++) fRec65[i] = 0;
		for (int i=0; i<2; i++) fVec25[i] = 0;
		for (int i=0; i<2; i++) fRec66[i] = 0;
		for (int i=0; i<2; i++) fVec26[i] = 0;
		for (int i=0; i<2; i++) fRec67[i] = 0;
		for (int i=0; i<2; i++) fRec3[i] = 0;
		for (int i=0; i<2; i++) fRec68[i] = 0;
		for (int i=0; i<1048576; i++) fVec27[i] = 0;
		for (int i=0; i<2; i++) iRec69[i] = 0;
		for (int i=0; i<2; i++) iRec70[i] = 0;
		for (int i=0; i<262144; i++) fVec28[i] = 0;
		for (int i=0; i<2; i++) fRec71[i] = 0;
		for (int i=0; i<2; i++) fVec29[i] = 0;
		for (int i=0; i<2; i++) fRec72[i] = 0;
		for (int i=0; i<2; i++) fVec30[i] = 0;
		for (int i=0; i<2; i++) fRec73[i] = 0;
		for (int i=0; i<2; i++) fVec31[i] = 0;
		for (int i=0; i<2; i++) fRec74[i] = 0;
		for (int i=0; i<2; i++) fVec32[i] = 0;
		for (int i=0; i<2; i++) fRec75[i] = 0;
		for (int i=0; i<2; i++) fRec4[i] = 0;
		for (int i=0; i<2; i++) fRec76[i] = 0;
		for (int i=0; i<1048576; i++) fVec33[i] = 0;
		for (int i=0; i<2; i++) iRec77[i] = 0;
		for (int i=0; i<2; i++) iRec78[i] = 0;
		for (int i=0; i<262144; i++) fVec34[i] = 0;
		for (int i=0; i<2; i++) fRec79[i] = 0;
		for (int i=0; i<2; i++) fVec35[i] = 0;
		for (int i=0; i<2; i++) fRec80[i] = 0;
		for (int i=0; i<2; i++) fVec36[i] = 0;
		for (int i=0; i<2; i++) fRec81[i] = 0;
		for (int i=0; i<2; i++) fVec37[i] = 0;
		for (int i=0; i<2; i++) fRec82[i] = 0;
		for (int i=0; i<2; i++) fVec38[i] = 0;
		for (int i=0; i<2; i++) fRec83[i] = 0;
		for (int i=0; i<2; i++) fRec5[i] = 0;
		for (int i=0; i<2; i++) fRec84[i] = 0;
		for (int i=0; i<1048576; i++) fVec39[i] = 0;
		for (int i=0; i<2; i++) iRec85[i] = 0;
		for (int i=0; i<2; i++) iRec86[i] = 0;
		for (int i=0; i<262144; i++) fVec40[i] = 0;
		for (int i=0; i<2; i++) fRec87[i] = 0;
		for (int i=0; i<2; i++) fVec41[i] = 0;
		for (int i=0; i<2; i++) fRec88[i] = 0;
		for (int i=0; i<2; i++) fVec42[i] = 0;
		for (int i=0; i<2; i++) fRec89[i] = 0;
		for (int i=0; i<2; i++) fVec43[i] = 0;
		for (int i=0; i<2; i++) fRec90[i] = 0;
		for (int i=0; i<2; i++) fVec44[i] = 0;
		for (int i=0; i<2; i++) fRec91[i] = 0;
		for (int i=0; i<2; i++) fRec6[i] = 0;
		for (int i=0; i<2; i++) fRec92[i] = 0;
		for (int i=0; i<1048576; i++) fVec45[i] = 0;
		for (int i=0; i<2; i++) iRec93[i] = 0;
		for (int i=0; i<2; i++) iRec94[i] = 0;
		for (int i=0; i<262144; i++) fVec46[i] = 0;
		for (int i=0; i<2; i++) fRec95[i] = 0;
		for (int i=0; i<2; i++) fVec47[i] = 0;
		for (int i=0; i<2; i++) fRec96[i] = 0;
		for (int i=0; i<2; i++) fVec48[i] = 0;
		for (int i=0; i<2; i++) fRec97[i] = 0;
		for (int i=0; i<2; i++) fVec49[i] = 0;
		for (int i=0; i<2; i++) fRec98[i] = 0;
		for (int i=0; i<2; i++) fVec50[i] = 0;
		for (int i=0; i<2; i++) fRec99[i] = 0;
		for (int i=0; i<2; i++) fRec7[i] = 0;
		for (int i=0; i<2; i++) fRec100[i] = 0;
		for (int i=0; i<2; i++) fVec51[i] = 0;
		for (int i=0; i<2; i++) fRec101[i] = 0;
		for (int i=0; i<2; i++) fRec102[i] = 0;
		for (int i=0; i<1048576; i++) fVec52[i] = 0;
		for (int i=0; i<2; i++) iRec103[i] = 0;
		for (int i=0; i<2; i++) iRec104[i] = 0;
		for (int i=0; i<262144; i++) fVec53[i] = 0;
		for (int i=0; i<2; i++) fVec54[i] = 0;
		for (int i=0; i<2; i++) fRec105[i] = 0;
		for (int i=0; i<2; i++) fVec55[i] = 0;
		for (int i=0; i<2; i++) fRec106[i] = 0;
		for (int i=0; i<2; i++) fVec56[i] = 0;
		for (int i=0; i<2; i++) fRec107[i] = 0;
		for (int i=0; i<2; i++) fRec8[i] = 0;
		for (int i=0; i<2; i++) fRec108[i] = 0;
		for (int i=0; i<1048576; i++) fVec57[i] = 0;
		for (int i=0; i<2; i++) iRec109[i] = 0;
		for (int i=0; i<2; i++) iRec110[i] = 0;
		for (int i=0; i<262144; i++) fVec58[i] = 0;
		for (int i=0; i<2; i++) fRec111[i] = 0;
		for (int i=0; i<2; i++) fVec59[i] = 0;
		for (int i=0; i<2; i++) fRec112[i] = 0;
		for (int i=0; i<2; i++) fVec60[i] = 0;
		for (int i=0; i<2; i++) fRec113[i] = 0;
		for (int i=0; i<2; i++) fVec61[i] = 0;
		for (int i=0; i<2; i++) fRec114[i] = 0;
		for (int i=0; i<2; i++) fVec62[i] = 0;
		for (int i=0; i<2; i++) fRec115[i] = 0;
		for (int i=0; i<2; i++) fRec9[i] = 0;
		for (int i=0; i<2; i++) fRec116[i] = 0;
		for (int i=0; i<1048576; i++) fVec63[i] = 0;
		for (int i=0; i<2; i++) iRec117[i] = 0;
		for (int i=0; i<2; i++) iRec118[i] = 0;
		for (int i=0; i<262144; i++) fVec64[i] = 0;
		for (int i=0; i<2; i++) fRec119[i] = 0;
		for (int i=0; i<2; i++) fVec65[i] = 0;
		for (int i=0; i<2; i++) fRec120[i] = 0;
		for (int i=0; i<2; i++) fVec66[i] = 0;
		for (int i=0; i<2; i++) fRec121[i] = 0;
		for (int i=0; i<2; i++) fVec67[i] = 0;
		for (int i=0; i<2; i++) fRec122[i] = 0;
		for (int i=0; i<2; i++) fVec68[i] = 0;
		for (int i=0; i<2; i++) fRec123[i] = 0;
		for (int i=0; i<2; i++) fRec10[i] = 0;
		for (int i=0; i<2; i++) fRec124[i] = 0;
		for (int i=0; i<1048576; i++) fVec69[i] = 0;
		for (int i=0; i<2; i++) iRec125[i] = 0;
		for (int i=0; i<2; i++) iRec126[i] = 0;
		for (int i=0; i<262144; i++) fVec70[i] = 0;
		for (int i=0; i<2; i++) fRec127[i] = 0;
		for (int i=0; i<2; i++) fVec71[i] = 0;
		for (int i=0; i<2; i++) fRec128[i] = 0;
		for (int i=0; i<2; i++) fVec72[i] = 0;
		for (int i=0; i<2; i++) fRec129[i] = 0;
		for (int i=0; i<2; i++) fVec73[i] = 0;
		for (int i=0; i<2; i++) fRec130[i] = 0;
		for (int i=0; i<2; i++) fVec74[i] = 0;
		for (int i=0; i<2; i++) fRec131[i] = 0;
		for (int i=0; i<2; i++) fRec11[i] = 0;
		for (int i=0; i<2; i++) fRec132[i] = 0;
		for (int i=0; i<1048576; i++) fVec75[i] = 0;
		for (int i=0; i<2; i++) iRec133[i] = 0;
		for (int i=0; i<2; i++) iRec134[i] = 0;
		for (int i=0; i<262144; i++) fVec76[i] = 0;
		for (int i=0; i<2; i++) fRec135[i] = 0;
		for (int i=0; i<2; i++) fVec77[i] = 0;
		for (int i=0; i<2; i++) fRec136[i] = 0;
		for (int i=0; i<2; i++) fVec78[i] = 0;
		for (int i=0; i<2; i++) fRec137[i] = 0;
		for (int i=0; i<2; i++) fVec79[i] = 0;
		for (int i=0; i<2; i++) fRec138[i] = 0;
		for (int i=0; i<2; i++) fVec80[i] = 0;
		for (int i=0; i<2; i++) fRec139[i] = 0;
		for (int i=0; i<2; i++) fRec12[i] = 0;
		for (int i=0; i<2; i++) fRec140[i] = 0;
		for (int i=0; i<1048576; i++) fVec81[i] = 0;
		for (int i=0; i<2; i++) iRec141[i] = 0;
		for (int i=0; i<2; i++) iRec142[i] = 0;
		for (int i=0; i<262144; i++) fVec82[i] = 0;
		for (int i=0; i<2; i++) fRec143[i] = 0;
		for (int i=0; i<2; i++) fVec83[i] = 0;
		for (int i=0; i<2; i++) fRec144[i] = 0;
		for (int i=0; i<2; i++) fVec84[i] = 0;
		for (int i=0; i<2; i++) fRec145[i] = 0;
		for (int i=0; i<2; i++) fVec85[i] = 0;
		for (int i=0; i<2; i++) fRec146[i] = 0;
		for (int i=0; i<2; i++) fVec86[i] = 0;
		for (int i=0; i<2; i++) fRec147[i] = 0;
		for (int i=0; i<2; i++) fRec13[i] = 0;
		for (int i=0; i<2; i++) fRec148[i] = 0;
		for (int i=0; i<1048576; i++) fVec87[i] = 0;
		for (int i=0; i<2; i++) iRec149[i] = 0;
		for (int i=0; i<2; i++) iRec150[i] = 0;
		for (int i=0; i<262144; i++) fVec88[i] = 0;
		for (int i=0; i<2; i++) fRec151[i] = 0;
		for (int i=0; i<2; i++) fVec89[i] = 0;
		for (int i=0; i<2; i++) fRec152[i] = 0;
		for (int i=0; i<2; i++) fVec90[i] = 0;
		for (int i=0; i<2; i++) fRec153[i] = 0;
		for (int i=0; i<2; i++) fVec91[i] = 0;
		for (int i=0; i<2; i++) fRec154[i] = 0;
		for (int i=0; i<2; i++) fVec92[i] = 0;
		for (int i=0; i<2; i++) fRec155[i] = 0;
		for (int i=0; i<2; i++) fRec14[i] = 0;
		for (int i=0; i<2; i++) fRec156[i] = 0;
		for (int i=0; i<1048576; i++) fVec93[i] = 0;
		for (int i=0; i<2; i++) iRec157[i] = 0;
		for (int i=0; i<2; i++) iRec158[i] = 0;
		for (int i=0; i<262144; i++) fVec94[i] = 0;
		for (int i=0; i<2; i++) fRec159[i] = 0;
		for (int i=0; i<2; i++) fVec95[i] = 0;
		for (int i=0; i<2; i++) fRec160[i] = 0;
		for (int i=0; i<2; i++) fVec96[i] = 0;
		for (int i=0; i<2; i++) fRec161[i] = 0;
		for (int i=0; i<2; i++) fVec97[i] = 0;
		for (int i=0; i<2; i++) fRec162[i] = 0;
		for (int i=0; i<2; i++) fVec98[i] = 0;
		for (int i=0; i<2; i++) fRec163[i] = 0;
		for (int i=0; i<2; i++) fRec15[i] = 0;
		for (int i=0; i<2; i++) fRec164[i] = 0;
		for (int i=0; i<2; i++) fRec165[i] = 0;
		for (int i=0; i<2; i++) fRec166[i] = 0;
		for (int i=0; i<2; i++) fRec167[i] = 0;
		for (int i=0; i<2; i++) fRec168[i] = 0;
		for (int i=0; i<2; i++) fRec169[i] = 0;
		for (int i=0; i<2; i++) fRec170[i] = 0;
		for (int i=0; i<2; i++) fRec171[i] = 0;
		for (int i=0; i<2; i++) fRec172[i] = 0;
		for (int i=0; i<2; i++) fRec173[i] = 0;
		for (int i=0; i<2; i++) fRec174[i] = 0;
		for (int i=0; i<2; i++) fRec175[i] = 0;
		for (int i=0; i<2; i++) fRec176[i] = 0;
		for (int i=0; i<2; i++) fRec177[i] = 0;
		for (int i=0; i<2; i++) fRec178[i] = 0;
		for (int i=0; i<2; i++) fRec179[i] = 0;
	}
	virtual void init(int samplingFreq) {
		classInit(samplingFreq);
		instanceInit(samplingFreq);
	}
	virtual void instanceInit(int samplingFreq) {
		instanceConstants(samplingFreq);
		instanceResetUserInterface();
		instanceClear();
	}
	virtual mydsp* clone() {
		return new mydsp();
	}
	virtual int getSampleRate() {
		return fSamplingFreq;
	}
	virtual void buildUserInterface(UI* ui_interface) {
		ui_interface->openVerticalBox("0x00");
		ui_interface->openHorizontalBox("Global_Parameters");
		ui_interface->declare(&fslider35, "7", "");
		ui_interface->addHorizontalSlider("dStretch", &fslider35, 1.0, 0.01, 1e+01, 0.01);
		ui_interface->declare(&fslider37, "7", "");
		ui_interface->addHorizontalSlider("hStretch", &fslider37, 1.0, -1e+01, 1e+01, 0.01);
		ui_interface->addHorizontalSlider("hWin", &fslider38, 64.0, 1.0, 127.0, 0.01);
		ui_interface->addHorizontalSlider("smoothDuration", &fslider2, 2e+01, 1e+01, 5e+03, 1.0);
		ui_interface->closeBox();
		ui_interface->openHorizontalBox("Lines");
		ui_interface->openVerticalBox("Del_Durations");
		ui_interface->addHorizontalSlider("d 0", &fslider34, 1e+02, 0.0, 2.1e+04, 1.0);
		ui_interface->addHorizontalSlider("d 1", &fslider40, 2e+02, 0.0, 2.1e+04, 1.0);
		ui_interface->addHorizontalSlider("d 2", &fslider43, 3e+02, 0.0, 2.1e+04, 1.0);
		ui_interface->addHorizontalSlider("d 3", &fslider46, 4e+02, 0.0, 2.1e+04, 1.0);
		ui_interface->addHorizontalSlider("d 4", &fslider49, 5e+02, 0.0, 2.1e+04, 1.0);
		ui_interface->addHorizontalSlider("d 5", &fslider52, 6e+02, 0.0, 2.1e+04, 1.0);
		ui_interface->addHorizontalSlider("d 6", &fslider55, 7e+02, 0.0, 2.1e+04, 1.0);
		ui_interface->addHorizontalSlider("d 7", &fslider58, 8e+02, 0.0, 2.1e+04, 1.0);
		ui_interface->addHorizontalSlider("d 8", &fslider62, 9e+02, 0.0, 2.1e+04, 1.0);
		ui_interface->addHorizontalSlider("d 9", &fslider64, 1e+03, 0.0, 2.1e+04, 1.0);
		ui_interface->addHorizontalSlider("d10", &fslider67, 1.1e+03, 0.0, 2.1e+04, 1.0);
		ui_interface->addHorizontalSlider("d11", &fslider70, 1.2e+03, 0.0, 2.1e+04, 1.0);
		ui_interface->addHorizontalSlider("d12", &fslider73, 1.3e+03, 0.0, 2.1e+04, 1.0);
		ui_interface->addHorizontalSlider("d13", &fslider76, 1.4e+03, 0.0, 2.1e+04, 1.0);
		ui_interface->addHorizontalSlider("d14", &fslider79, 1.5e+03, 0.0, 2.1e+04, 1.0);
		ui_interface->addHorizontalSlider("d15", &fslider82, 1.6e+03, 0.0, 2.1e+04, 1.0);
		ui_interface->closeBox();
		ui_interface->openVerticalBox("Del_Feedbacks");
		ui_interface->addHorizontalSlider("fd 0", &fslider1, 0.0, 0.0, 0.99, 0.01);
		ui_interface->addHorizontalSlider("fd 1", &fslider4, 0.0, 0.0, 0.99, 0.01);
		ui_interface->addHorizontalSlider("fd 2", &fslider6, 0.0, 0.0, 0.99, 0.01);
		ui_interface->addHorizontalSlider("fd 3", &fslider8, 0.0, 0.0, 0.99, 0.01);
		ui_interface->addHorizontalSlider("fd 4", &fslider10, 0.0, 0.0, 0.99, 0.01);
		ui_interface->addHorizontalSlider("fd 5", &fslider12, 0.0, 0.0, 0.99, 0.01);
		ui_interface->addHorizontalSlider("fd 6", &fslider14, 0.0, 0.0, 0.99, 0.01);
		ui_interface->addHorizontalSlider("fd 7", &fslider16, 0.0, 0.0, 0.99, 0.01);
		ui_interface->addHorizontalSlider("fd 8", &fslider18, 0.0, 0.0, 0.99, 0.01);
		ui_interface->addHorizontalSlider("fd 9", &fslider20, 0.0, 0.0, 0.99, 0.01);
		ui_interface->addHorizontalSlider("fd10", &fslider22, 0.0, 0.0, 0.99, 0.01);
		ui_interface->addHorizontalSlider("fd11", &fslider24, 0.0, 0.0, 0.99, 0.01);
		ui_interface->addHorizontalSlider("fd12", &fslider26, 0.0, 0.0, 0.99, 0.01);
		ui_interface->addHorizontalSlider("fd13", &fslider28, 0.0, 0.0, 0.99, 0.01);
		ui_interface->addHorizontalSlider("fd14", &fslider30, 0.0, 0.0, 0.99, 0.01);
		ui_interface->addHorizontalSlider("fd15", &fslider32, 0.0, 0.0, 0.99, 0.01);
		ui_interface->closeBox();
		ui_interface->openVerticalBox("EffeX_vs_Del");
		ui_interface->addHorizontalSlider("xvd 0", &fslider0, 1.0, 0.0, 1.0, 0.01);
		ui_interface->addHorizontalSlider("xvd 1", &fslider3, 1.0, 0.0, 1.0, 0.01);
		ui_interface->addHorizontalSlider("xvd 2", &fslider5, 1.0, 0.0, 1.0, 0.01);
		ui_interface->addHorizontalSlider("xvd 3", &fslider7, 1.0, 0.0, 1.0, 0.01);
		ui_interface->addHorizontalSlider("xvd 4", &fslider9, 1.0, 0.0, 1.0, 0.01);
		ui_interface->addHorizontalSlider("xvd 5", &fslider11, 1.0, 0.0, 1.0, 0.01);
		ui_interface->addHorizontalSlider("xvd 6", &fslider13, 1.0, 0.0, 1.0, 0.01);
		ui_interface->addHorizontalSlider("xvd 7", &fslider15, 1.0, 0.0, 1.0, 0.01);
		ui_interface->addHorizontalSlider("xvd 8", &fslider17, 1.0, 0.0, 1.0, 0.01);
		ui_interface->addHorizontalSlider("xvd 9", &fslider19, 1.0, 0.0, 1.0, 0.01);
		ui_interface->addHorizontalSlider("xvd10", &fslider21, 1.0, 0.0, 1.0, 0.01);
		ui_interface->addHorizontalSlider("xvd11", &fslider23, 1.0, 0.0, 1.0, 0.01);
		ui_interface->addHorizontalSlider("xvd12", &fslider25, 1.0, 0.0, 1.0, 0.01);
		ui_interface->addHorizontalSlider("xvd13", &fslider27, 1.0, 0.0, 1.0, 0.01);
		ui_interface->addHorizontalSlider("xvd14", &fslider29, 1.0, 0.0, 1.0, 0.01);
		ui_interface->addHorizontalSlider("xvd15", &fslider31, 1.0, 0.0, 1.0, 0.01);
		ui_interface->closeBox();
		ui_interface->openVerticalBox("Harmo_Transpositions");
		ui_interface->addHorizontalSlider("tr 0", &fslider36, 0.0, -2.4e+03, 2.4e+03, 1.0);
		ui_interface->addHorizontalSlider("tr 1", &fslider41, 0.0, -2.4e+03, 2.4e+03, 1.0);
		ui_interface->addHorizontalSlider("tr 2", &fslider44, 0.0, -2.4e+03, 2.4e+03, 1.0);
		ui_interface->addHorizontalSlider("tr 3", &fslider47, 0.0, -2.4e+03, 2.4e+03, 1.0);
		ui_interface->addHorizontalSlider("tr 4", &fslider50, 0.0, -2.4e+03, 2.4e+03, 1.0);
		ui_interface->addHorizontalSlider("tr 5", &fslider53, 0.0, -2.4e+03, 2.4e+03, 1.0);
		ui_interface->addHorizontalSlider("tr 6", &fslider56, 0.0, -2.4e+03, 2.4e+03, 1.0);
		ui_interface->addHorizontalSlider("tr 7", &fslider59, 0.0, -2.4e+03, 2.4e+03, 1.0);
		ui_interface->addHorizontalSlider("tr 8", &fslider60, 0.0, -2.4e+03, 2.4e+03, 1.0);
		ui_interface->addHorizontalSlider("tr 9", &fslider65, 0.0, -2.4e+03, 2.4e+03, 1.0);
		ui_interface->addHorizontalSlider("tr10", &fslider68, 0.0, -2.4e+03, 2.4e+03, 1.0);
		ui_interface->addHorizontalSlider("tr11", &fslider71, 0.0, -2.4e+03, 2.4e+03, 1.0);
		ui_interface->addHorizontalSlider("tr12", &fslider74, 0.0, -2.4e+03, 2.4e+03, 1.0);
		ui_interface->addHorizontalSlider("tr13", &fslider77, 0.0, -2.4e+03, 2.4e+03, 1.0);
		ui_interface->addHorizontalSlider("tr14", &fslider80, 0.0, -2.4e+03, 2.4e+03, 1.0);
		ui_interface->addHorizontalSlider("tr15", &fslider83, 0.0, -2.4e+03, 2.4e+03, 1.0);
		ui_interface->closeBox();
		ui_interface->openVerticalBox("Line_input");
		ui_interface->declare(&fslider33, "5", "");
		ui_interface->addHorizontalSlider("inp 0", &fslider33, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider39, "5", "");
		ui_interface->addHorizontalSlider("inp 1", &fslider39, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider42, "5", "");
		ui_interface->addHorizontalSlider("inp 2", &fslider42, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider45, "5", "");
		ui_interface->addHorizontalSlider("inp 3", &fslider45, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider48, "5", "");
		ui_interface->addHorizontalSlider("inp 4", &fslider48, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider51, "5", "");
		ui_interface->addHorizontalSlider("inp 5", &fslider51, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider54, "5", "");
		ui_interface->addHorizontalSlider("inp 6", &fslider54, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider57, "5", "");
		ui_interface->addHorizontalSlider("inp 7", &fslider57, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider61, "5", "");
		ui_interface->addHorizontalSlider("inp 8", &fslider61, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider63, "5", "");
		ui_interface->addHorizontalSlider("inp 9", &fslider63, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider66, "5", "");
		ui_interface->addHorizontalSlider("inp10", &fslider66, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider69, "5", "");
		ui_interface->addHorizontalSlider("inp11", &fslider69, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider72, "5", "");
		ui_interface->addHorizontalSlider("inp12", &fslider72, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider75, "5", "");
		ui_interface->addHorizontalSlider("inp13", &fslider75, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider78, "5", "");
		ui_interface->addHorizontalSlider("inp14", &fslider78, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider81, "5", "");
		ui_interface->addHorizontalSlider("inp15", &fslider81, 1.0, 0.0, 1.0, 0.01);
		ui_interface->closeBox();
		ui_interface->openVerticalBox("Line_output");
		ui_interface->declare(&fslider84, "6", "");
		ui_interface->addHorizontalSlider("out 0", &fslider84, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider85, "6", "");
		ui_interface->addHorizontalSlider("out 1", &fslider85, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider86, "6", "");
		ui_interface->addHorizontalSlider("out 2", &fslider86, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider87, "6", "");
		ui_interface->addHorizontalSlider("out 3", &fslider87, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider88, "6", "");
		ui_interface->addHorizontalSlider("out 4", &fslider88, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider89, "6", "");
		ui_interface->addHorizontalSlider("out 5", &fslider89, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider90, "6", "");
		ui_interface->addHorizontalSlider("out 6", &fslider90, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider91, "6", "");
		ui_interface->addHorizontalSlider("out 7", &fslider91, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider92, "6", "");
		ui_interface->addHorizontalSlider("out 8", &fslider92, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider93, "6", "");
		ui_interface->addHorizontalSlider("out 9", &fslider93, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider94, "6", "");
		ui_interface->addHorizontalSlider("out10", &fslider94, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider95, "6", "");
		ui_interface->addHorizontalSlider("out11", &fslider95, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider96, "6", "");
		ui_interface->addHorizontalSlider("out12", &fslider96, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider97, "6", "");
		ui_interface->addHorizontalSlider("out13", &fslider97, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider98, "6", "");
		ui_interface->addHorizontalSlider("out14", &fslider98, 1.0, 0.0, 1.0, 0.01);
		ui_interface->declare(&fslider99, "6", "");
		ui_interface->addHorizontalSlider("out15", &fslider99, 1.0, 0.0, 1.0, 0.01);
		ui_interface->closeBox();
		ui_interface->openHorizontalBox("Reinjection_Matrix");
		ui_interface->openVerticalBox("Del 0-->");
		ui_interface->addCheckButton("r  0", &fcheckbox0);
		ui_interface->addCheckButton("r 16", &fcheckbox16);
		ui_interface->addCheckButton("r 32", &fcheckbox32);
		ui_interface->addCheckButton("r 48", &fcheckbox48);
		ui_interface->addCheckButton("r 64", &fcheckbox64);
		ui_interface->addCheckButton("r 80", &fcheckbox80);
		ui_interface->addCheckButton("r 96", &fcheckbox96);
		ui_interface->addCheckButton("r112", &fcheckbox112);
		ui_interface->addCheckButton("r128", &fcheckbox128);
		ui_interface->addCheckButton("r144", &fcheckbox144);
		ui_interface->addCheckButton("r160", &fcheckbox160);
		ui_interface->addCheckButton("r176", &fcheckbox176);
		ui_interface->addCheckButton("r192", &fcheckbox192);
		ui_interface->addCheckButton("r208", &fcheckbox208);
		ui_interface->addCheckButton("r224", &fcheckbox224);
		ui_interface->addCheckButton("r240", &fcheckbox240);
		ui_interface->closeBox();
		ui_interface->openVerticalBox("Del 1-->");
		ui_interface->addCheckButton("r  1", &fcheckbox1);
		ui_interface->addCheckButton("r 17", &fcheckbox17);
		ui_interface->addCheckButton("r 33", &fcheckbox33);
		ui_interface->addCheckButton("r 49", &fcheckbox49);
		ui_interface->addCheckButton("r 65", &fcheckbox65);
		ui_interface->addCheckButton("r 81", &fcheckbox81);
		ui_interface->addCheckButton("r 97", &fcheckbox97);
		ui_interface->addCheckButton("r113", &fcheckbox113);
		ui_interface->addCheckButton("r129", &fcheckbox129);
		ui_interface->addCheckButton("r145", &fcheckbox145);
		ui_interface->addCheckButton("r161", &fcheckbox161);
		ui_interface->addCheckButton("r177", &fcheckbox177);
		ui_interface->addCheckButton("r193", &fcheckbox193);
		ui_interface->addCheckButton("r209", &fcheckbox209);
		ui_interface->addCheckButton("r225", &fcheckbox225);
		ui_interface->addCheckButton("r241", &fcheckbox241);
		ui_interface->closeBox();
		ui_interface->openVerticalBox("Del 2-->");
		ui_interface->addCheckButton("r  2", &fcheckbox2);
		ui_interface->addCheckButton("r 18", &fcheckbox18);
		ui_interface->addCheckButton("r 34", &fcheckbox34);
		ui_interface->addCheckButton("r 50", &fcheckbox50);
		ui_interface->addCheckButton("r 66", &fcheckbox66);
		ui_interface->addCheckButton("r 82", &fcheckbox82);
		ui_interface->addCheckButton("r 98", &fcheckbox98);
		ui_interface->addCheckButton("r114", &fcheckbox114);
		ui_interface->addCheckButton("r130", &fcheckbox130);
		ui_interface->addCheckButton("r146", &fcheckbox146);
		ui_interface->addCheckButton("r162", &fcheckbox162);
		ui_interface->addCheckButton("r178", &fcheckbox178);
		ui_interface->addCheckButton("r194", &fcheckbox194);
		ui_interface->addCheckButton("r210", &fcheckbox210);
		ui_interface->addCheckButton("r226", &fcheckbox226);
		ui_interface->addCheckButton("r242", &fcheckbox242);
		ui_interface->closeBox();
		ui_interface->openVerticalBox("Del 3-->");
		ui_interface->addCheckButton("r  3", &fcheckbox3);
		ui_interface->addCheckButton("r 19", &fcheckbox19);
		ui_interface->addCheckButton("r 35", &fcheckbox35);
		ui_interface->addCheckButton("r 51", &fcheckbox51);
		ui_interface->addCheckButton("r 67", &fcheckbox67);
		ui_interface->addCheckButton("r 83", &fcheckbox83);
		ui_interface->addCheckButton("r 99", &fcheckbox99);
		ui_interface->addCheckButton("r115", &fcheckbox115);
		ui_interface->addCheckButton("r131", &fcheckbox131);
		ui_interface->addCheckButton("r147", &fcheckbox147);
		ui_interface->addCheckButton("r163", &fcheckbox163);
		ui_interface->addCheckButton("r179", &fcheckbox179);
		ui_interface->addCheckButton("r195", &fcheckbox195);
		ui_interface->addCheckButton("r211", &fcheckbox211);
		ui_interface->addCheckButton("r227", &fcheckbox227);
		ui_interface->addCheckButton("r243", &fcheckbox243);
		ui_interface->closeBox();
		ui_interface->openVerticalBox("Del 4-->");
		ui_interface->addCheckButton("r  4", &fcheckbox4);
		ui_interface->addCheckButton("r 20", &fcheckbox20);
		ui_interface->addCheckButton("r 36", &fcheckbox36);
		ui_interface->addCheckButton("r 52", &fcheckbox52);
		ui_interface->addCheckButton("r 68", &fcheckbox68);
		ui_interface->addCheckButton("r 84", &fcheckbox84);
		ui_interface->addCheckButton("r100", &fcheckbox100);
		ui_interface->addCheckButton("r116", &fcheckbox116);
		ui_interface->addCheckButton("r132", &fcheckbox132);
		ui_interface->addCheckButton("r148", &fcheckbox148);
		ui_interface->addCheckButton("r164", &fcheckbox164);
		ui_interface->addCheckButton("r180", &fcheckbox180);
		ui_interface->addCheckButton("r196", &fcheckbox196);
		ui_interface->addCheckButton("r212", &fcheckbox212);
		ui_interface->addCheckButton("r228", &fcheckbox228);
		ui_interface->addCheckButton("r244", &fcheckbox244);
		ui_interface->closeBox();
		ui_interface->openVerticalBox("Del 5-->");
		ui_interface->addCheckButton("r  5", &fcheckbox5);
		ui_interface->addCheckButton("r 21", &fcheckbox21);
		ui_interface->addCheckButton("r 37", &fcheckbox37);
		ui_interface->addCheckButton("r 53", &fcheckbox53);
		ui_interface->addCheckButton("r 69", &fcheckbox69);
		ui_interface->addCheckButton("r 85", &fcheckbox85);
		ui_interface->addCheckButton("r101", &fcheckbox101);
		ui_interface->addCheckButton("r117", &fcheckbox117);
		ui_interface->addCheckButton("r133", &fcheckbox133);
		ui_interface->addCheckButton("r149", &fcheckbox149);
		ui_interface->addCheckButton("r165", &fcheckbox165);
		ui_interface->addCheckButton("r181", &fcheckbox181);
		ui_interface->addCheckButton("r197", &fcheckbox197);
		ui_interface->addCheckButton("r213", &fcheckbox213);
		ui_interface->addCheckButton("r229", &fcheckbox229);
		ui_interface->addCheckButton("r245", &fcheckbox245);
		ui_interface->closeBox();
		ui_interface->openVerticalBox("Del 6-->");
		ui_interface->addCheckButton("r  6", &fcheckbox6);
		ui_interface->addCheckButton("r 22", &fcheckbox22);
		ui_interface->addCheckButton("r 38", &fcheckbox38);
		ui_interface->addCheckButton("r 54", &fcheckbox54);
		ui_interface->addCheckButton("r 70", &fcheckbox70);
		ui_interface->addCheckButton("r 86", &fcheckbox86);
		ui_interface->addCheckButton("r102", &fcheckbox102);
		ui_interface->addCheckButton("r118", &fcheckbox118);
		ui_interface->addCheckButton("r134", &fcheckbox134);
		ui_interface->addCheckButton("r150", &fcheckbox150);
		ui_interface->addCheckButton("r166", &fcheckbox166);
		ui_interface->addCheckButton("r182", &fcheckbox182);
		ui_interface->addCheckButton("r198", &fcheckbox198);
		ui_interface->addCheckButton("r214", &fcheckbox214);
		ui_interface->addCheckButton("r230", &fcheckbox230);
		ui_interface->addCheckButton("r246", &fcheckbox246);
		ui_interface->closeBox();
		ui_interface->openVerticalBox("Del 7-->");
		ui_interface->addCheckButton("r  7", &fcheckbox7);
		ui_interface->addCheckButton("r 23", &fcheckbox23);
		ui_interface->addCheckButton("r 39", &fcheckbox39);
		ui_interface->addCheckButton("r 55", &fcheckbox55);
		ui_interface->addCheckButton("r 71", &fcheckbox71);
		ui_interface->addCheckButton("r 87", &fcheckbox87);
		ui_interface->addCheckButton("r103", &fcheckbox103);
		ui_interface->addCheckButton("r119", &fcheckbox119);
		ui_interface->addCheckButton("r135", &fcheckbox135);
		ui_interface->addCheckButton("r151", &fcheckbox151);
		ui_interface->addCheckButton("r167", &fcheckbox167);
		ui_interface->addCheckButton("r183", &fcheckbox183);
		ui_interface->addCheckButton("r199", &fcheckbox199);
		ui_interface->addCheckButton("r215", &fcheckbox215);
		ui_interface->addCheckButton("r231", &fcheckbox231);
		ui_interface->addCheckButton("r247", &fcheckbox247);
		ui_interface->closeBox();
		ui_interface->openVerticalBox("Del 8-->");
		ui_interface->addCheckButton("r  8", &fcheckbox8);
		ui_interface->addCheckButton("r 24", &fcheckbox24);
		ui_interface->addCheckButton("r 40", &fcheckbox40);
		ui_interface->addCheckButton("r 56", &fcheckbox56);
		ui_interface->addCheckButton("r 72", &fcheckbox72);
		ui_interface->addCheckButton("r 88", &fcheckbox88);
		ui_interface->addCheckButton("r104", &fcheckbox104);
		ui_interface->addCheckButton("r120", &fcheckbox120);
		ui_interface->addCheckButton("r136", &fcheckbox136);
		ui_interface->addCheckButton("r152", &fcheckbox152);
		ui_interface->addCheckButton("r168", &fcheckbox168);
		ui_interface->addCheckButton("r184", &fcheckbox184);
		ui_interface->addCheckButton("r200", &fcheckbox200);
		ui_interface->addCheckButton("r216", &fcheckbox216);
		ui_interface->addCheckButton("r232", &fcheckbox232);
		ui_interface->addCheckButton("r248", &fcheckbox248);
		ui_interface->closeBox();
		ui_interface->openVerticalBox("Del 9-->");
		ui_interface->addCheckButton("r  9", &fcheckbox9);
		ui_interface->addCheckButton("r 25", &fcheckbox25);
		ui_interface->addCheckButton("r 41", &fcheckbox41);
		ui_interface->addCheckButton("r 57", &fcheckbox57);
		ui_interface->addCheckButton("r 73", &fcheckbox73);
		ui_interface->addCheckButton("r 89", &fcheckbox89);
		ui_interface->addCheckButton("r105", &fcheckbox105);
		ui_interface->addCheckButton("r121", &fcheckbox121);
		ui_interface->addCheckButton("r137", &fcheckbox137);
		ui_interface->addCheckButton("r153", &fcheckbox153);
		ui_interface->addCheckButton("r169", &fcheckbox169);
		ui_interface->addCheckButton("r185", &fcheckbox185);
		ui_interface->addCheckButton("r201", &fcheckbox201);
		ui_interface->addCheckButton("r217", &fcheckbox217);
		ui_interface->addCheckButton("r233", &fcheckbox233);
		ui_interface->addCheckButton("r249", &fcheckbox249);
		ui_interface->closeBox();
		ui_interface->openVerticalBox("Del10-->");
		ui_interface->addCheckButton("r 10", &fcheckbox10);
		ui_interface->addCheckButton("r 26", &fcheckbox26);
		ui_interface->addCheckButton("r 42", &fcheckbox42);
		ui_interface->addCheckButton("r 58", &fcheckbox58);
		ui_interface->addCheckButton("r 74", &fcheckbox74);
		ui_interface->addCheckButton("r 90", &fcheckbox90);
		ui_interface->addCheckButton("r106", &fcheckbox106);
		ui_interface->addCheckButton("r122", &fcheckbox122);
		ui_interface->addCheckButton("r138", &fcheckbox138);
		ui_interface->addCheckButton("r154", &fcheckbox154);
		ui_interface->addCheckButton("r170", &fcheckbox170);
		ui_interface->addCheckButton("r186", &fcheckbox186);
		ui_interface->addCheckButton("r202", &fcheckbox202);
		ui_interface->addCheckButton("r218", &fcheckbox218);
		ui_interface->addCheckButton("r234", &fcheckbox234);
		ui_interface->addCheckButton("r250", &fcheckbox250);
		ui_interface->closeBox();
		ui_interface->openVerticalBox("Del11-->");
		ui_interface->addCheckButton("r 11", &fcheckbox11);
		ui_interface->addCheckButton("r 27", &fcheckbox27);
		ui_interface->addCheckButton("r 43", &fcheckbox43);
		ui_interface->addCheckButton("r 59", &fcheckbox59);
		ui_interface->addCheckButton("r 75", &fcheckbox75);
		ui_interface->addCheckButton("r 91", &fcheckbox91);
		ui_interface->addCheckButton("r107", &fcheckbox107);
		ui_interface->addCheckButton("r123", &fcheckbox123);
		ui_interface->addCheckButton("r139", &fcheckbox139);
		ui_interface->addCheckButton("r155", &fcheckbox155);
		ui_interface->addCheckButton("r171", &fcheckbox171);
		ui_interface->addCheckButton("r187", &fcheckbox187);
		ui_interface->addCheckButton("r203", &fcheckbox203);
		ui_interface->addCheckButton("r219", &fcheckbox219);
		ui_interface->addCheckButton("r235", &fcheckbox235);
		ui_interface->addCheckButton("r251", &fcheckbox251);
		ui_interface->closeBox();
		ui_interface->openVerticalBox("Del12-->");
		ui_interface->addCheckButton("r 12", &fcheckbox12);
		ui_interface->addCheckButton("r 28", &fcheckbox28);
		ui_interface->addCheckButton("r 44", &fcheckbox44);
		ui_interface->addCheckButton("r 60", &fcheckbox60);
		ui_interface->addCheckButton("r 76", &fcheckbox76);
		ui_interface->addCheckButton("r 92", &fcheckbox92);
		ui_interface->addCheckButton("r108", &fcheckbox108);
		ui_interface->addCheckButton("r124", &fcheckbox124);
		ui_interface->addCheckButton("r140", &fcheckbox140);
		ui_interface->addCheckButton("r156", &fcheckbox156);
		ui_interface->addCheckButton("r172", &fcheckbox172);
		ui_interface->addCheckButton("r188", &fcheckbox188);
		ui_interface->addCheckButton("r204", &fcheckbox204);
		ui_interface->addCheckButton("r220", &fcheckbox220);
		ui_interface->addCheckButton("r236", &fcheckbox236);
		ui_interface->addCheckButton("r252", &fcheckbox252);
		ui_interface->closeBox();
		ui_interface->openVerticalBox("Del13-->");
		ui_interface->addCheckButton("r 13", &fcheckbox13);
		ui_interface->addCheckButton("r 29", &fcheckbox29);
		ui_interface->addCheckButton("r 45", &fcheckbox45);
		ui_interface->addCheckButton("r 61", &fcheckbox61);
		ui_interface->addCheckButton("r 77", &fcheckbox77);
		ui_interface->addCheckButton("r 93", &fcheckbox93);
		ui_interface->addCheckButton("r109", &fcheckbox109);
		ui_interface->addCheckButton("r125", &fcheckbox125);
		ui_interface->addCheckButton("r141", &fcheckbox141);
		ui_interface->addCheckButton("r157", &fcheckbox157);
		ui_interface->addCheckButton("r173", &fcheckbox173);
		ui_interface->addCheckButton("r189", &fcheckbox189);
		ui_interface->addCheckButton("r205", &fcheckbox205);
		ui_interface->addCheckButton("r221", &fcheckbox221);
		ui_interface->addCheckButton("r237", &fcheckbox237);
		ui_interface->addCheckButton("r253", &fcheckbox253);
		ui_interface->closeBox();
		ui_interface->openVerticalBox("Del14-->");
		ui_interface->addCheckButton("r 14", &fcheckbox14);
		ui_interface->addCheckButton("r 30", &fcheckbox30);
		ui_interface->addCheckButton("r 46", &fcheckbox46);
		ui_interface->addCheckButton("r 62", &fcheckbox62);
		ui_interface->addCheckButton("r 78", &fcheckbox78);
		ui_interface->addCheckButton("r 94", &fcheckbox94);
		ui_interface->addCheckButton("r110", &fcheckbox110);
		ui_interface->addCheckButton("r126", &fcheckbox126);
		ui_interface->addCheckButton("r142", &fcheckbox142);
		ui_interface->addCheckButton("r158", &fcheckbox158);
		ui_interface->addCheckButton("r174", &fcheckbox174);
		ui_interface->addCheckButton("r190", &fcheckbox190);
		ui_interface->addCheckButton("r206", &fcheckbox206);
		ui_interface->addCheckButton("r222", &fcheckbox222);
		ui_interface->addCheckButton("r238", &fcheckbox238);
		ui_interface->addCheckButton("r254", &fcheckbox254);
		ui_interface->closeBox();
		ui_interface->openVerticalBox("Del15-->");
		ui_interface->addCheckButton("r 15", &fcheckbox15);
		ui_interface->addCheckButton("r 31", &fcheckbox31);
		ui_interface->addCheckButton("r 47", &fcheckbox47);
		ui_interface->addCheckButton("r 63", &fcheckbox63);
		ui_interface->addCheckButton("r 79", &fcheckbox79);
		ui_interface->addCheckButton("r 95", &fcheckbox95);
		ui_interface->addCheckButton("r111", &fcheckbox111);
		ui_interface->addCheckButton("r127", &fcheckbox127);
		ui_interface->addCheckButton("r143", &fcheckbox143);
		ui_interface->addCheckButton("r159", &fcheckbox159);
		ui_interface->addCheckButton("r175", &fcheckbox175);
		ui_interface->addCheckButton("r191", &fcheckbox191);
		ui_interface->addCheckButton("r207", &fcheckbox207);
		ui_interface->addCheckButton("r223", &fcheckbox223);
		ui_interface->addCheckButton("r239", &fcheckbox239);
		ui_interface->addCheckButton("r255", &fcheckbox255);
		ui_interface->closeBox();
		ui_interface->closeBox();
		ui_interface->closeBox();
		ui_interface->closeBox();
	}
	virtual void compute (int count, FAUSTFLOAT** input, FAUSTFLOAT** output) {
		double 	fSlow0 = double(fslider0);
		double 	fSlow1 = (1 - (0.75 * fSlow0));
		double 	fSlow2 = (double(fcheckbox0) * fSlow1);
		double 	fSlow3 = exp((0 - (fConst3 / double(fslider2))));
		double 	fSlow4 = (1.0 - fSlow3);
		double 	fSlow5 = (double(fslider1) * fSlow4);
		double 	fSlow6 = double(fslider3);
		double 	fSlow7 = (1 - (0.75 * fSlow6));
		double 	fSlow8 = (double(fcheckbox1) * fSlow7);
		double 	fSlow9 = (double(fslider4) * fSlow4);
		double 	fSlow10 = double(fslider5);
		double 	fSlow11 = (1 - (0.75 * fSlow10));
		double 	fSlow12 = (double(fcheckbox2) * fSlow11);
		double 	fSlow13 = (double(fslider6) * fSlow4);
		double 	fSlow14 = double(fslider7);
		double 	fSlow15 = (1 - (0.75 * fSlow14));
		double 	fSlow16 = (double(fcheckbox3) * fSlow15);
		double 	fSlow17 = (double(fslider8) * fSlow4);
		double 	fSlow18 = double(fslider9);
		double 	fSlow19 = (1 - (0.75 * fSlow18));
		double 	fSlow20 = (double(fcheckbox4) * fSlow19);
		double 	fSlow21 = (double(fslider10) * fSlow4);
		double 	fSlow22 = double(fslider11);
		double 	fSlow23 = (1 - (0.75 * fSlow22));
		double 	fSlow24 = (double(fcheckbox5) * fSlow23);
		double 	fSlow25 = (double(fslider12) * fSlow4);
		double 	fSlow26 = double(fslider13);
		double 	fSlow27 = (1 - (0.75 * fSlow26));
		double 	fSlow28 = (double(fcheckbox6) * fSlow27);
		double 	fSlow29 = (double(fslider14) * fSlow4);
		double 	fSlow30 = double(fslider15);
		double 	fSlow31 = (1 - (0.75 * fSlow30));
		double 	fSlow32 = (double(fcheckbox7) * fSlow31);
		double 	fSlow33 = (double(fslider16) * fSlow4);
		double 	fSlow34 = double(fslider17);
		double 	fSlow35 = (1 - (0.75 * fSlow34));
		double 	fSlow36 = (double(fcheckbox8) * fSlow35);
		double 	fSlow37 = (double(fslider18) * fSlow4);
		double 	fSlow38 = double(fslider19);
		double 	fSlow39 = (1 - (0.75 * fSlow38));
		double 	fSlow40 = (double(fcheckbox9) * fSlow39);
		double 	fSlow41 = (double(fslider20) * fSlow4);
		double 	fSlow42 = double(fslider21);
		double 	fSlow43 = (1 - (0.75 * fSlow42));
		double 	fSlow44 = (double(fcheckbox10) * fSlow43);
		double 	fSlow45 = (double(fslider22) * fSlow4);
		double 	fSlow46 = double(fslider23);
		double 	fSlow47 = (1 - (0.75 * fSlow46));
		double 	fSlow48 = (double(fcheckbox11) * fSlow47);
		double 	fSlow49 = (double(fslider24) * fSlow4);
		double 	fSlow50 = double(fslider25);
		double 	fSlow51 = (1 - (0.75 * fSlow50));
		double 	fSlow52 = (double(fcheckbox12) * fSlow51);
		double 	fSlow53 = (double(fslider26) * fSlow4);
		double 	fSlow54 = double(fslider27);
		double 	fSlow55 = (1 - (0.75 * fSlow54));
		double 	fSlow56 = (double(fcheckbox13) * fSlow55);
		double 	fSlow57 = (double(fslider28) * fSlow4);
		double 	fSlow58 = double(fslider29);
		double 	fSlow59 = (1 - (0.75 * fSlow58));
		double 	fSlow60 = (double(fcheckbox14) * fSlow59);
		double 	fSlow61 = (double(fslider30) * fSlow4);
		double 	fSlow62 = double(fslider31);
		double 	fSlow63 = (1 - (0.75 * fSlow62));
		double 	fSlow64 = (double(fcheckbox15) * fSlow63);
		double 	fSlow65 = (double(fslider32) * fSlow4);
		double 	fSlow66 = (double(fslider33) * fSlow4);
		double 	fSlow67 = double(fslider35);
		int 	iSlow68 = int((fConst4 * (double(fslider34) * fSlow67)));
		double 	fSlow69 = double(fslider37);
		double 	fSlow70 = (fConst5 * (0 - (3.8224 * ((4.4e+02 * pow(2.0,(0.08333333333333333 * ((0.01 * ((double(fslider36) * fSlow69) + 6000)) + -69.0)))) + -261.625977))));
		double 	fSlow71 = double(fslider38);
		double 	fSlow72 = ((int((fSlow71 < 127)))?fSlow71:127);
		double 	fSlow73 = ((int((fSlow72 < 1)))?0:(4096 * pow(1.07177,(fSlow72 + -127))));
		double 	fSlow74 = (1 - fSlow0);
		double 	fSlow75 = (double(fcheckbox16) * fSlow1);
		double 	fSlow76 = (double(fcheckbox17) * fSlow7);
		double 	fSlow77 = (double(fcheckbox18) * fSlow11);
		double 	fSlow78 = (double(fcheckbox19) * fSlow15);
		double 	fSlow79 = (double(fcheckbox20) * fSlow19);
		double 	fSlow80 = (double(fcheckbox21) * fSlow23);
		double 	fSlow81 = (double(fcheckbox22) * fSlow27);
		double 	fSlow82 = (double(fcheckbox23) * fSlow31);
		double 	fSlow83 = (double(fcheckbox24) * fSlow35);
		double 	fSlow84 = (double(fcheckbox25) * fSlow39);
		double 	fSlow85 = (double(fcheckbox26) * fSlow43);
		double 	fSlow86 = (double(fcheckbox27) * fSlow47);
		double 	fSlow87 = (double(fcheckbox28) * fSlow51);
		double 	fSlow88 = (double(fcheckbox29) * fSlow55);
		double 	fSlow89 = (double(fcheckbox30) * fSlow59);
		double 	fSlow90 = (double(fcheckbox31) * fSlow63);
		double 	fSlow91 = (double(fslider39) * fSlow4);
		int 	iSlow92 = int((fConst4 * (fSlow67 * double(fslider40))));
		double 	fSlow93 = (fConst5 * (0 - (3.8224 * ((4.4e+02 * pow(2.0,(0.08333333333333333 * ((0.01 * ((fSlow69 * double(fslider41)) + 6000)) + -69.0)))) + -261.625977))));
		double 	fSlow94 = (1 - fSlow6);
		double 	fSlow95 = (double(fcheckbox32) * fSlow1);
		double 	fSlow96 = (double(fcheckbox33) * fSlow7);
		double 	fSlow97 = (double(fcheckbox34) * fSlow11);
		double 	fSlow98 = (double(fcheckbox35) * fSlow15);
		double 	fSlow99 = (double(fcheckbox36) * fSlow19);
		double 	fSlow100 = (double(fcheckbox37) * fSlow23);
		double 	fSlow101 = (double(fcheckbox38) * fSlow27);
		double 	fSlow102 = (double(fcheckbox39) * fSlow31);
		double 	fSlow103 = (double(fcheckbox40) * fSlow35);
		double 	fSlow104 = (double(fcheckbox41) * fSlow39);
		double 	fSlow105 = (double(fcheckbox42) * fSlow43);
		double 	fSlow106 = (double(fcheckbox43) * fSlow47);
		double 	fSlow107 = (double(fcheckbox44) * fSlow51);
		double 	fSlow108 = (double(fcheckbox45) * fSlow55);
		double 	fSlow109 = (double(fcheckbox46) * fSlow59);
		double 	fSlow110 = (double(fcheckbox47) * fSlow63);
		double 	fSlow111 = (double(fslider42) * fSlow4);
		int 	iSlow112 = int((fConst4 * (fSlow67 * double(fslider43))));
		double 	fSlow113 = (fConst5 * (0 - (3.8224 * ((4.4e+02 * pow(2.0,(0.08333333333333333 * ((0.01 * ((fSlow69 * double(fslider44)) + 6000)) + -69.0)))) + -261.625977))));
		double 	fSlow114 = (1 - fSlow10);
		double 	fSlow115 = (double(fcheckbox48) * fSlow1);
		double 	fSlow116 = (double(fcheckbox49) * fSlow7);
		double 	fSlow117 = (double(fcheckbox50) * fSlow11);
		double 	fSlow118 = (double(fcheckbox51) * fSlow15);
		double 	fSlow119 = (double(fcheckbox52) * fSlow19);
		double 	fSlow120 = (double(fcheckbox53) * fSlow23);
		double 	fSlow121 = (double(fcheckbox54) * fSlow27);
		double 	fSlow122 = (double(fcheckbox55) * fSlow31);
		double 	fSlow123 = (double(fcheckbox56) * fSlow35);
		double 	fSlow124 = (double(fcheckbox57) * fSlow39);
		double 	fSlow125 = (double(fcheckbox58) * fSlow43);
		double 	fSlow126 = (double(fcheckbox59) * fSlow47);
		double 	fSlow127 = (double(fcheckbox60) * fSlow51);
		double 	fSlow128 = (double(fcheckbox61) * fSlow55);
		double 	fSlow129 = (double(fcheckbox62) * fSlow59);
		double 	fSlow130 = (double(fcheckbox63) * fSlow63);
		double 	fSlow131 = (double(fslider45) * fSlow4);
		int 	iSlow132 = int((fConst4 * (fSlow67 * double(fslider46))));
		double 	fSlow133 = (fConst5 * (0 - (3.8224 * ((4.4e+02 * pow(2.0,(0.08333333333333333 * ((0.01 * ((fSlow69 * double(fslider47)) + 6000)) + -69.0)))) + -261.625977))));
		double 	fSlow134 = (1 - fSlow14);
		double 	fSlow135 = (double(fcheckbox64) * fSlow1);
		double 	fSlow136 = (double(fcheckbox65) * fSlow7);
		double 	fSlow137 = (double(fcheckbox66) * fSlow11);
		double 	fSlow138 = (double(fcheckbox67) * fSlow15);
		double 	fSlow139 = (double(fcheckbox68) * fSlow19);
		double 	fSlow140 = (double(fcheckbox69) * fSlow23);
		double 	fSlow141 = (double(fcheckbox70) * fSlow27);
		double 	fSlow142 = (double(fcheckbox71) * fSlow31);
		double 	fSlow143 = (double(fcheckbox72) * fSlow35);
		double 	fSlow144 = (double(fcheckbox73) * fSlow39);
		double 	fSlow145 = (double(fcheckbox74) * fSlow43);
		double 	fSlow146 = (double(fcheckbox75) * fSlow47);
		double 	fSlow147 = (double(fcheckbox76) * fSlow51);
		double 	fSlow148 = (double(fcheckbox77) * fSlow55);
		double 	fSlow149 = (double(fcheckbox78) * fSlow59);
		double 	fSlow150 = (double(fcheckbox79) * fSlow63);
		double 	fSlow151 = (double(fslider48) * fSlow4);
		int 	iSlow152 = int((fConst4 * (fSlow67 * double(fslider49))));
		double 	fSlow153 = (fConst5 * (0 - (3.8224 * ((4.4e+02 * pow(2.0,(0.08333333333333333 * ((0.01 * ((fSlow69 * double(fslider50)) + 6000)) + -69.0)))) + -261.625977))));
		double 	fSlow154 = (1 - fSlow18);
		double 	fSlow155 = (double(fcheckbox80) * fSlow1);
		double 	fSlow156 = (double(fcheckbox81) * fSlow7);
		double 	fSlow157 = (double(fcheckbox82) * fSlow11);
		double 	fSlow158 = (double(fcheckbox83) * fSlow15);
		double 	fSlow159 = (double(fcheckbox84) * fSlow19);
		double 	fSlow160 = (double(fcheckbox85) * fSlow23);
		double 	fSlow161 = (double(fcheckbox86) * fSlow27);
		double 	fSlow162 = (double(fcheckbox87) * fSlow31);
		double 	fSlow163 = (double(fcheckbox88) * fSlow35);
		double 	fSlow164 = (double(fcheckbox89) * fSlow39);
		double 	fSlow165 = (double(fcheckbox90) * fSlow43);
		double 	fSlow166 = (double(fcheckbox91) * fSlow47);
		double 	fSlow167 = (double(fcheckbox92) * fSlow51);
		double 	fSlow168 = (double(fcheckbox93) * fSlow55);
		double 	fSlow169 = (double(fcheckbox94) * fSlow59);
		double 	fSlow170 = (double(fcheckbox95) * fSlow63);
		double 	fSlow171 = (double(fslider51) * fSlow4);
		int 	iSlow172 = int((fConst4 * (double(fslider52) * fSlow67)));
		double 	fSlow173 = (fConst5 * (0 - (3.8224 * ((4.4e+02 * pow(2.0,(0.08333333333333333 * ((0.01 * ((fSlow69 * double(fslider53)) + 6000)) + -69.0)))) + -261.625977))));
		double 	fSlow174 = (1 - fSlow22);
		double 	fSlow175 = (double(fcheckbox96) * fSlow1);
		double 	fSlow176 = (double(fcheckbox97) * fSlow7);
		double 	fSlow177 = (double(fcheckbox98) * fSlow11);
		double 	fSlow178 = (double(fcheckbox99) * fSlow15);
		double 	fSlow179 = (double(fcheckbox100) * fSlow19);
		double 	fSlow180 = (double(fcheckbox101) * fSlow23);
		double 	fSlow181 = (double(fcheckbox102) * fSlow27);
		double 	fSlow182 = (double(fcheckbox103) * fSlow31);
		double 	fSlow183 = (double(fcheckbox104) * fSlow35);
		double 	fSlow184 = (double(fcheckbox105) * fSlow39);
		double 	fSlow185 = (double(fcheckbox106) * fSlow43);
		double 	fSlow186 = (double(fcheckbox107) * fSlow47);
		double 	fSlow187 = (double(fcheckbox108) * fSlow51);
		double 	fSlow188 = (double(fcheckbox109) * fSlow55);
		double 	fSlow189 = (double(fcheckbox110) * fSlow59);
		double 	fSlow190 = (double(fcheckbox111) * fSlow63);
		double 	fSlow191 = (double(fslider54) * fSlow4);
		int 	iSlow192 = int((fConst4 * (double(fslider55) * fSlow67)));
		double 	fSlow193 = (fConst5 * (0 - (3.8224 * ((4.4e+02 * pow(2.0,(0.08333333333333333 * ((0.01 * ((fSlow69 * double(fslider56)) + 6000)) + -69.0)))) + -261.625977))));
		double 	fSlow194 = (1 - fSlow26);
		double 	fSlow195 = (double(fcheckbox112) * fSlow1);
		double 	fSlow196 = (double(fcheckbox113) * fSlow7);
		double 	fSlow197 = (double(fcheckbox114) * fSlow11);
		double 	fSlow198 = (double(fcheckbox115) * fSlow15);
		double 	fSlow199 = (double(fcheckbox116) * fSlow19);
		double 	fSlow200 = (double(fcheckbox117) * fSlow23);
		double 	fSlow201 = (double(fcheckbox118) * fSlow27);
		double 	fSlow202 = (double(fcheckbox119) * fSlow31);
		double 	fSlow203 = (double(fcheckbox120) * fSlow35);
		double 	fSlow204 = (double(fcheckbox121) * fSlow39);
		double 	fSlow205 = (double(fcheckbox122) * fSlow43);
		double 	fSlow206 = (double(fcheckbox123) * fSlow47);
		double 	fSlow207 = (double(fcheckbox124) * fSlow51);
		double 	fSlow208 = (double(fcheckbox125) * fSlow55);
		double 	fSlow209 = (double(fcheckbox126) * fSlow59);
		double 	fSlow210 = (double(fcheckbox127) * fSlow63);
		double 	fSlow211 = (double(fslider57) * fSlow4);
		int 	iSlow212 = int((fConst4 * (fSlow67 * double(fslider58))));
		double 	fSlow213 = (fConst5 * (0 - (3.8224 * ((4.4e+02 * pow(2.0,(0.08333333333333333 * ((0.01 * ((fSlow69 * double(fslider59)) + 6000)) + -69.0)))) + -261.625977))));
		double 	fSlow214 = (1 - fSlow30);
		double 	fSlow215 = (fConst5 * (0 - (3.8224 * ((4.4e+02 * pow(2.0,(0.08333333333333333 * ((0.01 * ((fSlow69 * double(fslider60)) + 6000)) + -69.0)))) + -261.625977))));
		double 	fSlow216 = (double(fcheckbox128) * fSlow1);
		double 	fSlow217 = (double(fcheckbox129) * fSlow7);
		double 	fSlow218 = (double(fcheckbox130) * fSlow11);
		double 	fSlow219 = (double(fcheckbox131) * fSlow15);
		double 	fSlow220 = (double(fcheckbox132) * fSlow19);
		double 	fSlow221 = (double(fcheckbox133) * fSlow23);
		double 	fSlow222 = (double(fcheckbox134) * fSlow27);
		double 	fSlow223 = (double(fcheckbox135) * fSlow31);
		double 	fSlow224 = (double(fcheckbox136) * fSlow35);
		double 	fSlow225 = (double(fcheckbox137) * fSlow39);
		double 	fSlow226 = (double(fcheckbox138) * fSlow43);
		double 	fSlow227 = (double(fcheckbox139) * fSlow47);
		double 	fSlow228 = (double(fcheckbox140) * fSlow51);
		double 	fSlow229 = (double(fcheckbox141) * fSlow55);
		double 	fSlow230 = (double(fcheckbox142) * fSlow59);
		double 	fSlow231 = (double(fcheckbox143) * fSlow63);
		double 	fSlow232 = (double(fslider61) * fSlow4);
		int 	iSlow233 = int((fConst4 * (fSlow67 * double(fslider62))));
		double 	fSlow234 = (1 - fSlow34);
		double 	fSlow235 = (double(fcheckbox144) * fSlow1);
		double 	fSlow236 = (double(fcheckbox145) * fSlow7);
		double 	fSlow237 = (double(fcheckbox146) * fSlow11);
		double 	fSlow238 = (double(fcheckbox147) * fSlow15);
		double 	fSlow239 = (double(fcheckbox148) * fSlow19);
		double 	fSlow240 = (double(fcheckbox149) * fSlow23);
		double 	fSlow241 = (double(fcheckbox150) * fSlow27);
		double 	fSlow242 = (double(fcheckbox151) * fSlow31);
		double 	fSlow243 = (double(fcheckbox152) * fSlow35);
		double 	fSlow244 = (double(fcheckbox153) * fSlow39);
		double 	fSlow245 = (double(fcheckbox154) * fSlow43);
		double 	fSlow246 = (double(fcheckbox155) * fSlow47);
		double 	fSlow247 = (double(fcheckbox156) * fSlow51);
		double 	fSlow248 = (double(fcheckbox157) * fSlow55);
		double 	fSlow249 = (double(fcheckbox158) * fSlow59);
		double 	fSlow250 = (double(fcheckbox159) * fSlow63);
		double 	fSlow251 = (double(fslider63) * fSlow4);
		int 	iSlow252 = int((fConst4 * (fSlow67 * double(fslider64))));
		double 	fSlow253 = (fConst5 * (0 - (3.8224 * ((4.4e+02 * pow(2.0,(0.08333333333333333 * ((0.01 * ((fSlow69 * double(fslider65)) + 6000)) + -69.0)))) + -261.625977))));
		double 	fSlow254 = (1 - fSlow38);
		double 	fSlow255 = (double(fcheckbox160) * fSlow1);
		double 	fSlow256 = (double(fcheckbox161) * fSlow7);
		double 	fSlow257 = (double(fcheckbox162) * fSlow11);
		double 	fSlow258 = (double(fcheckbox163) * fSlow15);
		double 	fSlow259 = (double(fcheckbox164) * fSlow19);
		double 	fSlow260 = (double(fcheckbox165) * fSlow23);
		double 	fSlow261 = (double(fcheckbox166) * fSlow27);
		double 	fSlow262 = (double(fcheckbox167) * fSlow31);
		double 	fSlow263 = (double(fcheckbox168) * fSlow35);
		double 	fSlow264 = (double(fcheckbox169) * fSlow39);
		double 	fSlow265 = (double(fcheckbox170) * fSlow43);
		double 	fSlow266 = (double(fcheckbox171) * fSlow47);
		double 	fSlow267 = (double(fcheckbox172) * fSlow51);
		double 	fSlow268 = (double(fcheckbox173) * fSlow55);
		double 	fSlow269 = (double(fcheckbox174) * fSlow59);
		double 	fSlow270 = (double(fcheckbox175) * fSlow63);
		double 	fSlow271 = (double(fslider66) * fSlow4);
		int 	iSlow272 = int((fConst4 * (fSlow67 * double(fslider67))));
		double 	fSlow273 = (fConst5 * (0 - (3.8224 * ((4.4e+02 * pow(2.0,(0.08333333333333333 * ((0.01 * ((fSlow69 * double(fslider68)) + 6000)) + -69.0)))) + -261.625977))));
		double 	fSlow274 = (1 - fSlow42);
		double 	fSlow275 = (double(fcheckbox176) * fSlow1);
		double 	fSlow276 = (double(fcheckbox177) * fSlow7);
		double 	fSlow277 = (double(fcheckbox178) * fSlow11);
		double 	fSlow278 = (double(fcheckbox179) * fSlow15);
		double 	fSlow279 = (double(fcheckbox180) * fSlow19);
		double 	fSlow280 = (double(fcheckbox181) * fSlow23);
		double 	fSlow281 = (double(fcheckbox182) * fSlow27);
		double 	fSlow282 = (double(fcheckbox183) * fSlow31);
		double 	fSlow283 = (double(fcheckbox184) * fSlow35);
		double 	fSlow284 = (double(fcheckbox185) * fSlow39);
		double 	fSlow285 = (double(fcheckbox186) * fSlow43);
		double 	fSlow286 = (double(fcheckbox187) * fSlow47);
		double 	fSlow287 = (double(fcheckbox188) * fSlow51);
		double 	fSlow288 = (double(fcheckbox189) * fSlow55);
		double 	fSlow289 = (double(fcheckbox190) * fSlow59);
		double 	fSlow290 = (double(fcheckbox191) * fSlow63);
		double 	fSlow291 = (double(fslider69) * fSlow4);
		int 	iSlow292 = int((fConst4 * (fSlow67 * double(fslider70))));
		double 	fSlow293 = (fConst5 * (0 - (3.8224 * ((4.4e+02 * pow(2.0,(0.08333333333333333 * ((0.01 * ((fSlow69 * double(fslider71)) + 6000)) + -69.0)))) + -261.625977))));
		double 	fSlow294 = (1 - fSlow46);
		double 	fSlow295 = (double(fcheckbox192) * fSlow1);
		double 	fSlow296 = (double(fcheckbox193) * fSlow7);
		double 	fSlow297 = (double(fcheckbox194) * fSlow11);
		double 	fSlow298 = (double(fcheckbox195) * fSlow15);
		double 	fSlow299 = (double(fcheckbox196) * fSlow19);
		double 	fSlow300 = (double(fcheckbox197) * fSlow23);
		double 	fSlow301 = (double(fcheckbox198) * fSlow27);
		double 	fSlow302 = (double(fcheckbox199) * fSlow31);
		double 	fSlow303 = (double(fcheckbox200) * fSlow35);
		double 	fSlow304 = (double(fcheckbox201) * fSlow39);
		double 	fSlow305 = (double(fcheckbox202) * fSlow43);
		double 	fSlow306 = (double(fcheckbox203) * fSlow47);
		double 	fSlow307 = (double(fcheckbox204) * fSlow51);
		double 	fSlow308 = (double(fcheckbox205) * fSlow55);
		double 	fSlow309 = (double(fcheckbox206) * fSlow59);
		double 	fSlow310 = (double(fcheckbox207) * fSlow63);
		double 	fSlow311 = (double(fslider72) * fSlow4);
		int 	iSlow312 = int((fConst4 * (fSlow67 * double(fslider73))));
		double 	fSlow313 = (fConst5 * (0 - (3.8224 * ((4.4e+02 * pow(2.0,(0.08333333333333333 * ((0.01 * ((fSlow69 * double(fslider74)) + 6000)) + -69.0)))) + -261.625977))));
		double 	fSlow314 = (1 - fSlow50);
		double 	fSlow315 = (double(fcheckbox208) * fSlow1);
		double 	fSlow316 = (double(fcheckbox209) * fSlow7);
		double 	fSlow317 = (double(fcheckbox210) * fSlow11);
		double 	fSlow318 = (double(fcheckbox211) * fSlow15);
		double 	fSlow319 = (double(fcheckbox212) * fSlow19);
		double 	fSlow320 = (double(fcheckbox213) * fSlow23);
		double 	fSlow321 = (double(fcheckbox214) * fSlow27);
		double 	fSlow322 = (double(fcheckbox215) * fSlow31);
		double 	fSlow323 = (double(fcheckbox216) * fSlow35);
		double 	fSlow324 = (double(fcheckbox217) * fSlow39);
		double 	fSlow325 = (double(fcheckbox218) * fSlow43);
		double 	fSlow326 = (double(fcheckbox219) * fSlow47);
		double 	fSlow327 = (double(fcheckbox220) * fSlow51);
		double 	fSlow328 = (double(fcheckbox221) * fSlow55);
		double 	fSlow329 = (double(fcheckbox222) * fSlow59);
		double 	fSlow330 = (double(fcheckbox223) * fSlow63);
		double 	fSlow331 = (double(fslider75) * fSlow4);
		int 	iSlow332 = int((fConst4 * (fSlow67 * double(fslider76))));
		double 	fSlow333 = (fConst5 * (0 - (3.8224 * ((4.4e+02 * pow(2.0,(0.08333333333333333 * ((0.01 * ((fSlow69 * double(fslider77)) + 6000)) + -69.0)))) + -261.625977))));
		double 	fSlow334 = (1 - fSlow54);
		double 	fSlow335 = (double(fcheckbox224) * fSlow1);
		double 	fSlow336 = (double(fcheckbox225) * fSlow7);
		double 	fSlow337 = (double(fcheckbox226) * fSlow11);
		double 	fSlow338 = (double(fcheckbox227) * fSlow15);
		double 	fSlow339 = (double(fcheckbox228) * fSlow19);
		double 	fSlow340 = (double(fcheckbox229) * fSlow23);
		double 	fSlow341 = (double(fcheckbox230) * fSlow27);
		double 	fSlow342 = (double(fcheckbox231) * fSlow31);
		double 	fSlow343 = (double(fcheckbox232) * fSlow35);
		double 	fSlow344 = (double(fcheckbox233) * fSlow39);
		double 	fSlow345 = (double(fcheckbox234) * fSlow43);
		double 	fSlow346 = (double(fcheckbox235) * fSlow47);
		double 	fSlow347 = (double(fcheckbox236) * fSlow51);
		double 	fSlow348 = (double(fcheckbox237) * fSlow55);
		double 	fSlow349 = (double(fcheckbox238) * fSlow59);
		double 	fSlow350 = (double(fcheckbox239) * fSlow63);
		double 	fSlow351 = (double(fslider78) * fSlow4);
		int 	iSlow352 = int((fConst4 * (fSlow67 * double(fslider79))));
		double 	fSlow353 = (fConst5 * (0 - (3.8224 * ((4.4e+02 * pow(2.0,(0.08333333333333333 * ((0.01 * ((fSlow69 * double(fslider80)) + 6000)) + -69.0)))) + -261.625977))));
		double 	fSlow354 = (1 - fSlow58);
		double 	fSlow355 = (double(fslider81) * fSlow4);
		double 	fSlow356 = (double(fcheckbox240) * fSlow1);
		double 	fSlow357 = (double(fcheckbox241) * fSlow7);
		double 	fSlow358 = (double(fcheckbox242) * fSlow11);
		double 	fSlow359 = (double(fcheckbox243) * fSlow15);
		double 	fSlow360 = (double(fcheckbox244) * fSlow19);
		double 	fSlow361 = (double(fcheckbox245) * fSlow23);
		double 	fSlow362 = (double(fcheckbox246) * fSlow27);
		double 	fSlow363 = (double(fcheckbox247) * fSlow31);
		double 	fSlow364 = (double(fcheckbox248) * fSlow35);
		double 	fSlow365 = (double(fcheckbox249) * fSlow39);
		double 	fSlow366 = (double(fcheckbox250) * fSlow43);
		double 	fSlow367 = (double(fcheckbox251) * fSlow47);
		double 	fSlow368 = (double(fcheckbox252) * fSlow51);
		double 	fSlow369 = (double(fcheckbox253) * fSlow55);
		double 	fSlow370 = (double(fcheckbox254) * fSlow59);
		double 	fSlow371 = (double(fcheckbox255) * fSlow63);
		int 	iSlow372 = int((fConst4 * (fSlow67 * double(fslider82))));
		double 	fSlow373 = (fConst5 * (0 - (3.8224 * ((4.4e+02 * pow(2.0,(0.08333333333333333 * ((0.01 * ((double(fslider83) * fSlow69) + 6000)) + -69.0)))) + -261.625977))));
		double 	fSlow374 = (1 - fSlow62);
		double 	fSlow375 = (double(fslider84) * fSlow4);
		double 	fSlow376 = (double(fslider85) * fSlow4);
		double 	fSlow377 = (double(fslider86) * fSlow4);
		double 	fSlow378 = (double(fslider87) * fSlow4);
		double 	fSlow379 = (double(fslider88) * fSlow4);
		double 	fSlow380 = (double(fslider89) * fSlow4);
		double 	fSlow381 = (double(fslider90) * fSlow4);
		double 	fSlow382 = (double(fslider91) * fSlow4);
		double 	fSlow383 = (double(fslider92) * fSlow4);
		double 	fSlow384 = (double(fslider93) * fSlow4);
		double 	fSlow385 = (double(fslider94) * fSlow4);
		double 	fSlow386 = (double(fslider95) * fSlow4);
		double 	fSlow387 = (double(fslider96) * fSlow4);
		double 	fSlow388 = (double(fslider97) * fSlow4);
		double 	fSlow389 = (double(fslider98) * fSlow4);
		double 	fSlow390 = (double(fslider99) * fSlow4);
		FAUSTFLOAT* input0 = input[0];
		FAUSTFLOAT* input1 = input[1];
		FAUSTFLOAT* input2 = input[2];
		FAUSTFLOAT* input3 = input[3];
		FAUSTFLOAT* input4 = input[4];
		FAUSTFLOAT* input5 = input[5];
		FAUSTFLOAT* input6 = input[6];
		FAUSTFLOAT* input7 = input[7];
		FAUSTFLOAT* input8 = input[8];
		FAUSTFLOAT* input9 = input[9];
		FAUSTFLOAT* input10 = input[10];
		FAUSTFLOAT* input11 = input[11];
		FAUSTFLOAT* input12 = input[12];
		FAUSTFLOAT* input13 = input[13];
		FAUSTFLOAT* input14 = input[14];
		FAUSTFLOAT* input15 = input[15];
		FAUSTFLOAT* output0 = output[0];
		FAUSTFLOAT* output1 = output[1];
		FAUSTFLOAT* output2 = output[2];
		FAUSTFLOAT* output3 = output[3];
		FAUSTFLOAT* output4 = output[4];
		FAUSTFLOAT* output5 = output[5];
		FAUSTFLOAT* output6 = output[6];
		FAUSTFLOAT* output7 = output[7];
		FAUSTFLOAT* output8 = output[8];
		FAUSTFLOAT* output9 = output[9];
		FAUSTFLOAT* output10 = output[10];
		FAUSTFLOAT* output11 = output[11];
		FAUSTFLOAT* output12 = output[12];
		FAUSTFLOAT* output13 = output[13];
		FAUSTFLOAT* output14 = output[14];
		FAUSTFLOAT* output15 = output[15];
		for (int i=0; i<count; i++) {
			fRec17[0] = (fConst2 + (fRec17[1] - floor((fConst2 + fRec17[1]))));
			double fTemp0 = (65536.0 * (fRec17[0] - floor(fRec17[0])));
			int iTemp1 = int(fTemp0);
			double fTemp2 = ftbl0[iTemp1];
			double fTemp3 = ((fTemp2 + ((fTemp0 - floor(fTemp0)) * (ftbl0[((iTemp1 + 1) % 65536)] - fTemp2))) + 1.0);
			fVec0[0] = fTemp3;
			fRec18[0] = (fSlow5 + (fSlow3 * fRec18[1]));
			double fTemp4 = (fRec0[1] * fRec18[0]);
			fRec19[0] = (fSlow9 + (fSlow3 * fRec19[1]));
			double fTemp5 = (fRec1[1] * fRec19[0]);
			fRec20[0] = (fSlow13 + (fSlow3 * fRec20[1]));
			double fTemp6 = (fRec2[1] * fRec20[0]);
			fRec21[0] = (fSlow17 + (fSlow3 * fRec21[1]));
			double fTemp7 = (fRec3[1] * fRec21[0]);
			fRec22[0] = (fSlow21 + (fSlow3 * fRec22[1]));
			double fTemp8 = (fRec4[1] * fRec22[0]);
			fRec23[0] = (fSlow25 + (fSlow3 * fRec23[1]));
			double fTemp9 = (fRec5[1] * fRec23[0]);
			fRec24[0] = (fSlow29 + (fSlow3 * fRec24[1]));
			double fTemp10 = (fRec6[1] * fRec24[0]);
			fRec25[0] = (fSlow33 + (fSlow3 * fRec25[1]));
			double fTemp11 = (fRec7[1] * fRec25[0]);
			fRec26[0] = (fSlow37 + (fSlow3 * fRec26[1]));
			double fTemp12 = (fRec8[1] * fRec26[0]);
			fRec27[0] = (fSlow41 + (fSlow3 * fRec27[1]));
			double fTemp13 = (fRec9[1] * fRec27[0]);
			fRec28[0] = (fSlow45 + (fSlow3 * fRec28[1]));
			double fTemp14 = (fRec10[1] * fRec28[0]);
			fRec29[0] = (fSlow49 + (fSlow3 * fRec29[1]));
			double fTemp15 = (fRec11[1] * fRec29[0]);
			fRec30[0] = (fSlow53 + (fSlow3 * fRec30[1]));
			double fTemp16 = (fRec12[1] * fRec30[0]);
			fRec31[0] = (fSlow57 + (fSlow3 * fRec31[1]));
			double fTemp17 = (fRec13[1] * fRec31[0]);
			fRec32[0] = (fSlow61 + (fSlow3 * fRec32[1]));
			double fTemp18 = (fRec14[1] * fRec32[0]);
			fRec33[0] = (fSlow65 + (fSlow3 * fRec33[1]));
			double fTemp19 = (fRec15[1] * fRec33[0]);
			fRec34[0] = (fSlow66 + (fSlow3 * fRec34[1]));
			double fTemp20 = (((((((((((((((((fSlow2 * fTemp4) + (fSlow8 * fTemp5)) + (fSlow12 * fTemp6)) + (fSlow16 * fTemp7)) + (fSlow20 * fTemp8)) + (fSlow24 * fTemp9)) + (fSlow28 * fTemp10)) + (fSlow32 * fTemp11)) + (fSlow36 * fTemp12)) + (fSlow40 * fTemp13)) + (fSlow44 * fTemp14)) + (fSlow48 * fTemp15)) + (fSlow52 * fTemp16)) + (fSlow56 * fTemp17)) + (fSlow60 * fTemp18)) + (fSlow64 * fTemp19)) + ((double)input0[i] * fRec34[0]));
			fVec1[IOTA&1048575] = fTemp20;
			double fTemp21 = (0.5 * fVec0[0]);
			int iTemp22 = ((fTemp21 > 0.001) * ((0.5 * fVec0[1]) <= 0.001));
			int iTemp23 = (1 - iTemp22);
			iRec35[0] = ((iRec35[1] * iTemp23) + (iSlow68 * iTemp22));
			double fTemp24 = (1 - fTemp21);
			fVec2[0] = fTemp24;
			int iTemp25 = ((fVec2[0] > 0.001) * (fVec2[1] <= 0.001));
			int iTemp26 = (1 - iTemp25);
			iRec36[0] = ((iRec36[1] * iTemp26) + (iSlow68 * iTemp25));
			double fTemp27 = ((0.5 * (fVec0[0] * fVec1[(IOTA-int((int(iRec35[0]) & 1048575)))&1048575])) + (fVec2[0] * fVec1[(IOTA-int((int(iRec36[0]) & 1048575)))&1048575]));
			int iTemp28 = (fTemp27 > 1);
			int iTemp29 = (fTemp27 < -1);
			double fTemp30 = ((iTemp28 + ((fTemp27 * (1 - iTemp29)) * (1 - iTemp28))) - iTemp29);
			double fTemp31 = (fSlow0 * fTemp30);
			fVec3[IOTA&262143] = fTemp31;
			fVec4[0] = fSlow73;
			double fTemp32 = ((int((fSlow73 != fVec4[1])))?fConst6:(fRec38[1] + -1));
			fRec38[0] = fTemp32;
			fRec39[0] = ((int((fTemp32 <= 0)))?fSlow73:(fRec39[1] + ((fSlow73 - fRec39[1]) / fTemp32)));
			double fTemp33 = double(fRec39[0]);
			double fTemp34 = (fRec37[1] + (fSlow70 / fTemp33));
			fRec37[0] = (fTemp34 - floor(fTemp34));
			double fTemp35 = (fRec37[0] - floor(fRec37[0]));
			fVec5[0] = fTemp35;
			int iTemp36 = (fVec5[0] > 0.001);
			int iTemp37 = (fVec5[1] <= 0.001);
			fRec40[0] = ((fRec40[1] * (1 - (iTemp36 * iTemp37))) + ((fRec39[0] * iTemp36) * iTemp37));
			double fTemp38 = (fConst4 * (fVec5[0] * fRec40[0]));
			int iTemp39 = int(fTemp38);
			double fTemp40 = floor(fTemp38);
			double fTemp41 = (0.5 * fVec5[0]);
			double fTemp42 = (65536.0 * (fTemp41 - floor(fTemp41)));
			int iTemp43 = int(fTemp42);
			double fTemp44 = ftbl0[iTemp43];
			double fTemp45 = (fRec37[0] + (0.25 - floor((fRec37[0] + 0.25))));
			fVec6[0] = fTemp45;
			int iTemp46 = (fVec6[0] > 0.001);
			int iTemp47 = (fVec6[1] <= 0.001);
			fRec41[0] = ((fRec41[1] * (1 - (iTemp46 * iTemp47))) + ((fRec39[0] * iTemp46) * iTemp47));
			double fTemp48 = (fConst4 * (fVec6[0] * fRec41[0]));
			int iTemp49 = int(fTemp48);
			double fTemp50 = floor(fTemp48);
			double fTemp51 = (0.5 * fVec6[0]);
			double fTemp52 = (65536.0 * (fTemp51 - floor(fTemp51)));
			int iTemp53 = int(fTemp52);
			double fTemp54 = ftbl0[iTemp53];
			double fTemp55 = (fRec37[0] + (0.5 - floor((fRec37[0] + 0.5))));
			fVec7[0] = fTemp55;
			int iTemp56 = (fVec7[0] > 0.001);
			int iTemp57 = (fVec7[1] <= 0.001);
			fRec42[0] = ((fRec42[1] * (1 - (iTemp56 * iTemp57))) + ((fRec39[0] * iTemp56) * iTemp57));
			double fTemp58 = (fConst4 * (fVec7[0] * fRec42[0]));
			int iTemp59 = int(fTemp58);
			double fTemp60 = floor(fTemp58);
			double fTemp61 = (0.5 * fVec7[0]);
			double fTemp62 = (65536.0 * (fTemp61 - floor(fTemp61)));
			int iTemp63 = int(fTemp62);
			double fTemp64 = ftbl0[iTemp63];
			double fTemp65 = (fRec37[0] + (0.75 - floor((fRec37[0] + 0.75))));
			fVec8[0] = fTemp65;
			int iTemp66 = (fVec8[0] > 0.001);
			int iTemp67 = (fVec8[1] <= 0.001);
			fRec43[0] = ((fRec43[1] * (1 - (iTemp66 * iTemp67))) + ((fRec39[0] * iTemp66) * iTemp67));
			double fTemp68 = (fConst4 * (fVec8[0] * fRec43[0]));
			int iTemp69 = int(fTemp68);
			double fTemp70 = floor(fTemp68);
			double fTemp71 = (0.5 * fVec8[0]);
			double fTemp72 = (65536.0 * (fTemp71 - floor(fTemp71)));
			int iTemp73 = int(fTemp72);
			double fTemp74 = ftbl0[iTemp73];
			fRec0[0] = ((0.5 * ((((((fVec3[(IOTA-int((iTemp39 & 262143)))&262143] * (fTemp40 + (1 - fTemp38))) + ((fTemp38 - fTemp40) * fVec3[(IOTA-int((int((iTemp39 + 1)) & 262143)))&262143])) * (fTemp44 + ((fTemp42 - floor(fTemp42)) * (ftbl0[((iTemp43 + 1) % 65536)] - fTemp44)))) + (((fVec3[(IOTA-int((iTemp49 & 262143)))&262143] * (fTemp50 + (1 - fTemp48))) + ((fTemp48 - fTemp50) * fVec3[(IOTA-int((int((iTemp49 + 1)) & 262143)))&262143])) * (fTemp54 + ((fTemp52 - floor(fTemp52)) * (ftbl0[((iTemp53 + 1) % 65536)] - fTemp54))))) + (((fVec3[(IOTA-int((iTemp59 & 262143)))&262143] * (fTemp60 + (1 - fTemp58))) + ((fTemp58 - fTemp60) * fVec3[(IOTA-int((int((iTemp59 + 1)) & 262143)))&262143])) * (fTemp64 + ((fTemp62 - floor(fTemp62)) * (ftbl0[((iTemp63 + 1) % 65536)] - fTemp64))))) + (((fVec3[(IOTA-int((iTemp69 & 262143)))&262143] * (fTemp70 + (1 - fTemp68))) + ((fTemp68 - fTemp70) * fVec3[(IOTA-int((int((iTemp69 + 1)) & 262143)))&262143])) * (fTemp74 + ((fTemp72 - floor(fTemp72)) * (ftbl0[((iTemp73 + 1) % 65536)] - fTemp74)))))) + (fSlow74 * fTemp30));
			fRec44[0] = (fSlow91 + (fSlow3 * fRec44[1]));
			double fTemp75 = (((((((((((((((((fSlow75 * fTemp4) + (fSlow76 * fTemp5)) + (fSlow77 * fTemp6)) + (fSlow78 * fTemp7)) + (fSlow79 * fTemp8)) + (fSlow80 * fTemp9)) + (fSlow81 * fTemp10)) + (fSlow82 * fTemp11)) + (fSlow83 * fTemp12)) + (fSlow84 * fTemp13)) + (fSlow85 * fTemp14)) + (fSlow86 * fTemp15)) + (fSlow87 * fTemp16)) + (fSlow88 * fTemp17)) + (fSlow89 * fTemp18)) + (fSlow90 * fTemp19)) + ((double)input1[i] * fRec44[0]));
			fVec9[IOTA&1048575] = fTemp75;
			iRec45[0] = ((iSlow92 * iTemp22) + (iTemp23 * iRec45[1]));
			iRec46[0] = ((iSlow92 * iTemp25) + (iTemp26 * iRec46[1]));
			double fTemp76 = ((0.5 * (fVec0[0] * fVec9[(IOTA-int((int(iRec45[0]) & 1048575)))&1048575])) + (fVec2[0] * fVec9[(IOTA-int((int(iRec46[0]) & 1048575)))&1048575]));
			int iTemp77 = (fTemp76 > 1);
			int iTemp78 = (fTemp76 < -1);
			double fTemp79 = ((iTemp77 + ((fTemp76 * (1 - iTemp78)) * (1 - iTemp77))) - iTemp78);
			double fTemp80 = (fSlow6 * fTemp79);
			fVec10[IOTA&262143] = fTemp80;
			double fTemp81 = (fRec47[1] + (fSlow93 / fTemp33));
			fRec47[0] = (fTemp81 - floor(fTemp81));
			double fTemp82 = (fRec47[0] - floor(fRec47[0]));
			fVec11[0] = fTemp82;
			int iTemp83 = (fVec11[0] > 0.001);
			int iTemp84 = (fVec11[1] <= 0.001);
			fRec48[0] = ((fRec48[1] * (1 - (iTemp83 * iTemp84))) + ((fRec39[0] * iTemp83) * iTemp84));
			double fTemp85 = (fConst4 * (fVec11[0] * fRec48[0]));
			int iTemp86 = int(fTemp85);
			double fTemp87 = floor(fTemp85);
			double fTemp88 = (0.5 * fVec11[0]);
			double fTemp89 = (65536.0 * (fTemp88 - floor(fTemp88)));
			int iTemp90 = int(fTemp89);
			double fTemp91 = ftbl0[iTemp90];
			double fTemp92 = (fRec47[0] + (0.25 - floor((fRec47[0] + 0.25))));
			fVec12[0] = fTemp92;
			int iTemp93 = (fVec12[0] > 0.001);
			int iTemp94 = (fVec12[1] <= 0.001);
			fRec49[0] = ((fRec49[1] * (1 - (iTemp93 * iTemp94))) + ((fRec39[0] * iTemp93) * iTemp94));
			double fTemp95 = (fConst4 * (fVec12[0] * fRec49[0]));
			int iTemp96 = int(fTemp95);
			double fTemp97 = floor(fTemp95);
			double fTemp98 = (0.5 * fVec12[0]);
			double fTemp99 = (65536.0 * (fTemp98 - floor(fTemp98)));
			int iTemp100 = int(fTemp99);
			double fTemp101 = ftbl0[iTemp100];
			double fTemp102 = (fRec47[0] + (0.5 - floor((fRec47[0] + 0.5))));
			fVec13[0] = fTemp102;
			int iTemp103 = (fVec13[0] > 0.001);
			int iTemp104 = (fVec13[1] <= 0.001);
			fRec50[0] = ((fRec50[1] * (1 - (iTemp103 * iTemp104))) + ((fRec39[0] * iTemp103) * iTemp104));
			double fTemp105 = (fConst4 * (fVec13[0] * fRec50[0]));
			int iTemp106 = int(fTemp105);
			double fTemp107 = floor(fTemp105);
			double fTemp108 = (0.5 * fVec13[0]);
			double fTemp109 = (65536.0 * (fTemp108 - floor(fTemp108)));
			int iTemp110 = int(fTemp109);
			double fTemp111 = ftbl0[iTemp110];
			double fTemp112 = (fRec47[0] + (0.75 - floor((fRec47[0] + 0.75))));
			fVec14[0] = fTemp112;
			int iTemp113 = (fVec14[0] > 0.001);
			int iTemp114 = (fVec14[1] <= 0.001);
			fRec51[0] = ((fRec51[1] * (1 - (iTemp113 * iTemp114))) + ((fRec39[0] * iTemp113) * iTemp114));
			double fTemp115 = (fConst4 * (fVec14[0] * fRec51[0]));
			int iTemp116 = int(fTemp115);
			double fTemp117 = floor(fTemp115);
			double fTemp118 = (0.5 * fVec14[0]);
			double fTemp119 = (65536.0 * (fTemp118 - floor(fTemp118)));
			int iTemp120 = int(fTemp119);
			double fTemp121 = ftbl0[iTemp120];
			fRec1[0] = ((0.5 * ((((((fVec10[(IOTA-int((iTemp86 & 262143)))&262143] * (fTemp87 + (1 - fTemp85))) + ((fTemp85 - fTemp87) * fVec10[(IOTA-int((int((iTemp86 + 1)) & 262143)))&262143])) * (fTemp91 + ((fTemp89 - floor(fTemp89)) * (ftbl0[((iTemp90 + 1) % 65536)] - fTemp91)))) + (((fVec10[(IOTA-int((iTemp96 & 262143)))&262143] * (fTemp97 + (1 - fTemp95))) + ((fTemp95 - fTemp97) * fVec10[(IOTA-int((int((iTemp96 + 1)) & 262143)))&262143])) * (fTemp101 + ((fTemp99 - floor(fTemp99)) * (ftbl0[((iTemp100 + 1) % 65536)] - fTemp101))))) + (((fVec10[(IOTA-int((iTemp106 & 262143)))&262143] * (fTemp107 + (1 - fTemp105))) + ((fTemp105 - fTemp107) * fVec10[(IOTA-int((int((iTemp106 + 1)) & 262143)))&262143])) * (fTemp111 + ((fTemp109 - floor(fTemp109)) * (ftbl0[((iTemp110 + 1) % 65536)] - fTemp111))))) + (((fVec10[(IOTA-int((iTemp116 & 262143)))&262143] * (fTemp117 + (1 - fTemp115))) + ((fTemp115 - fTemp117) * fVec10[(IOTA-int((int((iTemp116 + 1)) & 262143)))&262143])) * (fTemp121 + ((fTemp119 - floor(fTemp119)) * (ftbl0[((iTemp120 + 1) % 65536)] - fTemp121)))))) + (fSlow94 * fTemp79));
			fRec52[0] = (fSlow111 + (fSlow3 * fRec52[1]));
			double fTemp122 = (((((((((((((((((fSlow95 * fTemp4) + (fSlow96 * fTemp5)) + (fSlow97 * fTemp6)) + (fSlow98 * fTemp7)) + (fSlow99 * fTemp8)) + (fSlow100 * fTemp9)) + (fSlow101 * fTemp10)) + (fSlow102 * fTemp11)) + (fSlow103 * fTemp12)) + (fSlow104 * fTemp13)) + (fSlow105 * fTemp14)) + (fSlow106 * fTemp15)) + (fSlow107 * fTemp16)) + (fSlow108 * fTemp17)) + (fSlow109 * fTemp18)) + (fSlow110 * fTemp19)) + ((double)input2[i] * fRec52[0]));
			fVec15[IOTA&1048575] = fTemp122;
			iRec53[0] = ((iSlow112 * iTemp22) + (iTemp23 * iRec53[1]));
			iRec54[0] = ((iSlow112 * iTemp25) + (iTemp26 * iRec54[1]));
			double fTemp123 = ((0.5 * (fVec0[0] * fVec15[(IOTA-int((int(iRec53[0]) & 1048575)))&1048575])) + (fVec2[0] * fVec15[(IOTA-int((int(iRec54[0]) & 1048575)))&1048575]));
			int iTemp124 = (fTemp123 > 1);
			int iTemp125 = (fTemp123 < -1);
			double fTemp126 = ((iTemp124 + ((fTemp123 * (1 - iTemp125)) * (1 - iTemp124))) - iTemp125);
			double fTemp127 = (fSlow10 * fTemp126);
			fVec16[IOTA&262143] = fTemp127;
			double fTemp128 = (fRec55[1] + (fSlow113 / fTemp33));
			fRec55[0] = (fTemp128 - floor(fTemp128));
			double fTemp129 = (fRec55[0] - floor(fRec55[0]));
			fVec17[0] = fTemp129;
			int iTemp130 = (fVec17[0] > 0.001);
			int iTemp131 = (fVec17[1] <= 0.001);
			fRec56[0] = ((fRec56[1] * (1 - (iTemp130 * iTemp131))) + ((fRec39[0] * iTemp130) * iTemp131));
			double fTemp132 = (fConst4 * (fVec17[0] * fRec56[0]));
			int iTemp133 = int(fTemp132);
			double fTemp134 = floor(fTemp132);
			double fTemp135 = (0.5 * fVec17[0]);
			double fTemp136 = (65536.0 * (fTemp135 - floor(fTemp135)));
			int iTemp137 = int(fTemp136);
			double fTemp138 = ftbl0[iTemp137];
			double fTemp139 = (fRec55[0] + (0.25 - floor((fRec55[0] + 0.25))));
			fVec18[0] = fTemp139;
			int iTemp140 = (fVec18[0] > 0.001);
			int iTemp141 = (fVec18[1] <= 0.001);
			fRec57[0] = ((fRec57[1] * (1 - (iTemp140 * iTemp141))) + ((fRec39[0] * iTemp140) * iTemp141));
			double fTemp142 = (fConst4 * (fVec18[0] * fRec57[0]));
			int iTemp143 = int(fTemp142);
			double fTemp144 = floor(fTemp142);
			double fTemp145 = (0.5 * fVec18[0]);
			double fTemp146 = (65536.0 * (fTemp145 - floor(fTemp145)));
			int iTemp147 = int(fTemp146);
			double fTemp148 = ftbl0[iTemp147];
			double fTemp149 = (fRec55[0] + (0.5 - floor((fRec55[0] + 0.5))));
			fVec19[0] = fTemp149;
			int iTemp150 = (fVec19[0] > 0.001);
			int iTemp151 = (fVec19[1] <= 0.001);
			fRec58[0] = ((fRec58[1] * (1 - (iTemp150 * iTemp151))) + ((fRec39[0] * iTemp150) * iTemp151));
			double fTemp152 = (fConst4 * (fVec19[0] * fRec58[0]));
			int iTemp153 = int(fTemp152);
			double fTemp154 = floor(fTemp152);
			double fTemp155 = (0.5 * fVec19[0]);
			double fTemp156 = (65536.0 * (fTemp155 - floor(fTemp155)));
			int iTemp157 = int(fTemp156);
			double fTemp158 = ftbl0[iTemp157];
			double fTemp159 = (fRec55[0] + (0.75 - floor((fRec55[0] + 0.75))));
			fVec20[0] = fTemp159;
			int iTemp160 = (fVec20[0] > 0.001);
			int iTemp161 = (fVec20[1] <= 0.001);
			fRec59[0] = ((fRec59[1] * (1 - (iTemp160 * iTemp161))) + ((fRec39[0] * iTemp160) * iTemp161));
			double fTemp162 = (fConst4 * (fVec20[0] * fRec59[0]));
			int iTemp163 = int(fTemp162);
			double fTemp164 = floor(fTemp162);
			double fTemp165 = (0.5 * fVec20[0]);
			double fTemp166 = (65536.0 * (fTemp165 - floor(fTemp165)));
			int iTemp167 = int(fTemp166);
			double fTemp168 = ftbl0[iTemp167];
			fRec2[0] = ((0.5 * ((((((fVec16[(IOTA-int((iTemp133 & 262143)))&262143] * (fTemp134 + (1 - fTemp132))) + ((fTemp132 - fTemp134) * fVec16[(IOTA-int((int((iTemp133 + 1)) & 262143)))&262143])) * (fTemp138 + ((fTemp136 - floor(fTemp136)) * (ftbl0[((iTemp137 + 1) % 65536)] - fTemp138)))) + (((fVec16[(IOTA-int((iTemp143 & 262143)))&262143] * (fTemp144 + (1 - fTemp142))) + ((fTemp142 - fTemp144) * fVec16[(IOTA-int((int((iTemp143 + 1)) & 262143)))&262143])) * (fTemp148 + ((fTemp146 - floor(fTemp146)) * (ftbl0[((iTemp147 + 1) % 65536)] - fTemp148))))) + (((fVec16[(IOTA-int((iTemp153 & 262143)))&262143] * (fTemp154 + (1 - fTemp152))) + ((fTemp152 - fTemp154) * fVec16[(IOTA-int((int((iTemp153 + 1)) & 262143)))&262143])) * (fTemp158 + ((fTemp156 - floor(fTemp156)) * (ftbl0[((iTemp157 + 1) % 65536)] - fTemp158))))) + (((fVec16[(IOTA-int((iTemp163 & 262143)))&262143] * (fTemp164 + (1 - fTemp162))) + ((fTemp162 - fTemp164) * fVec16[(IOTA-int((int((iTemp163 + 1)) & 262143)))&262143])) * (fTemp168 + ((fTemp166 - floor(fTemp166)) * (ftbl0[((iTemp167 + 1) % 65536)] - fTemp168)))))) + (fSlow114 * fTemp126));
			fRec60[0] = (fSlow131 + (fSlow3 * fRec60[1]));
			double fTemp169 = (((((((((((((((((fSlow115 * fTemp4) + (fSlow116 * fTemp5)) + (fSlow117 * fTemp6)) + (fSlow118 * fTemp7)) + (fSlow119 * fTemp8)) + (fSlow120 * fTemp9)) + (fSlow121 * fTemp10)) + (fSlow122 * fTemp11)) + (fSlow123 * fTemp12)) + (fSlow124 * fTemp13)) + (fSlow125 * fTemp14)) + (fSlow126 * fTemp15)) + (fSlow127 * fTemp16)) + (fSlow128 * fTemp17)) + (fSlow129 * fTemp18)) + (fSlow130 * fTemp19)) + ((double)input3[i] * fRec60[0]));
			fVec21[IOTA&1048575] = fTemp169;
			iRec61[0] = ((iSlow132 * iTemp22) + (iTemp23 * iRec61[1]));
			iRec62[0] = ((iSlow132 * iTemp25) + (iTemp26 * iRec62[1]));
			double fTemp170 = ((0.5 * (fVec0[0] * fVec21[(IOTA-int((int(iRec61[0]) & 1048575)))&1048575])) + (fVec2[0] * fVec21[(IOTA-int((int(iRec62[0]) & 1048575)))&1048575]));
			int iTemp171 = (fTemp170 > 1);
			int iTemp172 = (fTemp170 < -1);
			double fTemp173 = ((iTemp171 + ((fTemp170 * (1 - iTemp172)) * (1 - iTemp171))) - iTemp172);
			double fTemp174 = (fSlow14 * fTemp173);
			fVec22[IOTA&262143] = fTemp174;
			double fTemp175 = (fRec63[1] + (fSlow133 / fTemp33));
			fRec63[0] = (fTemp175 - floor(fTemp175));
			double fTemp176 = (fRec63[0] - floor(fRec63[0]));
			fVec23[0] = fTemp176;
			int iTemp177 = (fVec23[0] > 0.001);
			int iTemp178 = (fVec23[1] <= 0.001);
			fRec64[0] = ((fRec64[1] * (1 - (iTemp177 * iTemp178))) + ((fRec39[0] * iTemp177) * iTemp178));
			double fTemp179 = (fConst4 * (fVec23[0] * fRec64[0]));
			int iTemp180 = int(fTemp179);
			double fTemp181 = floor(fTemp179);
			double fTemp182 = (0.5 * fVec23[0]);
			double fTemp183 = (65536.0 * (fTemp182 - floor(fTemp182)));
			int iTemp184 = int(fTemp183);
			double fTemp185 = ftbl0[iTemp184];
			double fTemp186 = (fRec63[0] + (0.25 - floor((fRec63[0] + 0.25))));
			fVec24[0] = fTemp186;
			int iTemp187 = (fVec24[0] > 0.001);
			int iTemp188 = (fVec24[1] <= 0.001);
			fRec65[0] = ((fRec65[1] * (1 - (iTemp187 * iTemp188))) + ((fRec39[0] * iTemp187) * iTemp188));
			double fTemp189 = (fConst4 * (fVec24[0] * fRec65[0]));
			int iTemp190 = int(fTemp189);
			double fTemp191 = floor(fTemp189);
			double fTemp192 = (0.5 * fVec24[0]);
			double fTemp193 = (65536.0 * (fTemp192 - floor(fTemp192)));
			int iTemp194 = int(fTemp193);
			double fTemp195 = ftbl0[iTemp194];
			double fTemp196 = (fRec63[0] + (0.5 - floor((fRec63[0] + 0.5))));
			fVec25[0] = fTemp196;
			int iTemp197 = (fVec25[0] > 0.001);
			int iTemp198 = (fVec25[1] <= 0.001);
			fRec66[0] = ((fRec66[1] * (1 - (iTemp197 * iTemp198))) + ((fRec39[0] * iTemp197) * iTemp198));
			double fTemp199 = (fConst4 * (fVec25[0] * fRec66[0]));
			int iTemp200 = int(fTemp199);
			double fTemp201 = floor(fTemp199);
			double fTemp202 = (0.5 * fVec25[0]);
			double fTemp203 = (65536.0 * (fTemp202 - floor(fTemp202)));
			int iTemp204 = int(fTemp203);
			double fTemp205 = ftbl0[iTemp204];
			double fTemp206 = (fRec63[0] + (0.75 - floor((fRec63[0] + 0.75))));
			fVec26[0] = fTemp206;
			int iTemp207 = (fVec26[0] > 0.001);
			int iTemp208 = (fVec26[1] <= 0.001);
			fRec67[0] = ((fRec67[1] * (1 - (iTemp207 * iTemp208))) + ((fRec39[0] * iTemp207) * iTemp208));
			double fTemp209 = (fConst4 * (fVec26[0] * fRec67[0]));
			int iTemp210 = int(fTemp209);
			double fTemp211 = floor(fTemp209);
			double fTemp212 = (0.5 * fVec26[0]);
			double fTemp213 = (65536.0 * (fTemp212 - floor(fTemp212)));
			int iTemp214 = int(fTemp213);
			double fTemp215 = ftbl0[iTemp214];
			fRec3[0] = ((0.5 * ((((((fVec22[(IOTA-int((iTemp180 & 262143)))&262143] * (fTemp181 + (1 - fTemp179))) + ((fTemp179 - fTemp181) * fVec22[(IOTA-int((int((iTemp180 + 1)) & 262143)))&262143])) * (fTemp185 + ((fTemp183 - floor(fTemp183)) * (ftbl0[((iTemp184 + 1) % 65536)] - fTemp185)))) + (((fVec22[(IOTA-int((iTemp190 & 262143)))&262143] * (fTemp191 + (1 - fTemp189))) + ((fTemp189 - fTemp191) * fVec22[(IOTA-int((int((iTemp190 + 1)) & 262143)))&262143])) * (fTemp195 + ((fTemp193 - floor(fTemp193)) * (ftbl0[((iTemp194 + 1) % 65536)] - fTemp195))))) + (((fVec22[(IOTA-int((iTemp200 & 262143)))&262143] * (fTemp201 + (1 - fTemp199))) + ((fTemp199 - fTemp201) * fVec22[(IOTA-int((int((iTemp200 + 1)) & 262143)))&262143])) * (fTemp205 + ((fTemp203 - floor(fTemp203)) * (ftbl0[((iTemp204 + 1) % 65536)] - fTemp205))))) + (((fVec22[(IOTA-int((iTemp210 & 262143)))&262143] * (fTemp211 + (1 - fTemp209))) + ((fTemp209 - fTemp211) * fVec22[(IOTA-int((int((iTemp210 + 1)) & 262143)))&262143])) * (fTemp215 + ((fTemp213 - floor(fTemp213)) * (ftbl0[((iTemp214 + 1) % 65536)] - fTemp215)))))) + (fSlow134 * fTemp173));
			fRec68[0] = (fSlow151 + (fSlow3 * fRec68[1]));
			double fTemp216 = (((((((((((((((((fSlow135 * fTemp4) + (fSlow136 * fTemp5)) + (fSlow137 * fTemp6)) + (fSlow138 * fTemp7)) + (fSlow139 * fTemp8)) + (fSlow140 * fTemp9)) + (fSlow141 * fTemp10)) + (fSlow142 * fTemp11)) + (fSlow143 * fTemp12)) + (fSlow144 * fTemp13)) + (fSlow145 * fTemp14)) + (fSlow146 * fTemp15)) + (fSlow147 * fTemp16)) + (fSlow148 * fTemp17)) + (fSlow149 * fTemp18)) + (fSlow150 * fTemp19)) + ((double)input4[i] * fRec68[0]));
			fVec27[IOTA&1048575] = fTemp216;
			iRec69[0] = ((iSlow152 * iTemp22) + (iTemp23 * iRec69[1]));
			iRec70[0] = ((iSlow152 * iTemp25) + (iTemp26 * iRec70[1]));
			double fTemp217 = ((0.5 * (fVec0[0] * fVec27[(IOTA-int((int(iRec69[0]) & 1048575)))&1048575])) + (fVec2[0] * fVec27[(IOTA-int((int(iRec70[0]) & 1048575)))&1048575]));
			int iTemp218 = (fTemp217 > 1);
			int iTemp219 = (fTemp217 < -1);
			double fTemp220 = ((iTemp218 + ((fTemp217 * (1 - iTemp219)) * (1 - iTemp218))) - iTemp219);
			double fTemp221 = (fSlow18 * fTemp220);
			fVec28[IOTA&262143] = fTemp221;
			double fTemp222 = (fRec71[1] + (fSlow153 / fTemp33));
			fRec71[0] = (fTemp222 - floor(fTemp222));
			double fTemp223 = (fRec71[0] - floor(fRec71[0]));
			fVec29[0] = fTemp223;
			int iTemp224 = (fVec29[0] > 0.001);
			int iTemp225 = (fVec29[1] <= 0.001);
			fRec72[0] = ((fRec72[1] * (1 - (iTemp224 * iTemp225))) + ((fRec39[0] * iTemp224) * iTemp225));
			double fTemp226 = (fConst4 * (fVec29[0] * fRec72[0]));
			int iTemp227 = int(fTemp226);
			double fTemp228 = floor(fTemp226);
			double fTemp229 = (0.5 * fVec29[0]);
			double fTemp230 = (65536.0 * (fTemp229 - floor(fTemp229)));
			int iTemp231 = int(fTemp230);
			double fTemp232 = ftbl0[iTemp231];
			double fTemp233 = (fRec71[0] + (0.25 - floor((fRec71[0] + 0.25))));
			fVec30[0] = fTemp233;
			int iTemp234 = (fVec30[0] > 0.001);
			int iTemp235 = (fVec30[1] <= 0.001);
			fRec73[0] = ((fRec73[1] * (1 - (iTemp234 * iTemp235))) + ((fRec39[0] * iTemp234) * iTemp235));
			double fTemp236 = (fConst4 * (fVec30[0] * fRec73[0]));
			int iTemp237 = int(fTemp236);
			double fTemp238 = floor(fTemp236);
			double fTemp239 = (0.5 * fVec30[0]);
			double fTemp240 = (65536.0 * (fTemp239 - floor(fTemp239)));
			int iTemp241 = int(fTemp240);
			double fTemp242 = ftbl0[iTemp241];
			double fTemp243 = (fRec71[0] + (0.5 - floor((fRec71[0] + 0.5))));
			fVec31[0] = fTemp243;
			int iTemp244 = (fVec31[0] > 0.001);
			int iTemp245 = (fVec31[1] <= 0.001);
			fRec74[0] = ((fRec74[1] * (1 - (iTemp244 * iTemp245))) + ((fRec39[0] * iTemp244) * iTemp245));
			double fTemp246 = (fConst4 * (fVec31[0] * fRec74[0]));
			int iTemp247 = int(fTemp246);
			double fTemp248 = floor(fTemp246);
			double fTemp249 = (0.5 * fVec31[0]);
			double fTemp250 = (65536.0 * (fTemp249 - floor(fTemp249)));
			int iTemp251 = int(fTemp250);
			double fTemp252 = ftbl0[iTemp251];
			double fTemp253 = (fRec71[0] + (0.75 - floor((fRec71[0] + 0.75))));
			fVec32[0] = fTemp253;
			int iTemp254 = (fVec32[0] > 0.001);
			int iTemp255 = (fVec32[1] <= 0.001);
			fRec75[0] = ((fRec75[1] * (1 - (iTemp254 * iTemp255))) + ((fRec39[0] * iTemp254) * iTemp255));
			double fTemp256 = (fConst4 * (fVec32[0] * fRec75[0]));
			int iTemp257 = int(fTemp256);
			double fTemp258 = floor(fTemp256);
			double fTemp259 = (0.5 * fVec32[0]);
			double fTemp260 = (65536.0 * (fTemp259 - floor(fTemp259)));
			int iTemp261 = int(fTemp260);
			double fTemp262 = ftbl0[iTemp261];
			fRec4[0] = ((0.5 * ((((((fVec28[(IOTA-int((iTemp227 & 262143)))&262143] * (fTemp228 + (1 - fTemp226))) + ((fTemp226 - fTemp228) * fVec28[(IOTA-int((int((iTemp227 + 1)) & 262143)))&262143])) * (fTemp232 + ((fTemp230 - floor(fTemp230)) * (ftbl0[((iTemp231 + 1) % 65536)] - fTemp232)))) + (((fVec28[(IOTA-int((iTemp237 & 262143)))&262143] * (fTemp238 + (1 - fTemp236))) + ((fTemp236 - fTemp238) * fVec28[(IOTA-int((int((iTemp237 + 1)) & 262143)))&262143])) * (fTemp242 + ((fTemp240 - floor(fTemp240)) * (ftbl0[((iTemp241 + 1) % 65536)] - fTemp242))))) + (((fVec28[(IOTA-int((iTemp247 & 262143)))&262143] * (fTemp248 + (1 - fTemp246))) + ((fTemp246 - fTemp248) * fVec28[(IOTA-int((int((iTemp247 + 1)) & 262143)))&262143])) * (fTemp252 + ((fTemp250 - floor(fTemp250)) * (ftbl0[((iTemp251 + 1) % 65536)] - fTemp252))))) + (((fVec28[(IOTA-int((iTemp257 & 262143)))&262143] * (fTemp258 + (1 - fTemp256))) + ((fTemp256 - fTemp258) * fVec28[(IOTA-int((int((iTemp257 + 1)) & 262143)))&262143])) * (fTemp262 + ((fTemp260 - floor(fTemp260)) * (ftbl0[((iTemp261 + 1) % 65536)] - fTemp262)))))) + (fSlow154 * fTemp220));
			fRec76[0] = (fSlow171 + (fSlow3 * fRec76[1]));
			double fTemp263 = (((((((((((((((((fSlow155 * fTemp4) + (fSlow156 * fTemp5)) + (fSlow157 * fTemp6)) + (fSlow158 * fTemp7)) + (fSlow159 * fTemp8)) + (fSlow160 * fTemp9)) + (fSlow161 * fTemp10)) + (fSlow162 * fTemp11)) + (fSlow163 * fTemp12)) + (fSlow164 * fTemp13)) + (fSlow165 * fTemp14)) + (fSlow166 * fTemp15)) + (fSlow167 * fTemp16)) + (fSlow168 * fTemp17)) + (fSlow169 * fTemp18)) + (fSlow170 * fTemp19)) + ((double)input5[i] * fRec76[0]));
			fVec33[IOTA&1048575] = fTemp263;
			iRec77[0] = ((iSlow172 * iTemp22) + (iTemp23 * iRec77[1]));
			iRec78[0] = ((iSlow172 * iTemp25) + (iTemp26 * iRec78[1]));
			double fTemp264 = ((0.5 * (fVec0[0] * fVec33[(IOTA-int((int(iRec77[0]) & 1048575)))&1048575])) + (fVec2[0] * fVec33[(IOTA-int((int(iRec78[0]) & 1048575)))&1048575]));
			int iTemp265 = (fTemp264 > 1);
			int iTemp266 = (fTemp264 < -1);
			double fTemp267 = ((iTemp265 + ((fTemp264 * (1 - iTemp266)) * (1 - iTemp265))) - iTemp266);
			double fTemp268 = (fSlow22 * fTemp267);
			fVec34[IOTA&262143] = fTemp268;
			double fTemp269 = (fRec79[1] + (fSlow173 / fTemp33));
			fRec79[0] = (fTemp269 - floor(fTemp269));
			double fTemp270 = (fRec79[0] - floor(fRec79[0]));
			fVec35[0] = fTemp270;
			int iTemp271 = (fVec35[0] > 0.001);
			int iTemp272 = (fVec35[1] <= 0.001);
			fRec80[0] = ((fRec80[1] * (1 - (iTemp271 * iTemp272))) + ((fRec39[0] * iTemp271) * iTemp272));
			double fTemp273 = (fConst4 * (fVec35[0] * fRec80[0]));
			int iTemp274 = int(fTemp273);
			double fTemp275 = floor(fTemp273);
			double fTemp276 = (0.5 * fVec35[0]);
			double fTemp277 = (65536.0 * (fTemp276 - floor(fTemp276)));
			int iTemp278 = int(fTemp277);
			double fTemp279 = ftbl0[iTemp278];
			double fTemp280 = (fRec79[0] + (0.25 - floor((fRec79[0] + 0.25))));
			fVec36[0] = fTemp280;
			int iTemp281 = (fVec36[0] > 0.001);
			int iTemp282 = (fVec36[1] <= 0.001);
			fRec81[0] = ((fRec81[1] * (1 - (iTemp281 * iTemp282))) + ((fRec39[0] * iTemp281) * iTemp282));
			double fTemp283 = (fConst4 * (fVec36[0] * fRec81[0]));
			int iTemp284 = int(fTemp283);
			double fTemp285 = floor(fTemp283);
			double fTemp286 = (0.5 * fVec36[0]);
			double fTemp287 = (65536.0 * (fTemp286 - floor(fTemp286)));
			int iTemp288 = int(fTemp287);
			double fTemp289 = ftbl0[iTemp288];
			double fTemp290 = (fRec79[0] + (0.5 - floor((fRec79[0] + 0.5))));
			fVec37[0] = fTemp290;
			int iTemp291 = (fVec37[0] > 0.001);
			int iTemp292 = (fVec37[1] <= 0.001);
			fRec82[0] = ((fRec82[1] * (1 - (iTemp291 * iTemp292))) + ((fRec39[0] * iTemp291) * iTemp292));
			double fTemp293 = (fConst4 * (fVec37[0] * fRec82[0]));
			int iTemp294 = int(fTemp293);
			double fTemp295 = floor(fTemp293);
			double fTemp296 = (0.5 * fVec37[0]);
			double fTemp297 = (65536.0 * (fTemp296 - floor(fTemp296)));
			int iTemp298 = int(fTemp297);
			double fTemp299 = ftbl0[iTemp298];
			double fTemp300 = (fRec79[0] + (0.75 - floor((fRec79[0] + 0.75))));
			fVec38[0] = fTemp300;
			int iTemp301 = (fVec38[0] > 0.001);
			int iTemp302 = (fVec38[1] <= 0.001);
			fRec83[0] = ((fRec83[1] * (1 - (iTemp301 * iTemp302))) + ((fRec39[0] * iTemp301) * iTemp302));
			double fTemp303 = (fConst4 * (fVec38[0] * fRec83[0]));
			int iTemp304 = int(fTemp303);
			double fTemp305 = floor(fTemp303);
			double fTemp306 = (0.5 * fVec38[0]);
			double fTemp307 = (65536.0 * (fTemp306 - floor(fTemp306)));
			int iTemp308 = int(fTemp307);
			double fTemp309 = ftbl0[iTemp308];
			fRec5[0] = ((0.5 * ((((((fVec34[(IOTA-int((iTemp274 & 262143)))&262143] * (fTemp275 + (1 - fTemp273))) + ((fTemp273 - fTemp275) * fVec34[(IOTA-int((int((iTemp274 + 1)) & 262143)))&262143])) * (fTemp279 + ((fTemp277 - floor(fTemp277)) * (ftbl0[((iTemp278 + 1) % 65536)] - fTemp279)))) + (((fVec34[(IOTA-int((iTemp284 & 262143)))&262143] * (fTemp285 + (1 - fTemp283))) + ((fTemp283 - fTemp285) * fVec34[(IOTA-int((int((iTemp284 + 1)) & 262143)))&262143])) * (fTemp289 + ((fTemp287 - floor(fTemp287)) * (ftbl0[((iTemp288 + 1) % 65536)] - fTemp289))))) + (((fVec34[(IOTA-int((iTemp294 & 262143)))&262143] * (fTemp295 + (1 - fTemp293))) + ((fTemp293 - fTemp295) * fVec34[(IOTA-int((int((iTemp294 + 1)) & 262143)))&262143])) * (fTemp299 + ((fTemp297 - floor(fTemp297)) * (ftbl0[((iTemp298 + 1) % 65536)] - fTemp299))))) + (((fVec34[(IOTA-int((iTemp304 & 262143)))&262143] * (fTemp305 + (1 - fTemp303))) + ((fTemp303 - fTemp305) * fVec34[(IOTA-int((int((iTemp304 + 1)) & 262143)))&262143])) * (fTemp309 + ((fTemp307 - floor(fTemp307)) * (ftbl0[((iTemp308 + 1) % 65536)] - fTemp309)))))) + (fSlow174 * fTemp267));
			fRec84[0] = (fSlow191 + (fSlow3 * fRec84[1]));
			double fTemp310 = (((((((((((((((((fSlow175 * fTemp4) + (fSlow176 * fTemp5)) + (fSlow177 * fTemp6)) + (fSlow178 * fTemp7)) + (fSlow179 * fTemp8)) + (fSlow180 * fTemp9)) + (fSlow181 * fTemp10)) + (fSlow182 * fTemp11)) + (fSlow183 * fTemp12)) + (fSlow184 * fTemp13)) + (fSlow185 * fTemp14)) + (fSlow186 * fTemp15)) + (fSlow187 * fTemp16)) + (fSlow188 * fTemp17)) + (fSlow189 * fTemp18)) + (fSlow190 * fTemp19)) + ((double)input6[i] * fRec84[0]));
			fVec39[IOTA&1048575] = fTemp310;
			iRec85[0] = ((iSlow192 * iTemp22) + (iTemp23 * iRec85[1]));
			iRec86[0] = ((iSlow192 * iTemp25) + (iTemp26 * iRec86[1]));
			double fTemp311 = ((0.5 * (fVec0[0] * fVec39[(IOTA-int((int(iRec85[0]) & 1048575)))&1048575])) + (fVec2[0] * fVec39[(IOTA-int((int(iRec86[0]) & 1048575)))&1048575]));
			int iTemp312 = (fTemp311 > 1);
			int iTemp313 = (fTemp311 < -1);
			double fTemp314 = ((iTemp312 + ((fTemp311 * (1 - iTemp313)) * (1 - iTemp312))) - iTemp313);
			double fTemp315 = (fSlow26 * fTemp314);
			fVec40[IOTA&262143] = fTemp315;
			double fTemp316 = (fRec87[1] + (fSlow193 / fTemp33));
			fRec87[0] = (fTemp316 - floor(fTemp316));
			double fTemp317 = (fRec87[0] - floor(fRec87[0]));
			fVec41[0] = fTemp317;
			int iTemp318 = (fVec41[0] > 0.001);
			int iTemp319 = (fVec41[1] <= 0.001);
			fRec88[0] = ((fRec88[1] * (1 - (iTemp318 * iTemp319))) + ((fRec39[0] * iTemp318) * iTemp319));
			double fTemp320 = (fConst4 * (fVec41[0] * fRec88[0]));
			int iTemp321 = int(fTemp320);
			double fTemp322 = floor(fTemp320);
			double fTemp323 = (0.5 * fVec41[0]);
			double fTemp324 = (65536.0 * (fTemp323 - floor(fTemp323)));
			int iTemp325 = int(fTemp324);
			double fTemp326 = ftbl0[iTemp325];
			double fTemp327 = (fRec87[0] + (0.25 - floor((fRec87[0] + 0.25))));
			fVec42[0] = fTemp327;
			int iTemp328 = (fVec42[0] > 0.001);
			int iTemp329 = (fVec42[1] <= 0.001);
			fRec89[0] = ((fRec89[1] * (1 - (iTemp328 * iTemp329))) + ((fRec39[0] * iTemp328) * iTemp329));
			double fTemp330 = (fConst4 * (fVec42[0] * fRec89[0]));
			int iTemp331 = int(fTemp330);
			double fTemp332 = floor(fTemp330);
			double fTemp333 = (0.5 * fVec42[0]);
			double fTemp334 = (65536.0 * (fTemp333 - floor(fTemp333)));
			int iTemp335 = int(fTemp334);
			double fTemp336 = ftbl0[iTemp335];
			double fTemp337 = (fRec87[0] + (0.5 - floor((fRec87[0] + 0.5))));
			fVec43[0] = fTemp337;
			int iTemp338 = (fVec43[0] > 0.001);
			int iTemp339 = (fVec43[1] <= 0.001);
			fRec90[0] = ((fRec90[1] * (1 - (iTemp338 * iTemp339))) + ((fRec39[0] * iTemp338) * iTemp339));
			double fTemp340 = (fConst4 * (fVec43[0] * fRec90[0]));
			int iTemp341 = int(fTemp340);
			double fTemp342 = floor(fTemp340);
			double fTemp343 = (0.5 * fVec43[0]);
			double fTemp344 = (65536.0 * (fTemp343 - floor(fTemp343)));
			int iTemp345 = int(fTemp344);
			double fTemp346 = ftbl0[iTemp345];
			double fTemp347 = (fRec87[0] + (0.75 - floor((fRec87[0] + 0.75))));
			fVec44[0] = fTemp347;
			int iTemp348 = (fVec44[0] > 0.001);
			int iTemp349 = (fVec44[1] <= 0.001);
			fRec91[0] = ((fRec91[1] * (1 - (iTemp348 * iTemp349))) + ((fRec39[0] * iTemp348) * iTemp349));
			double fTemp350 = (fConst4 * (fVec44[0] * fRec91[0]));
			int iTemp351 = int(fTemp350);
			double fTemp352 = floor(fTemp350);
			double fTemp353 = (0.5 * fVec44[0]);
			double fTemp354 = (65536.0 * (fTemp353 - floor(fTemp353)));
			int iTemp355 = int(fTemp354);
			double fTemp356 = ftbl0[iTemp355];
			fRec6[0] = ((0.5 * ((((((fVec40[(IOTA-int((iTemp321 & 262143)))&262143] * (fTemp322 + (1 - fTemp320))) + ((fTemp320 - fTemp322) * fVec40[(IOTA-int((int((iTemp321 + 1)) & 262143)))&262143])) * (fTemp326 + ((fTemp324 - floor(fTemp324)) * (ftbl0[((iTemp325 + 1) % 65536)] - fTemp326)))) + (((fVec40[(IOTA-int((iTemp331 & 262143)))&262143] * (fTemp332 + (1 - fTemp330))) + ((fTemp330 - fTemp332) * fVec40[(IOTA-int((int((iTemp331 + 1)) & 262143)))&262143])) * (fTemp336 + ((fTemp334 - floor(fTemp334)) * (ftbl0[((iTemp335 + 1) % 65536)] - fTemp336))))) + (((fVec40[(IOTA-int((iTemp341 & 262143)))&262143] * (fTemp342 + (1 - fTemp340))) + ((fTemp340 - fTemp342) * fVec40[(IOTA-int((int((iTemp341 + 1)) & 262143)))&262143])) * (fTemp346 + ((fTemp344 - floor(fTemp344)) * (ftbl0[((iTemp345 + 1) % 65536)] - fTemp346))))) + (((fVec40[(IOTA-int((iTemp351 & 262143)))&262143] * (fTemp352 + (1 - fTemp350))) + ((fTemp350 - fTemp352) * fVec40[(IOTA-int((int((iTemp351 + 1)) & 262143)))&262143])) * (fTemp356 + ((fTemp354 - floor(fTemp354)) * (ftbl0[((iTemp355 + 1) % 65536)] - fTemp356)))))) + (fSlow194 * fTemp314));
			fRec92[0] = (fSlow211 + (fSlow3 * fRec92[1]));
			double fTemp357 = (((((((((((((((((fSlow195 * fTemp4) + (fSlow196 * fTemp5)) + (fSlow197 * fTemp6)) + (fSlow198 * fTemp7)) + (fSlow199 * fTemp8)) + (fSlow200 * fTemp9)) + (fSlow201 * fTemp10)) + (fSlow202 * fTemp11)) + (fSlow203 * fTemp12)) + (fSlow204 * fTemp13)) + (fSlow205 * fTemp14)) + (fSlow206 * fTemp15)) + (fSlow207 * fTemp16)) + (fSlow208 * fTemp17)) + (fSlow209 * fTemp18)) + (fSlow210 * fTemp19)) + ((double)input7[i] * fRec92[0]));
			fVec45[IOTA&1048575] = fTemp357;
			iRec93[0] = ((iSlow212 * iTemp22) + (iTemp23 * iRec93[1]));
			iRec94[0] = ((iSlow212 * iTemp25) + (iTemp26 * iRec94[1]));
			double fTemp358 = ((0.5 * (fVec0[0] * fVec45[(IOTA-int((int(iRec93[0]) & 1048575)))&1048575])) + (fVec2[0] * fVec45[(IOTA-int((int(iRec94[0]) & 1048575)))&1048575]));
			int iTemp359 = (fTemp358 > 1);
			int iTemp360 = (fTemp358 < -1);
			double fTemp361 = ((iTemp359 + ((fTemp358 * (1 - iTemp360)) * (1 - iTemp359))) - iTemp360);
			double fTemp362 = (fSlow30 * fTemp361);
			fVec46[IOTA&262143] = fTemp362;
			double fTemp363 = (fRec95[1] + (fSlow213 / fTemp33));
			fRec95[0] = (fTemp363 - floor(fTemp363));
			double fTemp364 = (fRec95[0] + (0.25 - floor((fRec95[0] + 0.25))));
			fVec47[0] = fTemp364;
			int iTemp365 = (fVec47[0] > 0.001);
			int iTemp366 = (fVec47[1] <= 0.001);
			fRec96[0] = ((fRec96[1] * (1 - (iTemp365 * iTemp366))) + ((fRec39[0] * iTemp365) * iTemp366));
			double fTemp367 = (fConst4 * (fVec47[0] * fRec96[0]));
			int iTemp368 = int(fTemp367);
			double fTemp369 = floor(fTemp367);
			double fTemp370 = (0.5 * fVec47[0]);
			double fTemp371 = (65536.0 * (fTemp370 - floor(fTemp370)));
			int iTemp372 = int(fTemp371);
			double fTemp373 = ftbl0[iTemp372];
			double fTemp374 = (fRec95[0] + (0.5 - floor((fRec95[0] + 0.5))));
			fVec48[0] = fTemp374;
			int iTemp375 = (fVec48[0] > 0.001);
			int iTemp376 = (fVec48[1] <= 0.001);
			fRec97[0] = ((fRec97[1] * (1 - (iTemp375 * iTemp376))) + ((fRec39[0] * iTemp375) * iTemp376));
			double fTemp377 = (fConst4 * (fVec48[0] * fRec97[0]));
			int iTemp378 = int(fTemp377);
			double fTemp379 = floor(fTemp377);
			double fTemp380 = (0.5 * fVec48[0]);
			double fTemp381 = (65536.0 * (fTemp380 - floor(fTemp380)));
			int iTemp382 = int(fTemp381);
			double fTemp383 = ftbl0[iTemp382];
			double fTemp384 = (fRec95[0] + (0.75 - floor((fRec95[0] + 0.75))));
			fVec49[0] = fTemp384;
			int iTemp385 = (fVec49[0] > 0.001);
			int iTemp386 = (fVec49[1] <= 0.001);
			fRec98[0] = ((fRec98[1] * (1 - (iTemp385 * iTemp386))) + ((fRec39[0] * iTemp385) * iTemp386));
			double fTemp387 = (fConst4 * (fVec49[0] * fRec98[0]));
			int iTemp388 = int(fTemp387);
			double fTemp389 = floor(fTemp387);
			double fTemp390 = (0.5 * fVec49[0]);
			double fTemp391 = (65536.0 * (fTemp390 - floor(fTemp390)));
			int iTemp392 = int(fTemp391);
			double fTemp393 = ftbl0[iTemp392];
			double fTemp394 = (fRec95[0] - floor(fRec95[0]));
			fVec50[0] = fTemp394;
			int iTemp395 = (fVec50[0] > 0.001);
			int iTemp396 = (fVec50[1] <= 0.001);
			fRec99[0] = ((fRec99[1] * (1 - (iTemp395 * iTemp396))) + ((fRec39[0] * iTemp395) * iTemp396));
			double fTemp397 = (fConst4 * (fVec50[0] * fRec99[0]));
			int iTemp398 = int(fTemp397);
			double fTemp399 = floor(fTemp397);
			double fTemp400 = (0.5 * fVec50[0]);
			double fTemp401 = (65536.0 * (fTemp400 - floor(fTemp400)));
			int iTemp402 = int(fTemp401);
			double fTemp403 = ftbl0[iTemp402];
			fRec7[0] = ((0.5 * ((((((fVec46[(IOTA-int((iTemp368 & 262143)))&262143] * (fTemp369 + (1 - fTemp367))) + ((fTemp367 - fTemp369) * fVec46[(IOTA-int((int((iTemp368 + 1)) & 262143)))&262143])) * (fTemp373 + ((fTemp371 - floor(fTemp371)) * (ftbl0[((iTemp372 + 1) % 65536)] - fTemp373)))) + (((fVec46[(IOTA-int((iTemp378 & 262143)))&262143] * (fTemp379 + (1 - fTemp377))) + ((fTemp377 - fTemp379) * fVec46[(IOTA-int((int((iTemp378 + 1)) & 262143)))&262143])) * (fTemp383 + ((fTemp381 - floor(fTemp381)) * (ftbl0[((iTemp382 + 1) % 65536)] - fTemp383))))) + (((fVec46[(IOTA-int((iTemp388 & 262143)))&262143] * (fTemp389 + (1 - fTemp387))) + ((fTemp387 - fTemp389) * fVec46[(IOTA-int((int((iTemp388 + 1)) & 262143)))&262143])) * (fTemp393 + ((fTemp391 - floor(fTemp391)) * (ftbl0[((iTemp392 + 1) % 65536)] - fTemp393))))) + (((fVec46[(IOTA-int((iTemp398 & 262143)))&262143] * (fTemp399 + (1 - fTemp397))) + ((fTemp397 - fTemp399) * fVec46[(IOTA-int((int((iTemp398 + 1)) & 262143)))&262143])) * (fTemp403 + ((fTemp401 - floor(fTemp401)) * (ftbl0[((iTemp402 + 1) % 65536)] - fTemp403)))))) + (fSlow214 * fTemp361));
			double fTemp404 = (fRec100[1] + (fSlow215 / fTemp33));
			fRec100[0] = (fTemp404 - floor(fTemp404));
			double fTemp405 = (fRec100[0] - floor(fRec100[0]));
			fVec51[0] = fTemp405;
			double fTemp406 = (0.5 * fVec51[0]);
			double fTemp407 = (65536.0 * (fTemp406 - floor(fTemp406)));
			int iTemp408 = int(fTemp407);
			double fTemp409 = ftbl0[iTemp408];
			int iTemp410 = (fVec51[0] > 0.001);
			int iTemp411 = (fVec51[1] <= 0.001);
			fRec101[0] = ((fRec101[1] * (1 - (iTemp410 * iTemp411))) + ((fRec39[0] * iTemp410) * iTemp411));
			double fTemp412 = (fConst4 * (fVec51[0] * fRec101[0]));
			double fTemp413 = floor(fTemp412);
			fRec102[0] = (fSlow232 + (fSlow3 * fRec102[1]));
			double fTemp414 = (((((((((((((((((fSlow216 * fTemp4) + (fSlow217 * fTemp5)) + (fSlow218 * fTemp6)) + (fSlow219 * fTemp7)) + (fSlow220 * fTemp8)) + (fSlow221 * fTemp9)) + (fSlow222 * fTemp10)) + (fSlow223 * fTemp11)) + (fSlow224 * fTemp12)) + (fSlow225 * fTemp13)) + (fSlow226 * fTemp14)) + (fSlow227 * fTemp15)) + (fSlow228 * fTemp16)) + (fSlow229 * fTemp17)) + (fSlow230 * fTemp18)) + (fSlow231 * fTemp19)) + ((double)input8[i] * fRec102[0]));
			fVec52[IOTA&1048575] = fTemp414;
			iRec103[0] = ((iSlow233 * iTemp22) + (iTemp23 * iRec103[1]));
			iRec104[0] = ((iSlow233 * iTemp25) + (iTemp26 * iRec104[1]));
			double fTemp415 = ((0.5 * (fVec0[0] * fVec52[(IOTA-int((int(iRec103[0]) & 1048575)))&1048575])) + (fVec2[0] * fVec52[(IOTA-int((int(iRec104[0]) & 1048575)))&1048575]));
			int iTemp416 = (fTemp415 > 1);
			int iTemp417 = (fTemp415 < -1);
			double fTemp418 = ((iTemp416 + (((1 - iTemp417) * fTemp415) * (1 - iTemp416))) - iTemp417);
			double fTemp419 = (fSlow34 * fTemp418);
			fVec53[IOTA&262143] = fTemp419;
			int iTemp420 = int(fTemp412);
			double fTemp421 = (fRec100[0] + (0.25 - floor((fRec100[0] + 0.25))));
			fVec54[0] = fTemp421;
			double fTemp422 = (0.5 * fVec54[0]);
			double fTemp423 = (65536.0 * (fTemp422 - floor(fTemp422)));
			int iTemp424 = int(fTemp423);
			double fTemp425 = ftbl0[iTemp424];
			int iTemp426 = (fVec54[0] > 0.001);
			int iTemp427 = (fVec54[1] <= 0.001);
			fRec105[0] = ((fRec105[1] * (1 - (iTemp426 * iTemp427))) + ((fRec39[0] * iTemp426) * iTemp427));
			double fTemp428 = (fConst4 * (fVec54[0] * fRec105[0]));
			double fTemp429 = floor(fTemp428);
			int iTemp430 = int(fTemp428);
			double fTemp431 = (fRec100[0] + (0.5 - floor((fRec100[0] + 0.5))));
			fVec55[0] = fTemp431;
			double fTemp432 = (0.5 * fVec55[0]);
			double fTemp433 = (65536.0 * (fTemp432 - floor(fTemp432)));
			int iTemp434 = int(fTemp433);
			double fTemp435 = ftbl0[iTemp434];
			int iTemp436 = (fVec55[0] > 0.001);
			int iTemp437 = (fVec55[1] <= 0.001);
			fRec106[0] = ((fRec106[1] * (1 - (iTemp436 * iTemp437))) + ((fRec39[0] * iTemp436) * iTemp437));
			double fTemp438 = (fConst4 * (fVec55[0] * fRec106[0]));
			double fTemp439 = floor(fTemp438);
			int iTemp440 = int(fTemp438);
			double fTemp441 = (fRec100[0] + (0.75 - floor((fRec100[0] + 0.75))));
			fVec56[0] = fTemp441;
			double fTemp442 = (0.5 * fVec56[0]);
			double fTemp443 = (65536.0 * (fTemp442 - floor(fTemp442)));
			int iTemp444 = int(fTemp443);
			double fTemp445 = ftbl0[iTemp444];
			int iTemp446 = (fVec56[0] > 0.001);
			int iTemp447 = (fVec56[1] <= 0.001);
			fRec107[0] = ((fRec107[1] * (1 - (iTemp446 * iTemp447))) + ((fRec39[0] * iTemp446) * iTemp447));
			double fTemp448 = (fConst4 * (fVec56[0] * fRec107[0]));
			double fTemp449 = floor(fTemp448);
			int iTemp450 = int(fTemp448);
			fRec8[0] = ((0.5 * (((((fTemp409 + ((fTemp407 - floor(fTemp407)) * (ftbl0[((iTemp408 + 1) % 65536)] - fTemp409))) * (((fTemp413 + (1 - fTemp412)) * fVec53[(IOTA-int((iTemp420 & 262143)))&262143]) + ((fTemp412 - fTemp413) * fVec53[(IOTA-int((int((iTemp420 + 1)) & 262143)))&262143]))) + ((fTemp425 + ((fTemp423 - floor(fTemp423)) * (ftbl0[((iTemp424 + 1) % 65536)] - fTemp425))) * (((fTemp429 + (1 - fTemp428)) * fVec53[(IOTA-int((iTemp430 & 262143)))&262143]) + ((fTemp428 - fTemp429) * fVec53[(IOTA-int((int((iTemp430 + 1)) & 262143)))&262143])))) + ((fTemp435 + ((fTemp433 - floor(fTemp433)) * (ftbl0[((iTemp434 + 1) % 65536)] - fTemp435))) * (((fTemp439 + (1 - fTemp438)) * fVec53[(IOTA-int((iTemp440 & 262143)))&262143]) + ((fTemp438 - fTemp439) * fVec53[(IOTA-int((int((iTemp440 + 1)) & 262143)))&262143])))) + ((fTemp445 + ((fTemp443 - floor(fTemp443)) * (ftbl0[((iTemp444 + 1) % 65536)] - fTemp445))) * (((fTemp449 + (1 - fTemp448)) * fVec53[(IOTA-int((iTemp450 & 262143)))&262143]) + ((fTemp448 - fTemp449) * fVec53[(IOTA-int((int((iTemp450 + 1)) & 262143)))&262143]))))) + (fSlow234 * fTemp418));
			fRec108[0] = (fSlow251 + (fSlow3 * fRec108[1]));
			double fTemp451 = (((((((((((((((((fSlow235 * fTemp4) + (fSlow236 * fTemp5)) + (fSlow237 * fTemp6)) + (fSlow238 * fTemp7)) + (fSlow239 * fTemp8)) + (fSlow240 * fTemp9)) + (fSlow241 * fTemp10)) + (fSlow242 * fTemp11)) + (fSlow243 * fTemp12)) + (fSlow244 * fTemp13)) + (fSlow245 * fTemp14)) + (fSlow246 * fTemp15)) + (fSlow247 * fTemp16)) + (fSlow248 * fTemp17)) + (fSlow249 * fTemp18)) + (fSlow250 * fTemp19)) + ((double)input9[i] * fRec108[0]));
			fVec57[IOTA&1048575] = fTemp451;
			iRec109[0] = ((iSlow252 * iTemp22) + (iTemp23 * iRec109[1]));
			iRec110[0] = ((iSlow252 * iTemp25) + (iTemp26 * iRec110[1]));
			double fTemp452 = ((0.5 * (fVec0[0] * fVec57[(IOTA-int((int(iRec109[0]) & 1048575)))&1048575])) + (fVec2[0] * fVec57[(IOTA-int((int(iRec110[0]) & 1048575)))&1048575]));
			int iTemp453 = (fTemp452 > 1);
			int iTemp454 = (fTemp452 < -1);
			double fTemp455 = ((iTemp453 + ((fTemp452 * (1 - iTemp454)) * (1 - iTemp453))) - iTemp454);
			double fTemp456 = (fSlow38 * fTemp455);
			fVec58[IOTA&262143] = fTemp456;
			double fTemp457 = (fRec111[1] + (fSlow253 / fTemp33));
			fRec111[0] = (fTemp457 - floor(fTemp457));
			double fTemp458 = (fRec111[0] - floor(fRec111[0]));
			fVec59[0] = fTemp458;
			int iTemp459 = (fVec59[0] > 0.001);
			int iTemp460 = (fVec59[1] <= 0.001);
			fRec112[0] = ((fRec112[1] * (1 - (iTemp459 * iTemp460))) + ((fRec39[0] * iTemp459) * iTemp460));
			double fTemp461 = (fConst4 * (fVec59[0] * fRec112[0]));
			int iTemp462 = int(fTemp461);
			double fTemp463 = floor(fTemp461);
			double fTemp464 = (0.5 * fVec59[0]);
			double fTemp465 = (65536.0 * (fTemp464 - floor(fTemp464)));
			int iTemp466 = int(fTemp465);
			double fTemp467 = ftbl0[iTemp466];
			double fTemp468 = (fRec111[0] + (0.25 - floor((fRec111[0] + 0.25))));
			fVec60[0] = fTemp468;
			int iTemp469 = (fVec60[0] > 0.001);
			int iTemp470 = (fVec60[1] <= 0.001);
			fRec113[0] = ((fRec113[1] * (1 - (iTemp469 * iTemp470))) + ((fRec39[0] * iTemp469) * iTemp470));
			double fTemp471 = (fConst4 * (fVec60[0] * fRec113[0]));
			int iTemp472 = int(fTemp471);
			double fTemp473 = floor(fTemp471);
			double fTemp474 = (0.5 * fVec60[0]);
			double fTemp475 = (65536.0 * (fTemp474 - floor(fTemp474)));
			int iTemp476 = int(fTemp475);
			double fTemp477 = ftbl0[iTemp476];
			double fTemp478 = (fRec111[0] + (0.5 - floor((fRec111[0] + 0.5))));
			fVec61[0] = fTemp478;
			int iTemp479 = (fVec61[0] > 0.001);
			int iTemp480 = (fVec61[1] <= 0.001);
			fRec114[0] = ((fRec114[1] * (1 - (iTemp479 * iTemp480))) + ((fRec39[0] * iTemp479) * iTemp480));
			double fTemp481 = (fConst4 * (fVec61[0] * fRec114[0]));
			int iTemp482 = int(fTemp481);
			double fTemp483 = floor(fTemp481);
			double fTemp484 = (0.5 * fVec61[0]);
			double fTemp485 = (65536.0 * (fTemp484 - floor(fTemp484)));
			int iTemp486 = int(fTemp485);
			double fTemp487 = ftbl0[iTemp486];
			double fTemp488 = (fRec111[0] + (0.75 - floor((fRec111[0] + 0.75))));
			fVec62[0] = fTemp488;
			int iTemp489 = (fVec62[0] > 0.001);
			int iTemp490 = (fVec62[1] <= 0.001);
			fRec115[0] = ((fRec115[1] * (1 - (iTemp489 * iTemp490))) + ((fRec39[0] * iTemp489) * iTemp490));
			double fTemp491 = (fConst4 * (fVec62[0] * fRec115[0]));
			int iTemp492 = int(fTemp491);
			double fTemp493 = floor(fTemp491);
			double fTemp494 = (0.5 * fVec62[0]);
			double fTemp495 = (65536.0 * (fTemp494 - floor(fTemp494)));
			int iTemp496 = int(fTemp495);
			double fTemp497 = ftbl0[iTemp496];
			fRec9[0] = ((0.5 * ((((((fVec58[(IOTA-int((iTemp462 & 262143)))&262143] * (fTemp463 + (1 - fTemp461))) + ((fTemp461 - fTemp463) * fVec58[(IOTA-int((int((iTemp462 + 1)) & 262143)))&262143])) * (fTemp467 + ((fTemp465 - floor(fTemp465)) * (ftbl0[((iTemp466 + 1) % 65536)] - fTemp467)))) + (((fVec58[(IOTA-int((iTemp472 & 262143)))&262143] * (fTemp473 + (1 - fTemp471))) + ((fTemp471 - fTemp473) * fVec58[(IOTA-int((int((iTemp472 + 1)) & 262143)))&262143])) * (fTemp477 + ((fTemp475 - floor(fTemp475)) * (ftbl0[((iTemp476 + 1) % 65536)] - fTemp477))))) + (((fVec58[(IOTA-int((iTemp482 & 262143)))&262143] * (fTemp483 + (1 - fTemp481))) + ((fTemp481 - fTemp483) * fVec58[(IOTA-int((int((iTemp482 + 1)) & 262143)))&262143])) * (fTemp487 + ((fTemp485 - floor(fTemp485)) * (ftbl0[((iTemp486 + 1) % 65536)] - fTemp487))))) + (((fVec58[(IOTA-int((iTemp492 & 262143)))&262143] * (fTemp493 + (1 - fTemp491))) + ((fTemp491 - fTemp493) * fVec58[(IOTA-int((int((iTemp492 + 1)) & 262143)))&262143])) * (fTemp497 + ((fTemp495 - floor(fTemp495)) * (ftbl0[((iTemp496 + 1) % 65536)] - fTemp497)))))) + (fSlow254 * fTemp455));
			fRec116[0] = (fSlow271 + (fSlow3 * fRec116[1]));
			double fTemp498 = (((((((((((((((((fSlow255 * fTemp4) + (fSlow256 * fTemp5)) + (fSlow257 * fTemp6)) + (fSlow258 * fTemp7)) + (fSlow259 * fTemp8)) + (fSlow260 * fTemp9)) + (fSlow261 * fTemp10)) + (fSlow262 * fTemp11)) + (fSlow263 * fTemp12)) + (fSlow264 * fTemp13)) + (fSlow265 * fTemp14)) + (fSlow266 * fTemp15)) + (fSlow267 * fTemp16)) + (fSlow268 * fTemp17)) + (fSlow269 * fTemp18)) + (fSlow270 * fTemp19)) + ((double)input10[i] * fRec116[0]));
			fVec63[IOTA&1048575] = fTemp498;
			iRec117[0] = ((iSlow272 * iTemp22) + (iTemp23 * iRec117[1]));
			iRec118[0] = ((iSlow272 * iTemp25) + (iTemp26 * iRec118[1]));
			double fTemp499 = ((0.5 * (fVec0[0] * fVec63[(IOTA-int((int(iRec117[0]) & 1048575)))&1048575])) + (fVec2[0] * fVec63[(IOTA-int((int(iRec118[0]) & 1048575)))&1048575]));
			int iTemp500 = (fTemp499 > 1);
			int iTemp501 = (fTemp499 < -1);
			double fTemp502 = ((iTemp500 + ((fTemp499 * (1 - iTemp501)) * (1 - iTemp500))) - iTemp501);
			double fTemp503 = (fSlow42 * fTemp502);
			fVec64[IOTA&262143] = fTemp503;
			double fTemp504 = (fRec119[1] + (fSlow273 / fTemp33));
			fRec119[0] = (fTemp504 - floor(fTemp504));
			double fTemp505 = (fRec119[0] - floor(fRec119[0]));
			fVec65[0] = fTemp505;
			int iTemp506 = (fVec65[0] > 0.001);
			int iTemp507 = (fVec65[1] <= 0.001);
			fRec120[0] = ((fRec120[1] * (1 - (iTemp506 * iTemp507))) + ((fRec39[0] * iTemp506) * iTemp507));
			double fTemp508 = (fConst4 * (fVec65[0] * fRec120[0]));
			int iTemp509 = int(fTemp508);
			double fTemp510 = floor(fTemp508);
			double fTemp511 = (0.5 * fVec65[0]);
			double fTemp512 = (65536.0 * (fTemp511 - floor(fTemp511)));
			int iTemp513 = int(fTemp512);
			double fTemp514 = ftbl0[iTemp513];
			double fTemp515 = (fRec119[0] + (0.25 - floor((fRec119[0] + 0.25))));
			fVec66[0] = fTemp515;
			int iTemp516 = (fVec66[0] > 0.001);
			int iTemp517 = (fVec66[1] <= 0.001);
			fRec121[0] = ((fRec121[1] * (1 - (iTemp516 * iTemp517))) + ((fRec39[0] * iTemp516) * iTemp517));
			double fTemp518 = (fConst4 * (fVec66[0] * fRec121[0]));
			int iTemp519 = int(fTemp518);
			double fTemp520 = floor(fTemp518);
			double fTemp521 = (0.5 * fVec66[0]);
			double fTemp522 = (65536.0 * (fTemp521 - floor(fTemp521)));
			int iTemp523 = int(fTemp522);
			double fTemp524 = ftbl0[iTemp523];
			double fTemp525 = (fRec119[0] + (0.5 - floor((fRec119[0] + 0.5))));
			fVec67[0] = fTemp525;
			int iTemp526 = (fVec67[0] > 0.001);
			int iTemp527 = (fVec67[1] <= 0.001);
			fRec122[0] = ((fRec122[1] * (1 - (iTemp526 * iTemp527))) + ((fRec39[0] * iTemp526) * iTemp527));
			double fTemp528 = (fConst4 * (fVec67[0] * fRec122[0]));
			int iTemp529 = int(fTemp528);
			double fTemp530 = floor(fTemp528);
			double fTemp531 = (0.5 * fVec67[0]);
			double fTemp532 = (65536.0 * (fTemp531 - floor(fTemp531)));
			int iTemp533 = int(fTemp532);
			double fTemp534 = ftbl0[iTemp533];
			double fTemp535 = (fRec119[0] + (0.75 - floor((fRec119[0] + 0.75))));
			fVec68[0] = fTemp535;
			int iTemp536 = (fVec68[0] > 0.001);
			int iTemp537 = (fVec68[1] <= 0.001);
			fRec123[0] = ((fRec123[1] * (1 - (iTemp536 * iTemp537))) + ((fRec39[0] * iTemp536) * iTemp537));
			double fTemp538 = (fConst4 * (fVec68[0] * fRec123[0]));
			int iTemp539 = int(fTemp538);
			double fTemp540 = floor(fTemp538);
			double fTemp541 = (0.5 * fVec68[0]);
			double fTemp542 = (65536.0 * (fTemp541 - floor(fTemp541)));
			int iTemp543 = int(fTemp542);
			double fTemp544 = ftbl0[iTemp543];
			fRec10[0] = ((0.5 * ((((((fVec64[(IOTA-int((iTemp509 & 262143)))&262143] * (fTemp510 + (1 - fTemp508))) + ((fTemp508 - fTemp510) * fVec64[(IOTA-int((int((iTemp509 + 1)) & 262143)))&262143])) * (fTemp514 + ((fTemp512 - floor(fTemp512)) * (ftbl0[((iTemp513 + 1) % 65536)] - fTemp514)))) + (((fVec64[(IOTA-int((iTemp519 & 262143)))&262143] * (fTemp520 + (1 - fTemp518))) + ((fTemp518 - fTemp520) * fVec64[(IOTA-int((int((iTemp519 + 1)) & 262143)))&262143])) * (fTemp524 + ((fTemp522 - floor(fTemp522)) * (ftbl0[((iTemp523 + 1) % 65536)] - fTemp524))))) + (((fVec64[(IOTA-int((iTemp529 & 262143)))&262143] * (fTemp530 + (1 - fTemp528))) + ((fTemp528 - fTemp530) * fVec64[(IOTA-int((int((iTemp529 + 1)) & 262143)))&262143])) * (fTemp534 + ((fTemp532 - floor(fTemp532)) * (ftbl0[((iTemp533 + 1) % 65536)] - fTemp534))))) + (((fVec64[(IOTA-int((iTemp539 & 262143)))&262143] * (fTemp540 + (1 - fTemp538))) + ((fTemp538 - fTemp540) * fVec64[(IOTA-int((int((iTemp539 + 1)) & 262143)))&262143])) * (fTemp544 + ((fTemp542 - floor(fTemp542)) * (ftbl0[((iTemp543 + 1) % 65536)] - fTemp544)))))) + (fSlow274 * fTemp502));
			fRec124[0] = (fSlow291 + (fSlow3 * fRec124[1]));
			double fTemp545 = (((((((((((((((((fSlow275 * fTemp4) + (fSlow276 * fTemp5)) + (fSlow277 * fTemp6)) + (fSlow278 * fTemp7)) + (fSlow279 * fTemp8)) + (fSlow280 * fTemp9)) + (fSlow281 * fTemp10)) + (fSlow282 * fTemp11)) + (fSlow283 * fTemp12)) + (fSlow284 * fTemp13)) + (fSlow285 * fTemp14)) + (fSlow286 * fTemp15)) + (fSlow287 * fTemp16)) + (fSlow288 * fTemp17)) + (fSlow289 * fTemp18)) + (fSlow290 * fTemp19)) + ((double)input11[i] * fRec124[0]));
			fVec69[IOTA&1048575] = fTemp545;
			iRec125[0] = ((iSlow292 * iTemp22) + (iTemp23 * iRec125[1]));
			iRec126[0] = ((iSlow292 * iTemp25) + (iTemp26 * iRec126[1]));
			double fTemp546 = ((0.5 * (fVec0[0] * fVec69[(IOTA-int((int(iRec125[0]) & 1048575)))&1048575])) + (fVec2[0] * fVec69[(IOTA-int((int(iRec126[0]) & 1048575)))&1048575]));
			int iTemp547 = (fTemp546 > 1);
			int iTemp548 = (fTemp546 < -1);
			double fTemp549 = ((iTemp547 + ((fTemp546 * (1 - iTemp548)) * (1 - iTemp547))) - iTemp548);
			double fTemp550 = (fSlow46 * fTemp549);
			fVec70[IOTA&262143] = fTemp550;
			double fTemp551 = (fRec127[1] + (fSlow293 / fTemp33));
			fRec127[0] = (fTemp551 - floor(fTemp551));
			double fTemp552 = (fRec127[0] - floor(fRec127[0]));
			fVec71[0] = fTemp552;
			int iTemp553 = (fVec71[0] > 0.001);
			int iTemp554 = (fVec71[1] <= 0.001);
			fRec128[0] = ((fRec128[1] * (1 - (iTemp553 * iTemp554))) + ((fRec39[0] * iTemp553) * iTemp554));
			double fTemp555 = (fConst4 * (fVec71[0] * fRec128[0]));
			int iTemp556 = int(fTemp555);
			double fTemp557 = floor(fTemp555);
			double fTemp558 = (0.5 * fVec71[0]);
			double fTemp559 = (65536.0 * (fTemp558 - floor(fTemp558)));
			int iTemp560 = int(fTemp559);
			double fTemp561 = ftbl0[iTemp560];
			double fTemp562 = (fRec127[0] + (0.25 - floor((fRec127[0] + 0.25))));
			fVec72[0] = fTemp562;
			int iTemp563 = (fVec72[0] > 0.001);
			int iTemp564 = (fVec72[1] <= 0.001);
			fRec129[0] = ((fRec129[1] * (1 - (iTemp563 * iTemp564))) + ((fRec39[0] * iTemp563) * iTemp564));
			double fTemp565 = (fConst4 * (fVec72[0] * fRec129[0]));
			int iTemp566 = int(fTemp565);
			double fTemp567 = floor(fTemp565);
			double fTemp568 = (0.5 * fVec72[0]);
			double fTemp569 = (65536.0 * (fTemp568 - floor(fTemp568)));
			int iTemp570 = int(fTemp569);
			double fTemp571 = ftbl0[iTemp570];
			double fTemp572 = (fRec127[0] + (0.5 - floor((fRec127[0] + 0.5))));
			fVec73[0] = fTemp572;
			int iTemp573 = (fVec73[0] > 0.001);
			int iTemp574 = (fVec73[1] <= 0.001);
			fRec130[0] = ((fRec130[1] * (1 - (iTemp573 * iTemp574))) + ((fRec39[0] * iTemp573) * iTemp574));
			double fTemp575 = (fConst4 * (fVec73[0] * fRec130[0]));
			int iTemp576 = int(fTemp575);
			double fTemp577 = floor(fTemp575);
			double fTemp578 = (0.5 * fVec73[0]);
			double fTemp579 = (65536.0 * (fTemp578 - floor(fTemp578)));
			int iTemp580 = int(fTemp579);
			double fTemp581 = ftbl0[iTemp580];
			double fTemp582 = (fRec127[0] + (0.75 - floor((fRec127[0] + 0.75))));
			fVec74[0] = fTemp582;
			int iTemp583 = (fVec74[0] > 0.001);
			int iTemp584 = (fVec74[1] <= 0.001);
			fRec131[0] = ((fRec131[1] * (1 - (iTemp583 * iTemp584))) + ((fRec39[0] * iTemp583) * iTemp584));
			double fTemp585 = (fConst4 * (fVec74[0] * fRec131[0]));
			int iTemp586 = int(fTemp585);
			double fTemp587 = floor(fTemp585);
			double fTemp588 = (0.5 * fVec74[0]);
			double fTemp589 = (65536.0 * (fTemp588 - floor(fTemp588)));
			int iTemp590 = int(fTemp589);
			double fTemp591 = ftbl0[iTemp590];
			fRec11[0] = ((0.5 * ((((((fVec70[(IOTA-int((iTemp556 & 262143)))&262143] * (fTemp557 + (1 - fTemp555))) + ((fTemp555 - fTemp557) * fVec70[(IOTA-int((int((iTemp556 + 1)) & 262143)))&262143])) * (fTemp561 + ((fTemp559 - floor(fTemp559)) * (ftbl0[((iTemp560 + 1) % 65536)] - fTemp561)))) + (((fVec70[(IOTA-int((iTemp566 & 262143)))&262143] * (fTemp567 + (1 - fTemp565))) + ((fTemp565 - fTemp567) * fVec70[(IOTA-int((int((iTemp566 + 1)) & 262143)))&262143])) * (fTemp571 + ((fTemp569 - floor(fTemp569)) * (ftbl0[((iTemp570 + 1) % 65536)] - fTemp571))))) + (((fVec70[(IOTA-int((iTemp576 & 262143)))&262143] * (fTemp577 + (1 - fTemp575))) + ((fTemp575 - fTemp577) * fVec70[(IOTA-int((int((iTemp576 + 1)) & 262143)))&262143])) * (fTemp581 + ((fTemp579 - floor(fTemp579)) * (ftbl0[((iTemp580 + 1) % 65536)] - fTemp581))))) + (((fVec70[(IOTA-int((iTemp586 & 262143)))&262143] * (fTemp587 + (1 - fTemp585))) + ((fTemp585 - fTemp587) * fVec70[(IOTA-int((int((iTemp586 + 1)) & 262143)))&262143])) * (fTemp591 + ((fTemp589 - floor(fTemp589)) * (ftbl0[((iTemp590 + 1) % 65536)] - fTemp591)))))) + (fSlow294 * fTemp549));
			fRec132[0] = (fSlow311 + (fSlow3 * fRec132[1]));
			double fTemp592 = (((((((((((((((((fSlow295 * fTemp4) + (fSlow296 * fTemp5)) + (fSlow297 * fTemp6)) + (fSlow298 * fTemp7)) + (fSlow299 * fTemp8)) + (fSlow300 * fTemp9)) + (fSlow301 * fTemp10)) + (fSlow302 * fTemp11)) + (fSlow303 * fTemp12)) + (fSlow304 * fTemp13)) + (fSlow305 * fTemp14)) + (fSlow306 * fTemp15)) + (fSlow307 * fTemp16)) + (fSlow308 * fTemp17)) + (fSlow309 * fTemp18)) + (fSlow310 * fTemp19)) + ((double)input12[i] * fRec132[0]));
			fVec75[IOTA&1048575] = fTemp592;
			iRec133[0] = ((iSlow312 * iTemp22) + (iTemp23 * iRec133[1]));
			iRec134[0] = ((iSlow312 * iTemp25) + (iTemp26 * iRec134[1]));
			double fTemp593 = ((0.5 * (fVec0[0] * fVec75[(IOTA-int((int(iRec133[0]) & 1048575)))&1048575])) + (fVec2[0] * fVec75[(IOTA-int((int(iRec134[0]) & 1048575)))&1048575]));
			int iTemp594 = (fTemp593 > 1);
			int iTemp595 = (fTemp593 < -1);
			double fTemp596 = ((iTemp594 + ((fTemp593 * (1 - iTemp595)) * (1 - iTemp594))) - iTemp595);
			double fTemp597 = (fSlow50 * fTemp596);
			fVec76[IOTA&262143] = fTemp597;
			double fTemp598 = (fRec135[1] + (fSlow313 / fTemp33));
			fRec135[0] = (fTemp598 - floor(fTemp598));
			double fTemp599 = (fRec135[0] - floor(fRec135[0]));
			fVec77[0] = fTemp599;
			int iTemp600 = (fVec77[0] > 0.001);
			int iTemp601 = (fVec77[1] <= 0.001);
			fRec136[0] = ((fRec136[1] * (1 - (iTemp600 * iTemp601))) + ((fRec39[0] * iTemp600) * iTemp601));
			double fTemp602 = (fConst4 * (fVec77[0] * fRec136[0]));
			int iTemp603 = int(fTemp602);
			double fTemp604 = floor(fTemp602);
			double fTemp605 = (0.5 * fVec77[0]);
			double fTemp606 = (65536.0 * (fTemp605 - floor(fTemp605)));
			int iTemp607 = int(fTemp606);
			double fTemp608 = ftbl0[iTemp607];
			double fTemp609 = (fRec135[0] + (0.25 - floor((fRec135[0] + 0.25))));
			fVec78[0] = fTemp609;
			int iTemp610 = (fVec78[0] > 0.001);
			int iTemp611 = (fVec78[1] <= 0.001);
			fRec137[0] = ((fRec137[1] * (1 - (iTemp610 * iTemp611))) + ((fRec39[0] * iTemp610) * iTemp611));
			double fTemp612 = (fConst4 * (fVec78[0] * fRec137[0]));
			int iTemp613 = int(fTemp612);
			double fTemp614 = floor(fTemp612);
			double fTemp615 = (0.5 * fVec78[0]);
			double fTemp616 = (65536.0 * (fTemp615 - floor(fTemp615)));
			int iTemp617 = int(fTemp616);
			double fTemp618 = ftbl0[iTemp617];
			double fTemp619 = (fRec135[0] + (0.5 - floor((fRec135[0] + 0.5))));
			fVec79[0] = fTemp619;
			int iTemp620 = (fVec79[0] > 0.001);
			int iTemp621 = (fVec79[1] <= 0.001);
			fRec138[0] = ((fRec138[1] * (1 - (iTemp620 * iTemp621))) + ((fRec39[0] * iTemp620) * iTemp621));
			double fTemp622 = (fConst4 * (fVec79[0] * fRec138[0]));
			int iTemp623 = int(fTemp622);
			double fTemp624 = floor(fTemp622);
			double fTemp625 = (0.5 * fVec79[0]);
			double fTemp626 = (65536.0 * (fTemp625 - floor(fTemp625)));
			int iTemp627 = int(fTemp626);
			double fTemp628 = ftbl0[iTemp627];
			double fTemp629 = (fRec135[0] + (0.75 - floor((fRec135[0] + 0.75))));
			fVec80[0] = fTemp629;
			int iTemp630 = (fVec80[0] > 0.001);
			int iTemp631 = (fVec80[1] <= 0.001);
			fRec139[0] = ((fRec139[1] * (1 - (iTemp630 * iTemp631))) + ((fRec39[0] * iTemp630) * iTemp631));
			double fTemp632 = (fConst4 * (fVec80[0] * fRec139[0]));
			int iTemp633 = int(fTemp632);
			double fTemp634 = floor(fTemp632);
			double fTemp635 = (0.5 * fVec80[0]);
			double fTemp636 = (65536.0 * (fTemp635 - floor(fTemp635)));
			int iTemp637 = int(fTemp636);
			double fTemp638 = ftbl0[iTemp637];
			fRec12[0] = ((0.5 * ((((((fVec76[(IOTA-int((iTemp603 & 262143)))&262143] * (fTemp604 + (1 - fTemp602))) + ((fTemp602 - fTemp604) * fVec76[(IOTA-int((int((iTemp603 + 1)) & 262143)))&262143])) * (fTemp608 + ((fTemp606 - floor(fTemp606)) * (ftbl0[((iTemp607 + 1) % 65536)] - fTemp608)))) + (((fVec76[(IOTA-int((iTemp613 & 262143)))&262143] * (fTemp614 + (1 - fTemp612))) + ((fTemp612 - fTemp614) * fVec76[(IOTA-int((int((iTemp613 + 1)) & 262143)))&262143])) * (fTemp618 + ((fTemp616 - floor(fTemp616)) * (ftbl0[((iTemp617 + 1) % 65536)] - fTemp618))))) + (((fVec76[(IOTA-int((iTemp623 & 262143)))&262143] * (fTemp624 + (1 - fTemp622))) + ((fTemp622 - fTemp624) * fVec76[(IOTA-int((int((iTemp623 + 1)) & 262143)))&262143])) * (fTemp628 + ((fTemp626 - floor(fTemp626)) * (ftbl0[((iTemp627 + 1) % 65536)] - fTemp628))))) + (((fVec76[(IOTA-int((iTemp633 & 262143)))&262143] * (fTemp634 + (1 - fTemp632))) + ((fTemp632 - fTemp634) * fVec76[(IOTA-int((int((iTemp633 + 1)) & 262143)))&262143])) * (fTemp638 + ((fTemp636 - floor(fTemp636)) * (ftbl0[((iTemp637 + 1) % 65536)] - fTemp638)))))) + (fSlow314 * fTemp596));
			fRec140[0] = (fSlow331 + (fSlow3 * fRec140[1]));
			double fTemp639 = (((((((((((((((((fSlow315 * fTemp4) + (fSlow316 * fTemp5)) + (fSlow317 * fTemp6)) + (fSlow318 * fTemp7)) + (fSlow319 * fTemp8)) + (fSlow320 * fTemp9)) + (fSlow321 * fTemp10)) + (fSlow322 * fTemp11)) + (fSlow323 * fTemp12)) + (fSlow324 * fTemp13)) + (fSlow325 * fTemp14)) + (fSlow326 * fTemp15)) + (fSlow327 * fTemp16)) + (fSlow328 * fTemp17)) + (fSlow329 * fTemp18)) + (fSlow330 * fTemp19)) + ((double)input13[i] * fRec140[0]));
			fVec81[IOTA&1048575] = fTemp639;
			iRec141[0] = ((iSlow332 * iTemp22) + (iTemp23 * iRec141[1]));
			iRec142[0] = ((iSlow332 * iTemp25) + (iTemp26 * iRec142[1]));
			double fTemp640 = ((0.5 * (fVec0[0] * fVec81[(IOTA-int((int(iRec141[0]) & 1048575)))&1048575])) + (fVec2[0] * fVec81[(IOTA-int((int(iRec142[0]) & 1048575)))&1048575]));
			int iTemp641 = (fTemp640 > 1);
			int iTemp642 = (fTemp640 < -1);
			double fTemp643 = ((iTemp641 + ((fTemp640 * (1 - iTemp642)) * (1 - iTemp641))) - iTemp642);
			double fTemp644 = (fSlow54 * fTemp643);
			fVec82[IOTA&262143] = fTemp644;
			double fTemp645 = (fRec143[1] + (fSlow333 / fTemp33));
			fRec143[0] = (fTemp645 - floor(fTemp645));
			double fTemp646 = (fRec143[0] - floor(fRec143[0]));
			fVec83[0] = fTemp646;
			int iTemp647 = (fVec83[0] > 0.001);
			int iTemp648 = (fVec83[1] <= 0.001);
			fRec144[0] = ((fRec144[1] * (1 - (iTemp647 * iTemp648))) + ((fRec39[0] * iTemp647) * iTemp648));
			double fTemp649 = (fConst4 * (fVec83[0] * fRec144[0]));
			int iTemp650 = int(fTemp649);
			double fTemp651 = floor(fTemp649);
			double fTemp652 = (0.5 * fVec83[0]);
			double fTemp653 = (65536.0 * (fTemp652 - floor(fTemp652)));
			int iTemp654 = int(fTemp653);
			double fTemp655 = ftbl0[iTemp654];
			double fTemp656 = (fRec143[0] + (0.25 - floor((fRec143[0] + 0.25))));
			fVec84[0] = fTemp656;
			int iTemp657 = (fVec84[0] > 0.001);
			int iTemp658 = (fVec84[1] <= 0.001);
			fRec145[0] = ((fRec145[1] * (1 - (iTemp657 * iTemp658))) + ((fRec39[0] * iTemp657) * iTemp658));
			double fTemp659 = (fConst4 * (fVec84[0] * fRec145[0]));
			int iTemp660 = int(fTemp659);
			double fTemp661 = floor(fTemp659);
			double fTemp662 = (0.5 * fVec84[0]);
			double fTemp663 = (65536.0 * (fTemp662 - floor(fTemp662)));
			int iTemp664 = int(fTemp663);
			double fTemp665 = ftbl0[iTemp664];
			double fTemp666 = (fRec143[0] + (0.5 - floor((fRec143[0] + 0.5))));
			fVec85[0] = fTemp666;
			int iTemp667 = (fVec85[0] > 0.001);
			int iTemp668 = (fVec85[1] <= 0.001);
			fRec146[0] = ((fRec146[1] * (1 - (iTemp667 * iTemp668))) + ((fRec39[0] * iTemp667) * iTemp668));
			double fTemp669 = (fConst4 * (fVec85[0] * fRec146[0]));
			int iTemp670 = int(fTemp669);
			double fTemp671 = floor(fTemp669);
			double fTemp672 = (0.5 * fVec85[0]);
			double fTemp673 = (65536.0 * (fTemp672 - floor(fTemp672)));
			int iTemp674 = int(fTemp673);
			double fTemp675 = ftbl0[iTemp674];
			double fTemp676 = (fRec143[0] + (0.75 - floor((fRec143[0] + 0.75))));
			fVec86[0] = fTemp676;
			int iTemp677 = (fVec86[0] > 0.001);
			int iTemp678 = (fVec86[1] <= 0.001);
			fRec147[0] = ((fRec147[1] * (1 - (iTemp677 * iTemp678))) + ((fRec39[0] * iTemp677) * iTemp678));
			double fTemp679 = (fConst4 * (fVec86[0] * fRec147[0]));
			int iTemp680 = int(fTemp679);
			double fTemp681 = floor(fTemp679);
			double fTemp682 = (0.5 * fVec86[0]);
			double fTemp683 = (65536.0 * (fTemp682 - floor(fTemp682)));
			int iTemp684 = int(fTemp683);
			double fTemp685 = ftbl0[iTemp684];
			fRec13[0] = ((0.5 * ((((((fVec82[(IOTA-int((iTemp650 & 262143)))&262143] * (fTemp651 + (1 - fTemp649))) + ((fTemp649 - fTemp651) * fVec82[(IOTA-int((int((iTemp650 + 1)) & 262143)))&262143])) * (fTemp655 + ((fTemp653 - floor(fTemp653)) * (ftbl0[((iTemp654 + 1) % 65536)] - fTemp655)))) + (((fVec82[(IOTA-int((iTemp660 & 262143)))&262143] * (fTemp661 + (1 - fTemp659))) + ((fTemp659 - fTemp661) * fVec82[(IOTA-int((int((iTemp660 + 1)) & 262143)))&262143])) * (fTemp665 + ((fTemp663 - floor(fTemp663)) * (ftbl0[((iTemp664 + 1) % 65536)] - fTemp665))))) + (((fVec82[(IOTA-int((iTemp670 & 262143)))&262143] * (fTemp671 + (1 - fTemp669))) + ((fTemp669 - fTemp671) * fVec82[(IOTA-int((int((iTemp670 + 1)) & 262143)))&262143])) * (fTemp675 + ((fTemp673 - floor(fTemp673)) * (ftbl0[((iTemp674 + 1) % 65536)] - fTemp675))))) + (((fVec82[(IOTA-int((iTemp680 & 262143)))&262143] * (fTemp681 + (1 - fTemp679))) + ((fTemp679 - fTemp681) * fVec82[(IOTA-int((int((iTemp680 + 1)) & 262143)))&262143])) * (fTemp685 + ((fTemp683 - floor(fTemp683)) * (ftbl0[((iTemp684 + 1) % 65536)] - fTemp685)))))) + (fSlow334 * fTemp643));
			fRec148[0] = (fSlow351 + (fSlow3 * fRec148[1]));
			double fTemp686 = (((((((((((((((((fSlow335 * fTemp4) + (fSlow336 * fTemp5)) + (fSlow337 * fTemp6)) + (fSlow338 * fTemp7)) + (fSlow339 * fTemp8)) + (fSlow340 * fTemp9)) + (fSlow341 * fTemp10)) + (fSlow342 * fTemp11)) + (fSlow343 * fTemp12)) + (fSlow344 * fTemp13)) + (fSlow345 * fTemp14)) + (fSlow346 * fTemp15)) + (fSlow347 * fTemp16)) + (fSlow348 * fTemp17)) + (fSlow349 * fTemp18)) + (fSlow350 * fTemp19)) + ((double)input14[i] * fRec148[0]));
			fVec87[IOTA&1048575] = fTemp686;
			iRec149[0] = ((iSlow352 * iTemp22) + (iTemp23 * iRec149[1]));
			iRec150[0] = ((iSlow352 * iTemp25) + (iTemp26 * iRec150[1]));
			double fTemp687 = ((0.5 * (fVec0[0] * fVec87[(IOTA-int((int(iRec149[0]) & 1048575)))&1048575])) + (fVec2[0] * fVec87[(IOTA-int((int(iRec150[0]) & 1048575)))&1048575]));
			int iTemp688 = (fTemp687 > 1);
			int iTemp689 = (fTemp687 < -1);
			double fTemp690 = ((iTemp688 + ((fTemp687 * (1 - iTemp689)) * (1 - iTemp688))) - iTemp689);
			double fTemp691 = (fSlow58 * fTemp690);
			fVec88[IOTA&262143] = fTemp691;
			double fTemp692 = (fRec151[1] + (fSlow353 / fTemp33));
			fRec151[0] = (fTemp692 - floor(fTemp692));
			double fTemp693 = (fRec151[0] - floor(fRec151[0]));
			fVec89[0] = fTemp693;
			int iTemp694 = (fVec89[0] > 0.001);
			int iTemp695 = (fVec89[1] <= 0.001);
			fRec152[0] = ((fRec152[1] * (1 - (iTemp694 * iTemp695))) + ((fRec39[0] * iTemp694) * iTemp695));
			double fTemp696 = (fConst4 * (fVec89[0] * fRec152[0]));
			int iTemp697 = int(fTemp696);
			double fTemp698 = floor(fTemp696);
			double fTemp699 = (0.5 * fVec89[0]);
			double fTemp700 = (65536.0 * (fTemp699 - floor(fTemp699)));
			int iTemp701 = int(fTemp700);
			double fTemp702 = ftbl0[iTemp701];
			double fTemp703 = (fRec151[0] + (0.25 - floor((fRec151[0] + 0.25))));
			fVec90[0] = fTemp703;
			int iTemp704 = (fVec90[0] > 0.001);
			int iTemp705 = (fVec90[1] <= 0.001);
			fRec153[0] = ((fRec153[1] * (1 - (iTemp704 * iTemp705))) + ((fRec39[0] * iTemp704) * iTemp705));
			double fTemp706 = (fConst4 * (fVec90[0] * fRec153[0]));
			int iTemp707 = int(fTemp706);
			double fTemp708 = floor(fTemp706);
			double fTemp709 = (0.5 * fVec90[0]);
			double fTemp710 = (65536.0 * (fTemp709 - floor(fTemp709)));
			int iTemp711 = int(fTemp710);
			double fTemp712 = ftbl0[iTemp711];
			double fTemp713 = (fRec151[0] + (0.5 - floor((fRec151[0] + 0.5))));
			fVec91[0] = fTemp713;
			int iTemp714 = (fVec91[0] > 0.001);
			int iTemp715 = (fVec91[1] <= 0.001);
			fRec154[0] = ((fRec154[1] * (1 - (iTemp714 * iTemp715))) + ((fRec39[0] * iTemp714) * iTemp715));
			double fTemp716 = (fConst4 * (fVec91[0] * fRec154[0]));
			int iTemp717 = int(fTemp716);
			double fTemp718 = floor(fTemp716);
			double fTemp719 = (0.5 * fVec91[0]);
			double fTemp720 = (65536.0 * (fTemp719 - floor(fTemp719)));
			int iTemp721 = int(fTemp720);
			double fTemp722 = ftbl0[iTemp721];
			double fTemp723 = (fRec151[0] + (0.75 - floor((fRec151[0] + 0.75))));
			fVec92[0] = fTemp723;
			int iTemp724 = (fVec92[0] > 0.001);
			int iTemp725 = (fVec92[1] <= 0.001);
			fRec155[0] = ((fRec155[1] * (1 - (iTemp724 * iTemp725))) + ((fRec39[0] * iTemp724) * iTemp725));
			double fTemp726 = (fConst4 * (fVec92[0] * fRec155[0]));
			int iTemp727 = int(fTemp726);
			double fTemp728 = floor(fTemp726);
			double fTemp729 = (0.5 * fVec92[0]);
			double fTemp730 = (65536.0 * (fTemp729 - floor(fTemp729)));
			int iTemp731 = int(fTemp730);
			double fTemp732 = ftbl0[iTemp731];
			fRec14[0] = ((0.5 * ((((((fVec88[(IOTA-int((iTemp697 & 262143)))&262143] * (fTemp698 + (1 - fTemp696))) + ((fTemp696 - fTemp698) * fVec88[(IOTA-int((int((iTemp697 + 1)) & 262143)))&262143])) * (fTemp702 + ((fTemp700 - floor(fTemp700)) * (ftbl0[((iTemp701 + 1) % 65536)] - fTemp702)))) + (((fVec88[(IOTA-int((iTemp707 & 262143)))&262143] * (fTemp708 + (1 - fTemp706))) + ((fTemp706 - fTemp708) * fVec88[(IOTA-int((int((iTemp707 + 1)) & 262143)))&262143])) * (fTemp712 + ((fTemp710 - floor(fTemp710)) * (ftbl0[((iTemp711 + 1) % 65536)] - fTemp712))))) + (((fVec88[(IOTA-int((iTemp717 & 262143)))&262143] * (fTemp718 + (1 - fTemp716))) + ((fTemp716 - fTemp718) * fVec88[(IOTA-int((int((iTemp717 + 1)) & 262143)))&262143])) * (fTemp722 + ((fTemp720 - floor(fTemp720)) * (ftbl0[((iTemp721 + 1) % 65536)] - fTemp722))))) + (((fVec88[(IOTA-int((iTemp727 & 262143)))&262143] * (fTemp728 + (1 - fTemp726))) + ((fTemp726 - fTemp728) * fVec88[(IOTA-int((int((iTemp727 + 1)) & 262143)))&262143])) * (fTemp732 + ((fTemp730 - floor(fTemp730)) * (ftbl0[((iTemp731 + 1) % 65536)] - fTemp732)))))) + (fSlow354 * fTemp690));
			fRec156[0] = (fSlow355 + (fSlow3 * fRec156[1]));
			double fTemp733 = ((((((((((((((((((double)input15[i] * fRec156[0]) + (fSlow356 * fTemp4)) + (fSlow357 * fTemp5)) + (fSlow358 * fTemp6)) + (fSlow359 * fTemp7)) + (fSlow360 * fTemp8)) + (fSlow361 * fTemp9)) + (fSlow362 * fTemp10)) + (fSlow363 * fTemp11)) + (fSlow364 * fTemp12)) + (fSlow365 * fTemp13)) + (fSlow366 * fTemp14)) + (fSlow367 * fTemp15)) + (fSlow368 * fTemp16)) + (fSlow369 * fTemp17)) + (fSlow370 * fTemp18)) + (fSlow371 * fTemp19));
			fVec93[IOTA&1048575] = fTemp733;
			iRec157[0] = ((iSlow372 * iTemp22) + (iTemp23 * iRec157[1]));
			iRec158[0] = ((iSlow372 * iTemp25) + (iTemp26 * iRec158[1]));
			double fTemp734 = ((0.5 * (fVec0[0] * fVec93[(IOTA-int((int(iRec157[0]) & 1048575)))&1048575])) + (fVec2[0] * fVec93[(IOTA-int((int(iRec158[0]) & 1048575)))&1048575]));
			int iTemp735 = (fTemp734 > 1);
			int iTemp736 = (fTemp734 < -1);
			double fTemp737 = ((iTemp735 + ((fTemp734 * (1 - iTemp736)) * (1 - iTemp735))) - iTemp736);
			double fTemp738 = (fSlow62 * fTemp737);
			fVec94[IOTA&262143] = fTemp738;
			double fTemp739 = (fRec159[1] + (fSlow373 / fTemp33));
			fRec159[0] = (fTemp739 - floor(fTemp739));
			double fTemp740 = (fRec159[0] - floor(fRec159[0]));
			fVec95[0] = fTemp740;
			int iTemp741 = (fVec95[0] > 0.001);
			int iTemp742 = (fVec95[1] <= 0.001);
			fRec160[0] = ((fRec160[1] * (1 - (iTemp741 * iTemp742))) + ((fRec39[0] * iTemp741) * iTemp742));
			double fTemp743 = (fConst4 * (fVec95[0] * fRec160[0]));
			int iTemp744 = int(fTemp743);
			double fTemp745 = floor(fTemp743);
			double fTemp746 = (0.5 * fVec95[0]);
			double fTemp747 = (65536.0 * (fTemp746 - floor(fTemp746)));
			int iTemp748 = int(fTemp747);
			double fTemp749 = ftbl0[iTemp748];
			double fTemp750 = (fRec159[0] + (0.25 - floor((fRec159[0] + 0.25))));
			fVec96[0] = fTemp750;
			int iTemp751 = (fVec96[0] > 0.001);
			int iTemp752 = (fVec96[1] <= 0.001);
			fRec161[0] = ((fRec161[1] * (1 - (iTemp751 * iTemp752))) + ((fRec39[0] * iTemp751) * iTemp752));
			double fTemp753 = (fConst4 * (fVec96[0] * fRec161[0]));
			int iTemp754 = int(fTemp753);
			double fTemp755 = floor(fTemp753);
			double fTemp756 = (0.5 * fVec96[0]);
			double fTemp757 = (65536.0 * (fTemp756 - floor(fTemp756)));
			int iTemp758 = int(fTemp757);
			double fTemp759 = ftbl0[iTemp758];
			double fTemp760 = (fRec159[0] + (0.5 - floor((fRec159[0] + 0.5))));
			fVec97[0] = fTemp760;
			int iTemp761 = (fVec97[0] > 0.001);
			int iTemp762 = (fVec97[1] <= 0.001);
			fRec162[0] = ((fRec162[1] * (1 - (iTemp761 * iTemp762))) + ((fRec39[0] * iTemp761) * iTemp762));
			double fTemp763 = (fConst4 * (fVec97[0] * fRec162[0]));
			int iTemp764 = int(fTemp763);
			double fTemp765 = floor(fTemp763);
			double fTemp766 = (0.5 * fVec97[0]);
			double fTemp767 = (65536.0 * (fTemp766 - floor(fTemp766)));
			int iTemp768 = int(fTemp767);
			double fTemp769 = ftbl0[iTemp768];
			double fTemp770 = (fRec159[0] + (0.75 - floor((fRec159[0] + 0.75))));
			fVec98[0] = fTemp770;
			int iTemp771 = (fVec98[0] > 0.001);
			int iTemp772 = (fVec98[1] <= 0.001);
			fRec163[0] = ((fRec163[1] * (1 - (iTemp771 * iTemp772))) + ((fRec39[0] * iTemp771) * iTemp772));
			double fTemp773 = (fConst4 * (fVec98[0] * fRec163[0]));
			int iTemp774 = int(fTemp773);
			double fTemp775 = floor(fTemp773);
			double fTemp776 = (0.5 * fVec98[0]);
			double fTemp777 = (65536.0 * (fTemp776 - floor(fTemp776)));
			int iTemp778 = int(fTemp777);
			double fTemp779 = ftbl0[iTemp778];
			fRec15[0] = ((0.5 * ((((((fVec94[(IOTA-int((iTemp744 & 262143)))&262143] * (fTemp745 + (1 - fTemp743))) + ((fTemp743 - fTemp745) * fVec94[(IOTA-int((int((iTemp744 + 1)) & 262143)))&262143])) * (fTemp749 + ((fTemp747 - floor(fTemp747)) * (ftbl0[((iTemp748 + 1) % 65536)] - fTemp749)))) + (((fVec94[(IOTA-int((iTemp754 & 262143)))&262143] * (fTemp755 + (1 - fTemp753))) + ((fTemp753 - fTemp755) * fVec94[(IOTA-int((int((iTemp754 + 1)) & 262143)))&262143])) * (fTemp759 + ((fTemp757 - floor(fTemp757)) * (ftbl0[((iTemp758 + 1) % 65536)] - fTemp759))))) + (((fVec94[(IOTA-int((iTemp764 & 262143)))&262143] * (fTemp765 + (1 - fTemp763))) + ((fTemp763 - fTemp765) * fVec94[(IOTA-int((int((iTemp764 + 1)) & 262143)))&262143])) * (fTemp769 + ((fTemp767 - floor(fTemp767)) * (ftbl0[((iTemp768 + 1) % 65536)] - fTemp769))))) + (((fVec94[(IOTA-int((iTemp774 & 262143)))&262143] * (fTemp775 + (1 - fTemp773))) + ((fTemp773 - fTemp775) * fVec94[(IOTA-int((int((iTemp774 + 1)) & 262143)))&262143])) * (fTemp779 + ((fTemp777 - floor(fTemp777)) * (ftbl0[((iTemp778 + 1) % 65536)] - fTemp779)))))) + (fSlow374 * fTemp737));
			fRec164[0] = (fSlow375 + (fSlow3 * fRec164[1]));
			output0[i] = (FAUSTFLOAT)(fRec0[0] * fRec164[0]);
			fRec165[0] = (fSlow376 + (fSlow3 * fRec165[1]));
			output1[i] = (FAUSTFLOAT)(fRec1[0] * fRec165[0]);
			fRec166[0] = (fSlow377 + (fSlow3 * fRec166[1]));
			output2[i] = (FAUSTFLOAT)(fRec2[0] * fRec166[0]);
			fRec167[0] = (fSlow378 + (fSlow3 * fRec167[1]));
			output3[i] = (FAUSTFLOAT)(fRec3[0] * fRec167[0]);
			fRec168[0] = (fSlow379 + (fSlow3 * fRec168[1]));
			output4[i] = (FAUSTFLOAT)(fRec4[0] * fRec168[0]);
			fRec169[0] = (fSlow380 + (fSlow3 * fRec169[1]));
			output5[i] = (FAUSTFLOAT)(fRec5[0] * fRec169[0]);
			fRec170[0] = (fSlow381 + (fSlow3 * fRec170[1]));
			output6[i] = (FAUSTFLOAT)(fRec6[0] * fRec170[0]);
			fRec171[0] = (fSlow382 + (fSlow3 * fRec171[1]));
			output7[i] = (FAUSTFLOAT)(fRec7[0] * fRec171[0]);
			fRec172[0] = (fSlow383 + (fSlow3 * fRec172[1]));
			output8[i] = (FAUSTFLOAT)(fRec8[0] * fRec172[0]);
			fRec173[0] = (fSlow384 + (fSlow3 * fRec173[1]));
			output9[i] = (FAUSTFLOAT)(fRec9[0] * fRec173[0]);
			fRec174[0] = (fSlow385 + (fSlow3 * fRec174[1]));
			output10[i] = (FAUSTFLOAT)(fRec10[0] * fRec174[0]);
			fRec175[0] = (fSlow386 + (fSlow3 * fRec175[1]));
			output11[i] = (FAUSTFLOAT)(fRec11[0] * fRec175[0]);
			fRec176[0] = (fSlow387 + (fSlow3 * fRec176[1]));
			output12[i] = (FAUSTFLOAT)(fRec12[0] * fRec176[0]);
			fRec177[0] = (fSlow388 + (fSlow3 * fRec177[1]));
			output13[i] = (FAUSTFLOAT)(fRec13[0] * fRec177[0]);
			fRec178[0] = (fSlow389 + (fSlow3 * fRec178[1]));
			output14[i] = (FAUSTFLOAT)(fRec14[0] * fRec178[0]);
			fRec179[0] = (fSlow390 + (fSlow3 * fRec179[1]));
			output15[i] = (FAUSTFLOAT)(fRec15[0] * fRec179[0]);
			// post processing
			fRec179[1] = fRec179[0];
			fRec178[1] = fRec178[0];
			fRec177[1] = fRec177[0];
			fRec176[1] = fRec176[0];
			fRec175[1] = fRec175[0];
			fRec174[1] = fRec174[0];
			fRec173[1] = fRec173[0];
			fRec172[1] = fRec172[0];
			fRec171[1] = fRec171[0];
			fRec170[1] = fRec170[0];
			fRec169[1] = fRec169[0];
			fRec168[1] = fRec168[0];
			fRec167[1] = fRec167[0];
			fRec166[1] = fRec166[0];
			fRec165[1] = fRec165[0];
			fRec164[1] = fRec164[0];
			fRec15[1] = fRec15[0];
			fRec163[1] = fRec163[0];
			fVec98[1] = fVec98[0];
			fRec162[1] = fRec162[0];
			fVec97[1] = fVec97[0];
			fRec161[1] = fRec161[0];
			fVec96[1] = fVec96[0];
			fRec160[1] = fRec160[0];
			fVec95[1] = fVec95[0];
			fRec159[1] = fRec159[0];
			iRec158[1] = iRec158[0];
			iRec157[1] = iRec157[0];
			fRec156[1] = fRec156[0];
			fRec14[1] = fRec14[0];
			fRec155[1] = fRec155[0];
			fVec92[1] = fVec92[0];
			fRec154[1] = fRec154[0];
			fVec91[1] = fVec91[0];
			fRec153[1] = fRec153[0];
			fVec90[1] = fVec90[0];
			fRec152[1] = fRec152[0];
			fVec89[1] = fVec89[0];
			fRec151[1] = fRec151[0];
			iRec150[1] = iRec150[0];
			iRec149[1] = iRec149[0];
			fRec148[1] = fRec148[0];
			fRec13[1] = fRec13[0];
			fRec147[1] = fRec147[0];
			fVec86[1] = fVec86[0];
			fRec146[1] = fRec146[0];
			fVec85[1] = fVec85[0];
			fRec145[1] = fRec145[0];
			fVec84[1] = fVec84[0];
			fRec144[1] = fRec144[0];
			fVec83[1] = fVec83[0];
			fRec143[1] = fRec143[0];
			iRec142[1] = iRec142[0];
			iRec141[1] = iRec141[0];
			fRec140[1] = fRec140[0];
			fRec12[1] = fRec12[0];
			fRec139[1] = fRec139[0];
			fVec80[1] = fVec80[0];
			fRec138[1] = fRec138[0];
			fVec79[1] = fVec79[0];
			fRec137[1] = fRec137[0];
			fVec78[1] = fVec78[0];
			fRec136[1] = fRec136[0];
			fVec77[1] = fVec77[0];
			fRec135[1] = fRec135[0];
			iRec134[1] = iRec134[0];
			iRec133[1] = iRec133[0];
			fRec132[1] = fRec132[0];
			fRec11[1] = fRec11[0];
			fRec131[1] = fRec131[0];
			fVec74[1] = fVec74[0];
			fRec130[1] = fRec130[0];
			fVec73[1] = fVec73[0];
			fRec129[1] = fRec129[0];
			fVec72[1] = fVec72[0];
			fRec128[1] = fRec128[0];
			fVec71[1] = fVec71[0];
			fRec127[1] = fRec127[0];
			iRec126[1] = iRec126[0];
			iRec125[1] = iRec125[0];
			fRec124[1] = fRec124[0];
			fRec10[1] = fRec10[0];
			fRec123[1] = fRec123[0];
			fVec68[1] = fVec68[0];
			fRec122[1] = fRec122[0];
			fVec67[1] = fVec67[0];
			fRec121[1] = fRec121[0];
			fVec66[1] = fVec66[0];
			fRec120[1] = fRec120[0];
			fVec65[1] = fVec65[0];
			fRec119[1] = fRec119[0];
			iRec118[1] = iRec118[0];
			iRec117[1] = iRec117[0];
			fRec116[1] = fRec116[0];
			fRec9[1] = fRec9[0];
			fRec115[1] = fRec115[0];
			fVec62[1] = fVec62[0];
			fRec114[1] = fRec114[0];
			fVec61[1] = fVec61[0];
			fRec113[1] = fRec113[0];
			fVec60[1] = fVec60[0];
			fRec112[1] = fRec112[0];
			fVec59[1] = fVec59[0];
			fRec111[1] = fRec111[0];
			iRec110[1] = iRec110[0];
			iRec109[1] = iRec109[0];
			fRec108[1] = fRec108[0];
			fRec8[1] = fRec8[0];
			fRec107[1] = fRec107[0];
			fVec56[1] = fVec56[0];
			fRec106[1] = fRec106[0];
			fVec55[1] = fVec55[0];
			fRec105[1] = fRec105[0];
			fVec54[1] = fVec54[0];
			iRec104[1] = iRec104[0];
			iRec103[1] = iRec103[0];
			fRec102[1] = fRec102[0];
			fRec101[1] = fRec101[0];
			fVec51[1] = fVec51[0];
			fRec100[1] = fRec100[0];
			fRec7[1] = fRec7[0];
			fRec99[1] = fRec99[0];
			fVec50[1] = fVec50[0];
			fRec98[1] = fRec98[0];
			fVec49[1] = fVec49[0];
			fRec97[1] = fRec97[0];
			fVec48[1] = fVec48[0];
			fRec96[1] = fRec96[0];
			fVec47[1] = fVec47[0];
			fRec95[1] = fRec95[0];
			iRec94[1] = iRec94[0];
			iRec93[1] = iRec93[0];
			fRec92[1] = fRec92[0];
			fRec6[1] = fRec6[0];
			fRec91[1] = fRec91[0];
			fVec44[1] = fVec44[0];
			fRec90[1] = fRec90[0];
			fVec43[1] = fVec43[0];
			fRec89[1] = fRec89[0];
			fVec42[1] = fVec42[0];
			fRec88[1] = fRec88[0];
			fVec41[1] = fVec41[0];
			fRec87[1] = fRec87[0];
			iRec86[1] = iRec86[0];
			iRec85[1] = iRec85[0];
			fRec84[1] = fRec84[0];
			fRec5[1] = fRec5[0];
			fRec83[1] = fRec83[0];
			fVec38[1] = fVec38[0];
			fRec82[1] = fRec82[0];
			fVec37[1] = fVec37[0];
			fRec81[1] = fRec81[0];
			fVec36[1] = fVec36[0];
			fRec80[1] = fRec80[0];
			fVec35[1] = fVec35[0];
			fRec79[1] = fRec79[0];
			iRec78[1] = iRec78[0];
			iRec77[1] = iRec77[0];
			fRec76[1] = fRec76[0];
			fRec4[1] = fRec4[0];
			fRec75[1] = fRec75[0];
			fVec32[1] = fVec32[0];
			fRec74[1] = fRec74[0];
			fVec31[1] = fVec31[0];
			fRec73[1] = fRec73[0];
			fVec30[1] = fVec30[0];
			fRec72[1] = fRec72[0];
			fVec29[1] = fVec29[0];
			fRec71[1] = fRec71[0];
			iRec70[1] = iRec70[0];
			iRec69[1] = iRec69[0];
			fRec68[1] = fRec68[0];
			fRec3[1] = fRec3[0];
			fRec67[1] = fRec67[0];
			fVec26[1] = fVec26[0];
			fRec66[1] = fRec66[0];
			fVec25[1] = fVec25[0];
			fRec65[1] = fRec65[0];
			fVec24[1] = fVec24[0];
			fRec64[1] = fRec64[0];
			fVec23[1] = fVec23[0];
			fRec63[1] = fRec63[0];
			iRec62[1] = iRec62[0];
			iRec61[1] = iRec61[0];
			fRec60[1] = fRec60[0];
			fRec2[1] = fRec2[0];
			fRec59[1] = fRec59[0];
			fVec20[1] = fVec20[0];
			fRec58[1] = fRec58[0];
			fVec19[1] = fVec19[0];
			fRec57[1] = fRec57[0];
			fVec18[1] = fVec18[0];
			fRec56[1] = fRec56[0];
			fVec17[1] = fVec17[0];
			fRec55[1] = fRec55[0];
			iRec54[1] = iRec54[0];
			iRec53[1] = iRec53[0];
			fRec52[1] = fRec52[0];
			fRec1[1] = fRec1[0];
			fRec51[1] = fRec51[0];
			fVec14[1] = fVec14[0];
			fRec50[1] = fRec50[0];
			fVec13[1] = fVec13[0];
			fRec49[1] = fRec49[0];
			fVec12[1] = fVec12[0];
			fRec48[1] = fRec48[0];
			fVec11[1] = fVec11[0];
			fRec47[1] = fRec47[0];
			iRec46[1] = iRec46[0];
			iRec45[1] = iRec45[0];
			fRec44[1] = fRec44[0];
			fRec0[1] = fRec0[0];
			fRec43[1] = fRec43[0];
			fVec8[1] = fVec8[0];
			fRec42[1] = fRec42[0];
			fVec7[1] = fVec7[0];
			fRec41[1] = fRec41[0];
			fVec6[1] = fVec6[0];
			fRec40[1] = fRec40[0];
			fVec5[1] = fVec5[0];
			fRec37[1] = fRec37[0];
			fRec39[1] = fRec39[0];
			fRec38[1] = fRec38[0];
			fVec4[1] = fVec4[0];
			iRec36[1] = iRec36[0];
			fVec2[1] = fVec2[0];
			iRec35[1] = iRec35[0];
			IOTA = IOTA+1;
			fRec34[1] = fRec34[0];
			fRec33[1] = fRec33[0];
			fRec32[1] = fRec32[0];
			fRec31[1] = fRec31[0];
			fRec30[1] = fRec30[0];
			fRec29[1] = fRec29[0];
			fRec28[1] = fRec28[0];
			fRec27[1] = fRec27[0];
			fRec26[1] = fRec26[0];
			fRec25[1] = fRec25[0];
			fRec24[1] = fRec24[0];
			fRec23[1] = fRec23[0];
			fRec22[1] = fRec22[0];
			fRec21[1] = fRec21[0];
			fRec20[1] = fRec20[0];
			fRec19[1] = fRec19[0];
			fRec18[1] = fRec18[0];
			fVec0[1] = fVec0[0];
			fRec17[1] = fRec17[0];
		}
	}
};


double 	mydsp::ftbl0[65536];

/***************************END USER SECTION ***************************/

/*******************BEGIN ARCHITECTURE SECTION (part 2/2)***************/

/* Faust code wrapper ------- */

#include "ext.h"
#include "ext_obex.h"
#include "z_dsp.h"
#include "jpatcher_api.h"
#include <string.h>

#define ASSIST_INLET 	1  		/* should be defined somewhere ?? */
#define ASSIST_OUTLET 	2		/* should be defined somewhere ?? */

#define EXTERNAL_VERSION "0.60"

/************************************************************************
    FAUST Architecture File
    Copyright (C) 2003-2016 GRAME, Centre National de Creation Musicale
    ---------------------------------------------------------------------
    This Architecture section is free software; you can redistribute it
    and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 3 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; If not, see <http://www.gnu.org/licenses/>.

    EXCEPTION : As a special exception, you may create a larger work
    that contains this FAUST architecture section and distribute
    that work under terms of your choice, so long as this FAUST
    architecture section is not modified.

 ************************************************************************
 ************************************************************************/
 
#ifndef FAUST_GUI_H
#define FAUST_GUI_H

/*
  Copyright (C) 2000 Paul Davis
  Copyright (C) 2003 Rohan Drape
  Copyright (C) 2016 GRAME (renaming for internal use)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation; either version 2.1 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

  ISO/POSIX C version of Paul Davis's lock free ringbuffer C++ code.
  This is safe for the case of one read thread and one write thread.
*/

#ifndef __ring_buffer__
#define __ring_buffer__

#include <stdlib.h>
#include <string.h>

typedef struct {
    char *buf;
    size_t len;
}
ringbuffer_data_t;

typedef struct {
    char *buf;
    volatile size_t write_ptr;
    volatile size_t read_ptr;
    size_t	size;
    size_t	size_mask;
    int	mlocked;
}
ringbuffer_t;

ringbuffer_t *ringbuffer_create(size_t sz);
void ringbuffer_free(ringbuffer_t *rb);
void ringbuffer_get_read_vector(const ringbuffer_t *rb,
                                         ringbuffer_data_t *vec);
void ringbuffer_get_write_vector(const ringbuffer_t *rb,
                                          ringbuffer_data_t *vec);
size_t ringbuffer_read(ringbuffer_t *rb, char *dest, size_t cnt);
size_t ringbuffer_peek(ringbuffer_t *rb, char *dest, size_t cnt);
void ringbuffer_read_advance(ringbuffer_t *rb, size_t cnt);
size_t ringbuffer_read_space(const ringbuffer_t *rb);
int ringbuffer_mlock(ringbuffer_t *rb);
void ringbuffer_reset(ringbuffer_t *rb);
void ringbuffer_reset_size (ringbuffer_t * rb, size_t sz);
size_t ringbuffer_write(ringbuffer_t *rb, const char *src,
                                 size_t cnt);
void ringbuffer_write_advance(ringbuffer_t *rb, size_t cnt);
size_t ringbuffer_write_space(const ringbuffer_t *rb);

/* Create a new ringbuffer to hold at least `sz' bytes of data. The
   actual buffer size is rounded up to the next power of two.  */

inline ringbuffer_t *
ringbuffer_create (size_t sz)
{
	size_t power_of_two;
	ringbuffer_t *rb;

	if ((rb = (ringbuffer_t *) malloc (sizeof (ringbuffer_t))) == NULL) {
		return NULL;
	}

	for (power_of_two = 1u; 1u << power_of_two < sz; power_of_two++);

	rb->size = 1u << power_of_two;
	rb->size_mask = rb->size;
	rb->size_mask -= 1;
	rb->write_ptr = 0;
	rb->read_ptr = 0;
	if ((rb->buf = (char *) malloc (rb->size)) == NULL) {
		free (rb);
		return NULL;
	}
	rb->mlocked = 0;

	return rb;
}

/* Free all data associated with the ringbuffer `rb'. */

inline void
ringbuffer_free (ringbuffer_t * rb)
{
#ifdef USE_MLOCK
	if (rb->mlocked) {
		munlock (rb->buf, rb->size);
	}
#endif /* USE_MLOCK */
	free (rb->buf);
	free (rb);
}

/* Lock the data block of `rb' using the system call 'mlock'.  */

inline int
ringbuffer_mlock (ringbuffer_t * rb)
{
#ifdef USE_MLOCK
	if (mlock (rb->buf, rb->size)) {
		return -1;
	}
#endif /* USE_MLOCK */
	rb->mlocked = 1;
	return 0;
}

/* Reset the read and write pointers to zero. This is not thread
   safe. */

inline void
ringbuffer_reset (ringbuffer_t * rb)
{
	rb->read_ptr = 0;
	rb->write_ptr = 0;
    memset(rb->buf, 0, rb->size);
}

/* Reset the read and write pointers to zero. This is not thread
   safe. */

inline void
ringbuffer_reset_size (ringbuffer_t * rb, size_t sz)
{
    rb->size = sz;
    rb->size_mask = rb->size;
    rb->size_mask -= 1;
    rb->read_ptr = 0;
    rb->write_ptr = 0;
}

/* Return the number of bytes available for reading.  This is the
   number of bytes in front of the read pointer and behind the write
   pointer.  */

inline size_t
ringbuffer_read_space (const ringbuffer_t * rb)
{
	size_t w, r;

	w = rb->write_ptr;
	r = rb->read_ptr;

	if (w > r) {
		return w - r;
	} else {
		return (w - r + rb->size) & rb->size_mask;
	}
}

/* Return the number of bytes available for writing.  This is the
   number of bytes in front of the write pointer and behind the read
   pointer.  */

inline size_t
ringbuffer_write_space (const ringbuffer_t * rb)
{
	size_t w, r;

	w = rb->write_ptr;
	r = rb->read_ptr;

	if (w > r) {
		return ((r - w + rb->size) & rb->size_mask) - 1;
	} else if (w < r) {
		return (r - w) - 1;
	} else {
		return rb->size - 1;
	}
}

/* The copying data reader.  Copy at most `cnt' bytes from `rb' to
   `dest'.  Returns the actual number of bytes copied. */

inline size_t
ringbuffer_read (ringbuffer_t * rb, char *dest, size_t cnt)
{
	size_t free_cnt;
	size_t cnt2;
	size_t to_read;
	size_t n1, n2;

	if ((free_cnt = ringbuffer_read_space (rb)) == 0) {
		return 0;
	}

	to_read = cnt > free_cnt ? free_cnt : cnt;

	cnt2 = rb->read_ptr + to_read;

	if (cnt2 > rb->size) {
		n1 = rb->size - rb->read_ptr;
		n2 = cnt2 & rb->size_mask;
	} else {
		n1 = to_read;
		n2 = 0;
	}

	memcpy (dest, &(rb->buf[rb->read_ptr]), n1);
	rb->read_ptr = (rb->read_ptr + n1) & rb->size_mask;

	if (n2) {
		memcpy (dest + n1, &(rb->buf[rb->read_ptr]), n2);
		rb->read_ptr = (rb->read_ptr + n2) & rb->size_mask;
	}

	return to_read;
}

/* The copying data reader w/o read pointer advance.  Copy at most
   `cnt' bytes from `rb' to `dest'.  Returns the actual number of bytes
   copied. */

inline size_t
ringbuffer_peek (ringbuffer_t * rb, char *dest, size_t cnt)
{
	size_t free_cnt;
	size_t cnt2;
	size_t to_read;
	size_t n1, n2;
	size_t tmp_read_ptr;

	tmp_read_ptr = rb->read_ptr;

	if ((free_cnt = ringbuffer_read_space (rb)) == 0) {
		return 0;
	}

	to_read = cnt > free_cnt ? free_cnt : cnt;

	cnt2 = tmp_read_ptr + to_read;

	if (cnt2 > rb->size) {
		n1 = rb->size - tmp_read_ptr;
		n2 = cnt2 & rb->size_mask;
	} else {
		n1 = to_read;
		n2 = 0;
	}

	memcpy (dest, &(rb->buf[tmp_read_ptr]), n1);
	tmp_read_ptr = (tmp_read_ptr + n1) & rb->size_mask;

	if (n2) {
		memcpy (dest + n1, &(rb->buf[tmp_read_ptr]), n2);
	}

	return to_read;
}

/* The copying data writer.  Copy at most `cnt' bytes to `rb' from
   `src'.  Returns the actual number of bytes copied. */

inline size_t
ringbuffer_write (ringbuffer_t * rb, const char *src, size_t cnt)
{
	size_t free_cnt;
	size_t cnt2;
	size_t to_write;
	size_t n1, n2;

	if ((free_cnt = ringbuffer_write_space (rb)) == 0) {
		return 0;
	}

	to_write = cnt > free_cnt ? free_cnt : cnt;

	cnt2 = rb->write_ptr + to_write;

	if (cnt2 > rb->size) {
		n1 = rb->size - rb->write_ptr;
		n2 = cnt2 & rb->size_mask;
	} else {
		n1 = to_write;
		n2 = 0;
	}

	memcpy (&(rb->buf[rb->write_ptr]), src, n1);
	rb->write_ptr = (rb->write_ptr + n1) & rb->size_mask;

	if (n2) {
		memcpy (&(rb->buf[rb->write_ptr]), src + n1, n2);
		rb->write_ptr = (rb->write_ptr + n2) & rb->size_mask;
	}

	return to_write;
}

/* Advance the read pointer `cnt' places. */

inline void
ringbuffer_read_advance (ringbuffer_t * rb, size_t cnt)
{
	size_t tmp = (rb->read_ptr + cnt) & rb->size_mask;
	rb->read_ptr = tmp;
}

/* Advance the write pointer `cnt' places. */

inline void
ringbuffer_write_advance (ringbuffer_t * rb, size_t cnt)
{
	size_t tmp = (rb->write_ptr + cnt) & rb->size_mask;
	rb->write_ptr = tmp;
}

/* The non-copying data reader.  `vec' is an array of two places.  Set
   the values at `vec' to hold the current readable data at `rb'.  If
   the readable data is in one segment the second segment has zero
   length.  */

inline void
ringbuffer_get_read_vector (const ringbuffer_t * rb,
				 ringbuffer_data_t * vec)
{
	size_t free_cnt;
	size_t cnt2;
	size_t w, r;

	w = rb->write_ptr;
	r = rb->read_ptr;

	if (w > r) {
		free_cnt = w - r;
	} else {
		free_cnt = (w - r + rb->size) & rb->size_mask;
	}

	cnt2 = r + free_cnt;

	if (cnt2 > rb->size) {

		/* Two part vector: the rest of the buffer after the current write
		   ptr, plus some from the start of the buffer. */

		vec[0].buf = &(rb->buf[r]);
		vec[0].len = rb->size - r;
		vec[1].buf = rb->buf;
		vec[1].len = cnt2 & rb->size_mask;

	} else {

		/* Single part vector: just the rest of the buffer */

		vec[0].buf = &(rb->buf[r]);
		vec[0].len = free_cnt;
		vec[1].len = 0;
	}
}

/* The non-copying data writer.  `vec' is an array of two places.  Set
   the values at `vec' to hold the current writeable data at `rb'.  If
   the writeable data is in one segment the second segment has zero
   length.  */

inline void
ringbuffer_get_write_vector (const ringbuffer_t * rb,
				  ringbuffer_data_t * vec)
{
	size_t free_cnt;
	size_t cnt2;
	size_t w, r;

	w = rb->write_ptr;
	r = rb->read_ptr;

	if (w > r) {
		free_cnt = ((r - w + rb->size) & rb->size_mask) - 1;
	} else if (w < r) {
		free_cnt = (r - w) - 1;
	} else {
		free_cnt = rb->size - 1;
	}

	cnt2 = w + free_cnt;

	if (cnt2 > rb->size) {

		/* Two part vector: the rest of the buffer after the current write
		   ptr, plus some from the start of the buffer. */

		vec[0].buf = &(rb->buf[w]);
		vec[0].len = rb->size - w;
		vec[1].buf = rb->buf;
		vec[1].len = cnt2 & rb->size_mask;
	} else {
		vec[0].buf = &(rb->buf[w]);
		vec[0].len = free_cnt;
		vec[1].len = 0;
	}
}

#endif // __ring_buffer__

#include <list>
#include <map>
#include <vector>

/*******************************************************************************
 * GUI : Abstract Graphic User Interface
 * Provides additional mechanisms to synchronize widgets and zones. Widgets
 * should both reflect the value of a zone and allow to change this value.
 ******************************************************************************/

class uiItem;
typedef void (*uiCallback)(FAUSTFLOAT val, void* data);

class clist : public std::list<uiItem*>
{
    public:
    
        virtual ~clist();
        
};

typedef std::map<FAUSTFLOAT*, clist*> zmap;

typedef std::map<FAUSTFLOAT*, ringbuffer_t*> ztimedmap;

class GUI : public UI
{
		
    private:
     
        static std::list<GUI*>  fGuiList;
        zmap                    fZoneMap;
        bool                    fStopped;
        
     public:
            
        GUI() : fStopped(false) 
        {	
            fGuiList.push_back(this);
        }
        
        virtual ~GUI() 
        {   
            // delete all 
            zmap::iterator g;
            for (g = fZoneMap.begin(); g != fZoneMap.end(); g++) {
                delete (*g).second;
            }
            // suppress 'this' in static fGuiList
            fGuiList.remove(this);
        }

        // -- registerZone(z,c) : zone management
        
        void registerZone(FAUSTFLOAT* z, uiItem* c)
        {
            if (fZoneMap.find(z) == fZoneMap.end()) fZoneMap[z] = new clist();
            fZoneMap[z]->push_back(c);
        }

        void updateAllZones();
        
        void updateZone(FAUSTFLOAT* z);
        
        static void updateAllGuis()
        {
            std::list<GUI*>::iterator g;
            for (g = fGuiList.begin(); g != fGuiList.end(); g++) {
                (*g)->updateAllZones();
            }
        }
        void addCallback(FAUSTFLOAT* zone, uiCallback foo, void* data);
        virtual void show() {};	
        virtual bool run() { return false; };
    
        virtual void stop() { fStopped = true; }
        bool stopped() { return fStopped; }
    
        // -- widget's layouts
        
        virtual void openTabBox(const char* label) {};
        virtual void openHorizontalBox(const char* label) {}
        virtual void openVerticalBox(const char* label) {}
        virtual void closeBox() {}
        
        // -- active widgets
        
        virtual void addButton(const char* label, FAUSTFLOAT* zone) {}
        virtual void addCheckButton(const char* label, FAUSTFLOAT* zone) {}
        virtual void addVerticalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step) {}
        virtual void addHorizontalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step) {}
        virtual void addNumEntry(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step) {}
    
        // -- passive widgets
        
        virtual void addHorizontalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max) {}
        virtual void addVerticalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max) {}
    
        // -- metadata declarations

        virtual void declare(FAUSTFLOAT* , const char* , const char*) {}
    
        // Static global for timed zones, shared between all UI that will set timed values
        static ztimedmap gTimedZoneMap;

};

/**
 * User Interface Item: abstract definition
 */

class uiItem
{
    protected:
          
        GUI*            fGUI;
        FAUSTFLOAT*     fZone;
        FAUSTFLOAT      fCache;

        uiItem(GUI* ui, FAUSTFLOAT* zone):fGUI(ui), fZone(zone), fCache(FAUSTFLOAT(-123456.654321))
        { 
            ui->registerZone(zone, this); 
        }

    public:

        virtual ~uiItem() 
        {}

        void modifyZone(FAUSTFLOAT v) 	
        { 
            fCache = v;
            if (*fZone != v) {
                *fZone = v;
                fGUI->updateZone(fZone);
            }
        }
                
        FAUSTFLOAT		cache()	{ return fCache; }
        virtual void 	reflectZone() = 0;	
};

/**
 * User Interface item owned (and so deleted) by external code
 */

class uiOwnedItem : public uiItem {
    
    protected:
    
        uiOwnedItem(GUI* ui, FAUSTFLOAT* zone):uiItem(ui, zone)
        {}
    
     public:
    
        virtual ~uiOwnedItem()
        {}
    
        virtual void reflectZone() {}
};

/**
 * Callback Item
 */

struct uiCallbackItem : public uiItem
{
	uiCallback	fCallback;
	void*		fData;
	
	uiCallbackItem(GUI* ui, FAUSTFLOAT* zone, uiCallback foo, void* data) 
			: uiItem(ui, zone), fCallback(foo), fData(data) {}
	
	virtual void reflectZone() 
    {		
		FAUSTFLOAT 	v = *fZone;
		fCache = v; 
		fCallback(v, fData);	
	}
};

/**
 * Allows to group a set of zones.
 */
 
class uiGroupItem : public uiItem 
{
    protected:
    
        std::vector<FAUSTFLOAT*> fZoneMap;

    public:
    
        uiGroupItem(GUI* ui, FAUSTFLOAT* zone):uiItem(ui, zone)
        {}
        virtual ~uiGroupItem() 
        {}
        
        virtual void reflectZone() 
        {
            FAUSTFLOAT v = *fZone;
            fCache = v;
            
            // Update all zones of the same group
            std::vector<FAUSTFLOAT*>::iterator it;
            for (it = fZoneMap.begin(); it != fZoneMap.end(); it++) {
                (*(*it)) = v;
            }
        }
        
        void addZone(FAUSTFLOAT* zone) { fZoneMap.push_back(zone); }

};

/**
 * Update all user items reflecting zone z
 */

inline void GUI::updateZone(FAUSTFLOAT* z)
{
	FAUSTFLOAT v = *z;
	clist* l = fZoneMap[z];
	for (clist::iterator c = l->begin(); c != l->end(); c++) {
		if ((*c)->cache() != v) (*c)->reflectZone();
	}
}

/**
 * Update all user items not up to date
 */

inline void GUI::updateAllZones()
{
	for (zmap::iterator m = fZoneMap.begin(); m != fZoneMap.end(); m++) {
		FAUSTFLOAT* z = m->first;
		clist*	l = m->second;
        if (z) {
            FAUSTFLOAT	v = *z;
            for (clist::iterator c = l->begin(); c != l->end(); c++) {
                if ((*c)->cache() != v) (*c)->reflectZone();
            }
        }
	}
}

inline void GUI::addCallback(FAUSTFLOAT* zone, uiCallback foo, void* data) 
{ 
	new uiCallbackItem(this, zone, foo, data); 
};

inline clist::~clist() 
{
    std::list<uiItem*>::iterator it;
    for (it = begin(); it != end(); it++) {
        uiOwnedItem* owned = dynamic_cast<uiOwnedItem*>(*it);
        // owned items are deleted by external code
        if (!owned) {
            delete (*it);
        }
    }
}

// For precise timestamped control
struct DatedControl {

    double fDate;
    FAUSTFLOAT fValue;
    
    DatedControl(double d = 0., FAUSTFLOAT v = FAUSTFLOAT(0)):fDate(d), fValue(v) {}

};
  
#endif
/************************************************************************
    FAUST Architecture File
    Copyright (C) 2003-2016 GRAME, Centre National de Creation Musicale
    ---------------------------------------------------------------------
    This Architecture section is free software; you can redistribute it
    and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 3 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; If not, see <http://www.gnu.org/licenses/>.

    EXCEPTION : As a special exception, you may create a larger work
    that contains this FAUST architecture section and distribute
    that work under terms of your choice, so long as this FAUST
    architecture section is not modified.

 ************************************************************************
 ************************************************************************/

#ifndef FAUST_MIDIUI_H
#define FAUST_MIDIUI_H

#ifndef FAUSTFLOAT
#define FAUSTFLOAT float
#endif

#include <vector>
#include <string>
#include <utility>
#include <iostream>

/************************************************************************
    FAUST Architecture File
    Copyright (C) 2003-2011 GRAME, Centre National de Creation Musicale
    ---------------------------------------------------------------------
    This Architecture section is free software; you can redistribute it
    and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 3 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; If not, see <http://www.gnu.org/licenses/>.

    EXCEPTION : As a special exception, you may create a larger work
    that contains this FAUST architecture section and distribute
    that work under terms of your choice, so long as this FAUST
    architecture section is not modified.

 ************************************************************************
 ************************************************************************/

#ifndef __midi__
#define __midi__

#include <vector>
#include <string>
#include <algorithm>

class MapUI;

//----------------------------------------------------------------
//  MIDI processor definition
//----------------------------------------------------------------

class midi {

    public:

        midi() {}
        virtual ~midi() {}

        // Additional time-stamped API for MIDI input
        virtual MapUI* keyOn(double, int channel, int pitch, int velocity)
        {
            return keyOn(channel, pitch, velocity);
        }
        
        virtual void keyOff(double, int channel, int pitch, int velocity = 127)
        {
            keyOff(channel, pitch, velocity);
        }
        
        virtual void pitchWheel(double, int channel, int wheel)
        {
            pitchWheel(channel, wheel);
        }
           
        virtual void ctrlChange(double, int channel, int ctrl, int value)
        {
            ctrlChange(channel, ctrl, value);
        }
       
        virtual void progChange(double, int channel, int pgm)
        {
            progChange(channel, pgm);
        }
        
        virtual void keyPress(double, int channel, int pitch, int press)
        {
            keyPress(channel, pitch, press);
        }
        
        virtual void chanPress(double date, int channel, int press)
        {
            chanPress(channel, press);
        }
       
        virtual void ctrlChange14bits(double, int channel, int ctrl, int value)
        {
            ctrlChange14bits(channel, ctrl, value);
        }

        // MIDI sync
        virtual void start_sync(double date)  {}
        virtual void stop_sync(double date)   {}
        virtual void clock(double date)  {}

        // Standard MIDI API
        virtual MapUI* keyOn(int channel, int pitch, int velocity)      { return 0; }
        virtual void keyOff(int channel, int pitch, int velocity)       {}
        virtual void keyPress(int channel, int pitch, int press)        {}
        virtual void chanPress(int channel, int press)                  {}
        virtual void ctrlChange(int channel, int ctrl, int value)       {}
        virtual void ctrlChange14bits(int channel, int ctrl, int value) {}
        virtual void pitchWheel(int channel, int wheel)                 {}
        virtual void progChange(int channel, int pgm)                   {}

        enum MidiStatus {

            // channel voice messages
            MIDI_NOTE_OFF           = 0x80,
            MIDI_NOTE_ON            = 0x90,
            MIDI_CONTROL_CHANGE     = 0xB0,
            MIDI_PROGRAM_CHANGE     = 0xC0,
            MIDI_PITCH_BEND         = 0xE0,
            MIDI_AFTERTOUCH         = 0xD0,	// aka channel pressure
            MIDI_POLY_AFTERTOUCH    = 0xA0,	// aka key pressure
            MIDI_CLOCK              = 0xF8,
            MIDI_START              = 0xFA,
            MIDI_STOP               = 0xFC

        };

        enum MidiCtrl {

            ALL_NOTES_OFF = 123,
            ALL_SOUND_OFF = 120

        };
};

//----------------------------------------------------------------
//  Base class for MIDI API handling
//----------------------------------------------------------------

class midi_handler : public midi {

    protected:

        std::vector<midi*> fMidiInputs;
        std::string fName;

    public:

        midi_handler(const std::string& name = "MIDIHandler"):fName(name) {}
        virtual ~midi_handler() {}

        virtual void addMidiIn(midi* midi_dsp) { if (midi_dsp) fMidiInputs.push_back(midi_dsp); }
        virtual void removeMidiIn(midi* midi_dsp)
        {
            std::vector<midi*>::iterator it = std::find(fMidiInputs.begin(), fMidiInputs.end(), midi_dsp);
            if (it != fMidiInputs.end()) {
                fMidiInputs.erase(it);
            }
        }

        virtual bool start_midi() { return true; }
        virtual void stop_midi() {}
        
        void handleSync(double time, int type)
        {
            if (type == MIDI_CLOCK) {
                for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
                    fMidiInputs[i]->clock(time);
                }
            } else if (type == MIDI_START) {
                for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
                    fMidiInputs[i]->start_sync(time);
                }
            } else if (type == MIDI_STOP) {
                for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
                    fMidiInputs[i]->stop_sync(time);
                }
            }
        }

        void handleData1(double time, int type, int channel, int data1)
        {
            if (type == MIDI_PROGRAM_CHANGE) {
                for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
                    fMidiInputs[i]->progChange(time, channel, data1);
                }
            } else if (type == MIDI_AFTERTOUCH) {
                for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
                    fMidiInputs[i]->chanPress(time, channel, data1);
                }
            }
        }

        void handleData2(double time, int type, int channel, int data1, int data2)
        {
            if (type == MIDI_NOTE_OFF || ((type == MIDI_NOTE_ON) && (data2 == 0))) {
                for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
                    fMidiInputs[i]->keyOff(time, channel, data1, data2);
                }
            } else if (type == MIDI_NOTE_ON) {
                for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
                    fMidiInputs[i]->keyOn(time, channel, data1, data2);
                }
            } else if (type == MIDI_CONTROL_CHANGE) {
                for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
                    fMidiInputs[i]->ctrlChange(time, channel, data1, data2);
                }
            } else if (type == MIDI_PITCH_BEND) {
                for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
                    fMidiInputs[i]->pitchWheel(time, channel, (data2 * 128.0) + data1);
                }
            } else if (type == MIDI_POLY_AFTERTOUCH) {
                for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
                    fMidiInputs[i]->keyPress(time, channel, data1, data2);
                }
            }
        }


};

#endif // __midi__
/************************************************************************
    FAUST Architecture File
    Copyright (C) 2003-2016 GRAME, Centre National de Creation Musicale
    ---------------------------------------------------------------------
    This Architecture section is free software; you can redistribute it
    and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 3 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; If not, see <http://www.gnu.org/licenses/>.

    EXCEPTION : As a special exception, you may create a larger work
    that contains this FAUST architecture section and distribute
    that work under terms of your choice, so long as this FAUST
    architecture section is not modified.


 ************************************************************************
 ************************************************************************/

#ifndef __ValueConverter__
#define __ValueConverter__

/***************************************************************************************
								ValueConverter.h
							    (GRAME, © 2015)

Set of conversion objects used to map user interface values (for example a gui slider
delivering values between 0 and 1) to faust values (for example a vslider between
20 and 20000) using a log scale.

-- Utilities

Range(lo,hi) : clip a value x between lo and hi
Interpolator(lo,hi,v1,v2) : Maps a value x between lo and hi to a value y between v1 and v2
Interpolator3pt(lo,mi,hi,v1,vm,v2) : Map values between lo mid hi to values between v1 vm v2

-- Value Converters

ValueConverter::ui2faust(x)
ValueConverter::faust2ui(x)

-- ValueConverters used for sliders depending of the scale

LinearValueConverter(umin, umax, fmin, fmax)
LogValueConverter(umin, umax, fmin, fmax)
ExpValueConverter(umin, umax, fmin, fmax)

-- ValueConverters used for accelerometers based on 3 points

AccUpConverter(amin, amid, amax, fmin, fmid, fmax)		-- curve 0
AccDownConverter(amin, amid, amax, fmin, fmid, fmax)	-- curve 1
AccUpDownConverter(amin, amid, amax, fmin, fmid, fmax)	-- curve 2
AccDownUpConverter(amin, amid, amax, fmin, fmid, fmax)	-- curve 3

-- lists of ZoneControl are used to implement accelerometers metadata for each axes

ZoneControl(zone, valueConverter) : a zone with an accelerometer data converter

-- ZoneReader are used to implement screencolor metadata

ZoneReader(zone, valueConverter) : a zone with a data converter

****************************************************************************************/

#include <float.h>
#include <algorithm>    // std::max
#include <cmath>
#include <vector>
#include <assert.h>

//--------------------------------------------------------------------------------------
// Interpolator(lo,hi,v1,v2)
// Maps a value x between lo and hi to a value y between v1 and v2
// y = v1 + (x-lo)/(hi-lo)*(v2-v1)
// y = v1 + (x-lo) * coef   		with coef = (v2-v1)/(hi-lo)
// y = v1 + x*coef - lo*coef
// y = v1 - lo*coef + x*coef
// y = offset + x*coef				with offset = v1 - lo*coef
//--------------------------------------------------------------------------------------
class Interpolator
{
    private:

        //--------------------------------------------------------------------------------------
        // Range(lo,hi) clip a value between lo and hi
        //--------------------------------------------------------------------------------------
        struct Range
        {
            double fLo;
            double fHi;

            Range(double x, double y) : fLo(std::min<double>(x,y)), fHi(std::max<double>(x,y)) {}
            double operator()(double x) { return (x<fLo) ? fLo : (x>fHi) ? fHi : x; }
        };


        Range fRange;
        double fCoef;
        double fOffset;

    public:

        Interpolator(double lo, double hi, double v1, double v2) : fRange(lo,hi)
        {
            if (hi != lo) {
                // regular case
                fCoef = (v2-v1)/(hi-lo);
                fOffset = v1 - lo*fCoef;
            } else {
                // degenerate case, avoids division by zero
                fCoef = 0;
                fOffset = (v1+v2)/2;
            }
        }
        double operator()(double v)
        {
            double x = fRange(v);
            return  fOffset + x*fCoef;
        }

        void getLowHigh(double& amin, double& amax)
        {
            amin = fRange.fLo;
            amax = fRange.fHi;
        }
};

//--------------------------------------------------------------------------------------
// Interpolator3pt(lo,mi,hi,v1,vm,v2)
// Map values between lo mid hi to values between v1 vm v2
//--------------------------------------------------------------------------------------
class Interpolator3pt
{

    private:

        Interpolator fSegment1;
        Interpolator fSegment2;
        double fMid;

    public:

        Interpolator3pt(double lo, double mi, double hi, double v1, double vm, double v2) :
            fSegment1(lo, mi, v1, vm),
            fSegment2(mi, hi, vm, v2),
            fMid(mi) {}
        double operator()(double x) { return  (x < fMid) ? fSegment1(x) : fSegment2(x); }

        void getMappingValues(double& amin, double& amid, double& amax)
        {
            fSegment1.getLowHigh(amin, amid);
            fSegment2.getLowHigh(amid, amax);
        }
};

//--------------------------------------------------------------------------------------
// Abstract ValueConverter class. Converts values between UI and Faust representations
//--------------------------------------------------------------------------------------
class ValueConverter
{

    public:

        virtual ~ValueConverter() {}
        virtual double ui2faust(double x) = 0;
        virtual double faust2ui(double x) = 0;
};

//--------------------------------------------------------------------------------------
// Linear conversion between ui and faust values
//--------------------------------------------------------------------------------------
class LinearValueConverter : public ValueConverter
{

    private:

        Interpolator fUI2F;
        Interpolator fF2UI;

    public:

        LinearValueConverter(double umin, double umax, double fmin, double fmax) :
            fUI2F(umin,umax,fmin,fmax), fF2UI(fmin,fmax,umin,umax)
        {}

        LinearValueConverter() :
            fUI2F(0.,0.,0.,0.), fF2UI(0.,0.,0.,0.)
        {}
        virtual double ui2faust(double x) {	return fUI2F(x); }
        virtual double faust2ui(double x) {	return fF2UI(x); }

};

//--------------------------------------------------------------------------------------
// Logarithmic conversion between ui and faust values
//--------------------------------------------------------------------------------------
class LogValueConverter : public LinearValueConverter
{

    public:

        LogValueConverter(double umin, double umax, double fmin, double fmax) :
            LinearValueConverter(umin, umax, log(std::max<double>(DBL_MIN, fmin)), log(std::max<double>(DBL_MIN, fmax)))
        {}

        virtual double ui2faust(double x) 	{ return exp(LinearValueConverter::ui2faust(x)); }
        virtual double faust2ui(double x)	{ return LinearValueConverter::faust2ui(log(std::max<double>(x, DBL_MIN))); }

};

//--------------------------------------------------------------------------------------
// Exponential conversion between ui and Faust values
//--------------------------------------------------------------------------------------
class ExpValueConverter : public LinearValueConverter
{

    public:

        ExpValueConverter(double umin, double umax, double fmin, double fmax) :
            LinearValueConverter(umin, umax, exp(fmin), exp(fmax))
        {}

        virtual double ui2faust(double x) { return log(LinearValueConverter::ui2faust(x)); }
        virtual double faust2ui(double x) { return LinearValueConverter::faust2ui(exp(x)); }

};

//--------------------------------------------------------------------------------------
// A converter than can be updated
//--------------------------------------------------------------------------------------

class UpdatableValueConverter : public ValueConverter {

    protected:

        bool fActive;

    public:

        UpdatableValueConverter():fActive(true)
        {}
        virtual ~UpdatableValueConverter()
        {}

        virtual void setMappingValues(double amin, double amid, double amax, double min, double init, double max) = 0;
        virtual void getMappingValues(double& amin, double& amid, double& amax) = 0;

        void setActive(bool on_off) { fActive = on_off; }
        bool getActive() { return fActive; }

};

//--------------------------------------------------------------------------------------
// Convert accelerometer or gyroscope values to Faust values
// Using an Up curve (curve 0)
//--------------------------------------------------------------------------------------
class AccUpConverter : public UpdatableValueConverter
{

    private:

        Interpolator3pt fA2F;
        Interpolator3pt fF2A;

    public:

        AccUpConverter(double amin, double amid, double amax, double fmin, double fmid, double fmax) :
            fA2F(amin,amid,amax,fmin,fmid,fmax),
            fF2A(fmin,fmid,fmax,amin,amid,amax)
        {}

        virtual double ui2faust(double x)	{ return fA2F(x); }
        virtual double faust2ui(double x)	{ return fF2A(x); }

        virtual void setMappingValues(double amin, double amid, double amax, double fmin, double fmid, double fmax)
        {
            //__android_log_print(ANDROID_LOG_ERROR, "Faust", "AccUpConverter update %f %f %f %f %f %f", amin,amid,amax,fmin,fmid,fmax);
            fA2F = Interpolator3pt(amin,amid,amax,fmin,fmid,fmax);
            fF2A = Interpolator3pt(fmin,fmid,fmax,amin,amid,amax);
        }

        virtual void getMappingValues(double& amin, double& amid, double& amax)
        {
            fA2F.getMappingValues(amin, amid, amax);
        }

};

//--------------------------------------------------------------------------------------
// Convert accelerometer or gyroscope values to Faust values
// Using a Down curve (curve 1)
//--------------------------------------------------------------------------------------
class AccDownConverter : public UpdatableValueConverter
{

    private:

        Interpolator3pt	fA2F;
        Interpolator3pt	fF2A;

    public:

        AccDownConverter(double amin, double amid, double amax, double fmin, double fmid, double fmax) :
            fA2F(amin,amid,amax,fmax,fmid,fmin),
            fF2A(fmin,fmid,fmax,amax,amid,amin)
        {}

        virtual double ui2faust(double x)	{ return fA2F(x); }
        virtual double faust2ui(double x)	{ return fF2A(x); }

        virtual void setMappingValues(double amin, double amid, double amax, double fmin, double fmid, double fmax)
        {
             //__android_log_print(ANDROID_LOG_ERROR, "Faust", "AccDownConverter update %f %f %f %f %f %f", amin,amid,amax,fmin,fmid,fmax);
            fA2F = Interpolator3pt(amin,amid,amax,fmax,fmid,fmin);
            fF2A = Interpolator3pt(fmin,fmid,fmax,amax,amid,amin);
        }

        virtual void getMappingValues(double& amin, double& amid, double& amax)
        {
            fA2F.getMappingValues(amin, amid, amax);
        }
};

//--------------------------------------------------------------------------------------
// Convert accelerometer or gyroscope values to Faust values
// Using an Up-Down curve (curve 2)
//--------------------------------------------------------------------------------------
class AccUpDownConverter : public UpdatableValueConverter
{

    private:

        Interpolator3pt	fA2F;
        Interpolator fF2A;

    public:

        AccUpDownConverter(double amin, double amid, double amax, double fmin, double fmid, double fmax) :
            fA2F(amin,amid,amax,fmin,fmax,fmin),
            fF2A(fmin,fmax,amin,amax)				// Special, pseudo inverse of a non monotone function
        {}

        virtual double ui2faust(double x)	{ return fA2F(x); }
        virtual double faust2ui(double x)	{ return fF2A(x); }

        virtual void setMappingValues(double amin, double amid, double amax, double fmin, double fmid, double fmax)
        {
             //__android_log_print(ANDROID_LOG_ERROR, "Faust", "AccUpDownConverter update %f %f %f %f %f %f", amin,amid,amax,fmin,fmid,fmax);
            fA2F = Interpolator3pt(amin,amid,amax,fmin,fmax,fmin);
            fF2A = Interpolator(fmin,fmax,amin,amax);
        }

        virtual void getMappingValues(double& amin, double& amid, double& amax)
        {
            fA2F.getMappingValues(amin, amid, amax);
        }
};

//--------------------------------------------------------------------------------------
// Convert accelerometer or gyroscope values to Faust values
// Using a Down-Up curve (curve 3)
//--------------------------------------------------------------------------------------
class AccDownUpConverter : public UpdatableValueConverter
{

    private:

        Interpolator3pt	fA2F;
        Interpolator fF2A;

    public:

        AccDownUpConverter(double amin, double amid, double amax, double fmin, double fmid, double fmax) :
            fA2F(amin,amid,amax,fmax,fmin,fmax),
            fF2A(fmin,fmax,amin,amax)				// Special, pseudo inverse of a non monotone function
        {}

        virtual double ui2faust(double x)	{ return fA2F(x); }
        virtual double faust2ui(double x)	{ return fF2A(x); }

        virtual void setMappingValues(double amin, double amid, double amax, double fmin, double fmid, double fmax)
        {
            //__android_log_print(ANDROID_LOG_ERROR, "Faust", "AccDownUpConverter update %f %f %f %f %f %f", amin,amid,amax,fmin,fmid,fmax);
            fA2F = Interpolator3pt(amin,amid,amax,fmax,fmin,fmax);
            fF2A = Interpolator(fmin,fmax,amin,amax);
        }

        virtual void getMappingValues(double& amin, double& amid, double& amax)
        {
            fA2F.getMappingValues(amin, amid, amax);
        }
};

//--------------------------------------------------------------------------------------
// Base class for ZoneControl
//--------------------------------------------------------------------------------------
class ZoneControl
{

    protected:

        FAUSTFLOAT*	fZone;

    public:

        ZoneControl(FAUSTFLOAT* zone) : fZone(zone) {}
        virtual ~ZoneControl() {}

        virtual void update(double v) {}

        virtual void setMappingValues(int curve, double amin, double amid, double amax, double min, double init, double max) {}
        virtual void getMappingValues(double& amin, double& amid, double& amax) {}

        FAUSTFLOAT* getZone() { return fZone; }

        virtual void setActive(bool on_off) {}
        virtual bool getActive() { return false; }

        virtual int getCurve() { return -1; }

};

//--------------------------------------------------------------------------------------
//  Useful to implement accelerometers metadata as a list of ZoneControl for each axes
//--------------------------------------------------------------------------------------
class ConverterZoneControl : public ZoneControl
{

    private:

        ValueConverter* fValueConverter;

    public:

        ConverterZoneControl(FAUSTFLOAT* zone, ValueConverter* valueConverter) : ZoneControl(zone), fValueConverter(valueConverter) {}
        virtual ~ConverterZoneControl() { delete fValueConverter; } // Assuming fValueConverter is not kept elsewhere...

        void update(double v) { *fZone = fValueConverter->ui2faust(v); }

        ValueConverter* getConverter() { return fValueConverter; }

};

//--------------------------------------------------------------------------------------
// Association of a zone and a four value converter, each one for each possible curve.
// Useful to implement accelerometers metadata as a list of ZoneControl for each axes
//--------------------------------------------------------------------------------------
class CurveZoneControl : public ZoneControl
{

    private:

        std::vector<UpdatableValueConverter*> fValueConverters;
        int fCurve;

    public:

        CurveZoneControl(FAUSTFLOAT* zone, int curve, double amin, double amid, double amax, double min, double init, double max) : ZoneControl(zone), fCurve(0)
        {
            assert(curve >= 0 && curve <= 3);
            fValueConverters.push_back(new AccUpConverter(amin, amid, amax, min, init, max));
            fValueConverters.push_back(new AccDownConverter(amin, amid, amax, min, init, max));
            fValueConverters.push_back(new AccUpDownConverter(amin, amid, amax, min, init, max));
            fValueConverters.push_back(new AccDownUpConverter(amin, amid, amax, min, init, max));
            fCurve = curve;
        }
        virtual ~CurveZoneControl()
        {
            std::vector<UpdatableValueConverter*>::iterator it;
            for (it = fValueConverters.begin(); it != fValueConverters.end(); it++) {
                delete(*it);
            }
        }
        void update(double v) { if (fValueConverters[fCurve]->getActive()) *fZone = fValueConverters[fCurve]->ui2faust(v); }

        void setMappingValues(int curve, double amin, double amid, double amax, double min, double init, double max)
        {
            fValueConverters[curve]->setMappingValues(amin, amid, amax, min, init, max);
            fCurve = curve;
        }

        void getMappingValues(double& amin, double& amid, double& amax)
        {
            fValueConverters[fCurve]->getMappingValues(amin, amid, amax);
        }

        void setActive(bool on_off)
        {
            std::vector<UpdatableValueConverter*>::iterator it;
            for (it = fValueConverters.begin(); it != fValueConverters.end(); it++) {
                (*it)->setActive(on_off);
            }
        }

        int getCurve() { return fCurve; }
};

class ZoneReader
{

    private:

        FAUSTFLOAT*     fZone;
        Interpolator    fInterpolator;

    public:

        ZoneReader(FAUSTFLOAT* zone, double lo, double hi) : fZone(zone), fInterpolator(lo, hi, 0, 255) {}

        virtual ~ZoneReader() {}

        int getValue() {
            if (fZone != 0) {
                return (int)fInterpolator(*fZone);
            } else {
                return 127;
            }
        }

};

#endif

#ifdef _MSC_VER
#define gsscanf sscanf_s
#else
#define gsscanf sscanf
#endif

/*****************************************************************************
* Helper code for MIDI meta and polyphonic 'nvoices' parsing
******************************************************************************/

struct MidiMeta : public Meta, public std::map<std::string, std::string>
{
    void declare(const char* key, const char* value)
    {
        (*this)[key] = value;
    }
    
    const std::string get(const char* key, const char* def)
    {
        if (this->find(key) != this->end()) {
            return (*this)[key];
        } else {
            return def;
        }
    }
    
    static void analyse(dsp* tmp_dsp, bool& midi_sync, int& nvoices)
    {
        JSONUI jsonui;
        tmp_dsp->buildUserInterface(&jsonui);
        std::string json = jsonui.JSON();
        midi_sync = ((json.find("midi") != std::string::npos) &&
                     ((json.find("start") != std::string::npos) ||
                      (json.find("stop") != std::string::npos) ||
                      (json.find("clock") != std::string::npos)));
    
    #if defined(NVOICES) && NVOICES!=NUM_VOICES
        nvoices = NVOICES;
    #else
        MidiMeta meta;
        tmp_dsp->metadata(&meta);
        std::string numVoices = meta.get("nvoices", "0");
        nvoices = atoi(numVoices.c_str());
        if (nvoices < 0) nvoices = 0;
    #endif
    }
};

/*******************************************************************************
 * MidiUI : Faust User Interface
 * This class decodes MIDI meta data and maps incoming MIDI messages to them.
 * Currently ctrl, keyon/keyoff, keypress, pgm, chanpress, pitchwheel/pitchbend 
 * start/stop/clock meta data is handled.
 ******************************************************************************/
 
class uiMidiItem : public uiItem {
 
    protected:
    
         midi* fMidiOut;
         bool fInputCtrl;

    public:
    
        uiMidiItem(midi* midi_out, GUI* ui, FAUSTFLOAT* zone, bool input)
            :uiItem(ui, zone), fMidiOut(midi_out), fInputCtrl(input) {}
        virtual ~uiMidiItem() {}
 
};
 
class uiMidiTimedItem : public uiMidiItem
{
    protected:
    
        bool fDelete;
   
    public:
       
        uiMidiTimedItem(midi* midi_out, GUI* ui, FAUSTFLOAT* zone, bool input = true)
            :uiMidiItem(midi_out, ui, zone, input)
        {
            if (GUI::gTimedZoneMap.find(fZone) == GUI::gTimedZoneMap.end()) {
                GUI::gTimedZoneMap[fZone] = ringbuffer_create(8192);
                fDelete = true;
            } else {
                fDelete = false;
            }
        }
        
        virtual ~uiMidiTimedItem() 
        {
            ztimedmap::iterator it;
            if (fDelete && ((it = GUI::gTimedZoneMap.find(fZone)) != GUI::gTimedZoneMap.end())) {
                ringbuffer_free((*it).second);
                GUI::gTimedZoneMap.erase(it);
            }
        }

        void modifyZone(double date, FAUSTFLOAT v) 	
        { 
            size_t res;
            DatedControl dated_val(date, v);
            if ((res = ringbuffer_write(GUI::gTimedZoneMap[fZone], (const char*)&dated_val, sizeof(DatedControl))) != sizeof(DatedControl)) {
                std::cerr << "ringbuffer_write error DatedControl" << std::endl;
            }
        }
        
        // TODO
        virtual void reflectZone() {}

};

// MIDI sync

class uiMidiStart : public uiMidiTimedItem
{
  
    public:
    
        uiMidiStart(midi* midi_out, GUI* ui, FAUSTFLOAT* zone, bool input = true)
            :uiMidiTimedItem(midi_out, ui, zone, input)
        {}
        virtual ~uiMidiStart()
        {}
        
        virtual void reflectZone()
        {
            FAUSTFLOAT v = *fZone;
            fCache = v;
            if (v != FAUSTFLOAT(0)) {
                fMidiOut->start_sync(0);
            }
        }
        
};

class uiMidiStop : public uiMidiTimedItem
{
  
    public:
    
        uiMidiStop(midi* midi_out, GUI* ui, FAUSTFLOAT* zone, bool input = true)
            :uiMidiTimedItem(midi_out, ui, zone, input)
        {}
        virtual ~uiMidiStop()
        {}
        
        virtual void reflectZone()
        {
            FAUSTFLOAT v = *fZone;
            fCache = v;
            if (v != FAUSTFLOAT(1)) {
                fMidiOut->stop_sync(0);
            }
        }
};

class uiMidiClock : public uiMidiTimedItem
{

    private:
        
        bool fState;
  
    public:
    
        uiMidiClock(midi* midi_out, GUI* ui, FAUSTFLOAT* zone, bool input = true)
            :uiMidiTimedItem(midi_out, ui, zone, input), fState(false)
        {}
        virtual ~uiMidiClock()
        {}
        
        void modifyZone(double date, FAUSTFLOAT v) 	
        { 
            if (fInputCtrl) {
                fState = !fState;
                uiMidiTimedItem::modifyZone(date, FAUSTFLOAT(fState));
            }
        }
        
        virtual void reflectZone()
        {
            FAUSTFLOAT v = *fZone;
            fCache = v;
            fMidiOut->clock(0);
        }
};

class uiMidiProgChange : public uiMidiItem
{
    private:
        
        int fPgm;
  
    public:
    
        uiMidiProgChange(midi* midi_out, int pgm, GUI* ui, FAUSTFLOAT* zone, bool input = true)
            :uiMidiItem(midi_out, ui, zone, input), fPgm(pgm)
        {}
        virtual ~uiMidiProgChange()
        {}
        
        virtual void reflectZone()
        {
            FAUSTFLOAT v = *fZone;
            fCache = v;
            if (v != FAUSTFLOAT(0)) {
                fMidiOut->progChange(0, fPgm);
            }
        }
        
};

class uiMidiChanPress : public uiMidiItem
{
    private:
        
        int fPress;
  
    public:
    
        uiMidiChanPress(midi* midi_out, int press, GUI* ui, FAUSTFLOAT* zone, bool input = true)
            :uiMidiItem(midi_out, ui, zone, input), fPress(press)
        {}
        virtual ~uiMidiChanPress()
        {}
        
        virtual void reflectZone()
        {
            FAUSTFLOAT v = *fZone;
            fCache = v;
            if (v != FAUSTFLOAT(0)) {
                fMidiOut->chanPress(0, fPress);
            }
        }
        
};

class uiMidiCtrlChange : public uiMidiItem
{
    private:
    
        int fCtrl;
        LinearValueConverter fConverter;
 
    public:
    
        uiMidiCtrlChange(midi* midi_out, int ctrl, GUI* ui, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max, bool input = true)
            :uiMidiItem(midi_out, ui, zone, input), fCtrl(ctrl), fConverter(0., 127., double(min), double(max))
        {}
        virtual ~uiMidiCtrlChange()
        {}
        
        virtual void reflectZone()
        {
            FAUSTFLOAT v = *fZone;
            fCache = v;
            fMidiOut->ctrlChange(0, fCtrl, fConverter.faust2ui(v));
        }
        
        void modifyZone(int v) 	
        { 
            if (fInputCtrl) {
                uiItem::modifyZone(FAUSTFLOAT(fConverter.ui2faust(v)));
            }
        }
 
};

class uiMidiPitchWheel : public uiMidiItem
{

    private:
    	
		// currently, the range is of pitchwheel if fixed (-2/2 semitones)
        FAUSTFLOAT wheel2bend(float v)
        {
            return pow(2.0,(v/16383.0*4-2)/12);
        }

        int bend2wheel(float v)
        {
            return (int)((12*log(v)/log(2)+2)/4*16383);
        }
 
    public:
    
        uiMidiPitchWheel(midi* midi_out, GUI* ui, FAUSTFLOAT* zone, bool input = true)
            :uiMidiItem(midi_out, ui, zone, input)
        {}
        virtual ~uiMidiPitchWheel()
        {}
        
        virtual void reflectZone()
        {
            FAUSTFLOAT v = *fZone;
            fCache = v;
            fMidiOut->pitchWheel(0, bend2wheel(v));
        }
        
        void modifyZone(int v) 	
        { 
            if (fInputCtrl) {
                uiItem::modifyZone(wheel2bend(v));
            }
        }
 
};

class uiMidiKeyOn : public uiMidiItem
{

    private:
        
        int fKeyOn;
        LinearValueConverter fConverter;
  
    public:
    
        uiMidiKeyOn(midi* midi_out, int key, GUI* ui, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max, bool input = true)
            :uiMidiItem(midi_out, ui, zone, input), fKeyOn(key), fConverter(0., 127., double(min), double(max))
        {}
        virtual ~uiMidiKeyOn()
        {}
        
        virtual void reflectZone()
        {
            FAUSTFLOAT v = *fZone;
            fCache = v;
            fMidiOut->keyOn(0, fKeyOn, fConverter.faust2ui(v));
        }
        
        void modifyZone(int v) 	
        { 
            if (fInputCtrl) {
                uiItem::modifyZone(FAUSTFLOAT(fConverter.ui2faust(v)));
            }
        }
        
};

class uiMidiKeyOff : public uiMidiItem
{

    private:
        
        int fKeyOff;
        LinearValueConverter fConverter;
  
    public:
    
        uiMidiKeyOff(midi* midi_out, int key, GUI* ui, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max, bool input = true)
            :uiMidiItem(midi_out, ui, zone, input), fKeyOff(key), fConverter(0., 127., double(min), double(max))
        {}
        virtual ~uiMidiKeyOff()
        {}
        
        virtual void reflectZone()
        {
            FAUSTFLOAT v = *fZone;
            fCache = v;
            fMidiOut->keyOff(0, fKeyOff, fConverter.faust2ui(v));
        }
        
        void modifyZone(int v) 	
        { 
            if (fInputCtrl) {
                uiItem::modifyZone(FAUSTFLOAT(fConverter.ui2faust(v)));
            }
        }
        
};

class uiMidiKeyPress : public uiMidiItem
{

    private:
        
        int fKeyOn;
        LinearValueConverter fConverter;
  
    public:
    
        uiMidiKeyPress(midi* midi_out, int key, GUI* ui, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max, bool input = true)
            :uiMidiItem(midi_out, ui, zone, input), fKeyOn(key), fConverter(0., 127., double(min), double(max))
        {}
        virtual ~uiMidiKeyPress()
        {}
        
        virtual void reflectZone()
        {
            FAUSTFLOAT v = *fZone;
            fCache = v;
            fMidiOut->keyPress(0, fKeyOn, fConverter.faust2ui(v));
        }
        
        void modifyZone(int v) 	
        { 
            if (fInputCtrl) {
                uiItem::modifyZone(FAUSTFLOAT(fConverter.ui2faust(v)));
            }
        }
        
};

class MapUI;

class MidiUI : public GUI, public midi
{

    protected:
    
        std::map <int, std::vector<uiMidiCtrlChange*> > fCtrlChangeTable;
        std::map <int, std::vector<uiMidiProgChange*> > fProgChangeTable;
        std::map <int, std::vector<uiMidiChanPress*> >  fChanPressTable;
        std::map <int, std::vector<uiMidiKeyOn*> >      fKeyOnTable;
        std::map <int, std::vector<uiMidiKeyOff*> >     fKeyOffTable;
        std::map <int, std::vector<uiMidiKeyPress*> >   fKeyPressTable;
        std::vector<uiMidiPitchWheel*>                  fPitchWheelTable;
        
        std::vector<uiMidiStart*>   fStartTable;
        std::vector<uiMidiStop*>    fStopTable;
        std::vector<uiMidiClock*>   fClockTable;
        
        std::vector<std::pair <std::string, std::string> > fMetaAux;
        
        midi_handler* fMidiHandler;
        
        void addGenericZone(FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max, bool input = true)
        {
            if (fMetaAux.size() > 0) {
                for (size_t i = 0; i < fMetaAux.size(); i++) {
                    unsigned num;
                    if (fMetaAux[i].first == "midi") {
                        if (gsscanf(fMetaAux[i].second.c_str(), "ctrl %u", &num) == 1) {
                            fCtrlChangeTable[num].push_back(new uiMidiCtrlChange(fMidiHandler, num, this, zone, min, max, input));
                        } else if (gsscanf(fMetaAux[i].second.c_str(), "keyon %u", &num) == 1) {
                            fKeyOnTable[num].push_back(new uiMidiKeyOn(fMidiHandler, num, this, zone, min, max, input));
                        } else if (gsscanf(fMetaAux[i].second.c_str(), "keyoff %u", &num) == 1) {
                            fKeyOffTable[num].push_back(new uiMidiKeyOff(fMidiHandler, num, this, zone, min, max, input));
                        } else if (gsscanf(fMetaAux[i].second.c_str(), "keypress %u", &num) == 1) {
                            fKeyPressTable[num].push_back(new uiMidiKeyPress(fMidiHandler, num, this, zone, min, max, input));
                        } else if (gsscanf(fMetaAux[i].second.c_str(), "pgm %u", &num) == 1) {
                            fProgChangeTable[num].push_back(new uiMidiProgChange(fMidiHandler, num, this, zone, input));
                        } else if (gsscanf(fMetaAux[i].second.c_str(), "chanpress %u", &num) == 1) {
                            fChanPressTable[num].push_back(new uiMidiChanPress(fMidiHandler, num, this, zone, input));
                        } else if (strcmp(fMetaAux[i].second.c_str(), "pitchwheel") == 0 
                            || strcmp(fMetaAux[i].second.c_str(), "pitchbend") == 0) {
                            fPitchWheelTable.push_back(new uiMidiPitchWheel(fMidiHandler, this, zone, input));
                        // MIDI sync
                        } else if (strcmp(fMetaAux[i].second.c_str(), "start") == 0) {
                            fStartTable.push_back(new uiMidiStart(fMidiHandler, this, zone, input));
                        } else if (strcmp(fMetaAux[i].second.c_str(), "stop") == 0) {
                            fStopTable.push_back(new uiMidiStop(fMidiHandler, this, zone, input));
                        } else if (strcmp(fMetaAux[i].second.c_str(), "clock") == 0) {
                            fClockTable.push_back(new uiMidiClock(fMidiHandler, this, zone, input));
                        }
                    }
                }
            }
            fMetaAux.clear();
        }

    public:

        MidiUI(midi_handler* midi_handler)
        {
            fMidiHandler = midi_handler;
            fMidiHandler->addMidiIn(this);
        }
 
        virtual ~MidiUI() 
        { 
            fMidiHandler->removeMidiIn(this);
        }
        
        bool run() { return fMidiHandler->start_midi(); }
        void stop() { fMidiHandler->stop_midi(); }
        
        void addMidiIn(midi* midi_dsp) { fMidiHandler->addMidiIn(midi_dsp); }
        void removeMidiIn(midi* midi_dsp) { fMidiHandler->removeMidiIn(midi_dsp); }
      
        // -- active widgets
        
        virtual void addButton(const char* label, FAUSTFLOAT* zone)
        {
            addGenericZone(zone, FAUSTFLOAT(0), FAUSTFLOAT(1));
        }
        virtual void addCheckButton(const char* label, FAUSTFLOAT* zone)
        {
            addGenericZone(zone, FAUSTFLOAT(0), FAUSTFLOAT(1));
        }
        
        virtual void addVerticalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step)
        {
            addGenericZone(zone, min, max);
        }
        virtual void addHorizontalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step)
        {
            addGenericZone(zone, min, max);
        }
        virtual void addNumEntry(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step)
        {
            addGenericZone(zone, min, max);
        }

        // -- passive widgets

        virtual void addHorizontalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max) 
        {
            addGenericZone(zone, min, max, false);
        }
        virtual void addVerticalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max)
        {
            addGenericZone(zone, min, max, false);
        }

        // -- metadata declarations

        virtual void declare(FAUSTFLOAT* zone, const char* key, const char* val)
        {
            fMetaAux.push_back(std::make_pair(key, val));
        }
        
        // -- MIDI API 
        
        MapUI* keyOn(double date, int channel, int note, int velocity)
        {
            if (fKeyOnTable.find(note) != fKeyOnTable.end()) {
                for (unsigned int i = 0; i < fKeyOnTable[note].size(); i++) {
                    fKeyOnTable[note][i]->modifyZone(FAUSTFLOAT(velocity));
                }
            }
            return 0;
        }
        
        void keyOff(double date,  int channel, int note, int velocity)
        {
            if (fKeyOffTable.find(note) != fKeyOffTable.end()) {
                for (unsigned int i = 0; i < fKeyOffTable[note].size(); i++) {
                    fKeyOffTable[note][i]->modifyZone(FAUSTFLOAT(velocity));
                }
            }
        }
           
        void ctrlChange(double date, int channel, int ctrl, int value)
        {
            if (fCtrlChangeTable.find(ctrl) != fCtrlChangeTable.end()) {
                for (unsigned int i = 0; i < fCtrlChangeTable[ctrl].size(); i++) {
                    fCtrlChangeTable[ctrl][i]->modifyZone(FAUSTFLOAT(value));
                }
            } 
        }
        
        void progChange(double date, int channel, int pgm)
        {
            if (fProgChangeTable.find(pgm) != fProgChangeTable.end()) {
                for (unsigned int i = 0; i < fProgChangeTable[pgm].size(); i++) {
                    fProgChangeTable[pgm][i]->modifyZone(FAUSTFLOAT(1));
                }
            } 
        }
        
        void pitchWheel(double date, int channel, int wheel) 
        {
            for (unsigned int i = 0; i < fPitchWheelTable.size(); i++) {
                fPitchWheelTable[i]->modifyZone(FAUSTFLOAT(wheel));
            }
        }
        
        void keyPress(double date, int channel, int pitch, int press) 
        {
            if (fKeyPressTable.find(press) != fKeyPressTable.end()) {
                for (unsigned int i = 0; i < fKeyPressTable[press].size(); i++) {
                    fKeyPressTable[press][i]->modifyZone(FAUSTFLOAT(press));
                }
            } 
        }
        
        void chanPress(double date, int channel, int press)
        {
            if (fChanPressTable.find(press) != fChanPressTable.end()) {
                for (unsigned int i = 0; i < fChanPressTable[press].size(); i++) {
                    fChanPressTable[press][i]->modifyZone(FAUSTFLOAT(1));
                }
            } 
        }
        
        void ctrlChange14bits(double date, int channel, int ctrl, int value) {}
        
        // MIDI sync
        
        void start_sync(double date)
        {
            for (unsigned int i = 0; i < fStartTable.size(); i++) {
                fStartTable[i]->modifyZone(date, FAUSTFLOAT(1));
            }
        }
        
        void stop_sync(double date)
        {
            for (unsigned int i = 0; i < fStopTable.size(); i++) {
                fStopTable[i]->modifyZone(date, FAUSTFLOAT(0));
            }
        }
        
        void clock(double date)
        {
            for (unsigned int i = 0; i < fClockTable.size(); i++) {
                fClockTable[i]->modifyZone(date, FAUSTFLOAT(1));
            }
        }
};

#endif // FAUST_MIDIUI_H
/************************************************************************
 FAUST Architecture File
 Copyright (C) 2003-2017 GRAME, Centre National de Creation Musicale
 ---------------------------------------------------------------------
 This Architecture section is free software; you can redistribute it
 and/or modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 3 of
 the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; If not, see <http://www.gnu.org/licenses/>.

 EXCEPTION : As a special exception, you may create a larger work
 that contains this FAUST architecture section and distribute
 that work under terms of your choice, so long as this FAUST
 architecture section is not modified.

 ************************************************************************
 ************************************************************************/

#ifndef __poly_dsp__
#define __poly_dsp__

#include <stdio.h>
#include <string>
#include <math.h>
#include <float.h>
#include <algorithm>
#include <ostream>
#include <sstream>
#include <vector>
#include <limits.h>

/************************************************************************
    FAUST Architecture File
    Copyright (C) 2003-2011 GRAME, Centre National de Creation Musicale
    ---------------------------------------------------------------------
    This Architecture section is free software; you can redistribute it
    and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 3 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; If not, see <http://www.gnu.org/licenses/>.

    EXCEPTION : As a special exception, you may create a larger work
    that contains this FAUST architecture section and distribute
    that work under terms of your choice, so long as this FAUST
    architecture section is not modified.


 ************************************************************************
 ************************************************************************/

#ifndef FAUST_MAPUI_H
#define FAUST_MAPUI_H

#ifndef FAUSTFLOAT
#define FAUSTFLOAT float
#endif

#include <vector>
#include <map>
#include <string>


/*******************************************************************************
 * MapUI : Faust User Interface
 * This class creates a map of complete hierarchical path and zones for each UI items.
 ******************************************************************************/

class MapUI : public UI, public PathBuilder
{
    
    protected:
    
        // Complete path map
        std::map<std::string, FAUSTFLOAT*> fPathZoneMap;
    
        // Label zone map
        std::map<std::string, FAUSTFLOAT*> fLabelZoneMap;
    
    public:
        
        MapUI() {};
        virtual ~MapUI() {};
        
        // -- widget's layouts
        void openTabBox(const char* label)
        {
            fControlsLevel.push_back(label);
        }
        void openHorizontalBox(const char* label)
        {
            fControlsLevel.push_back(label);
        }
        void openVerticalBox(const char* label)
        {
            fControlsLevel.push_back(label);
        }
        void closeBox()
        {
            fControlsLevel.pop_back();
        }
        
        // -- active widgets
        void addButton(const char* label, FAUSTFLOAT* zone)
        {
            fPathZoneMap[buildPath(label)] = zone;
            fLabelZoneMap[label] = zone;
        }
        void addCheckButton(const char* label, FAUSTFLOAT* zone)
        {
            fPathZoneMap[buildPath(label)] = zone;
            fLabelZoneMap[label] = zone;
        }
        void addVerticalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT fmin, FAUSTFLOAT fmax, FAUSTFLOAT step)
        {
            fPathZoneMap[buildPath(label)] = zone;
            fLabelZoneMap[label] = zone;
        }
        void addHorizontalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT fmin, FAUSTFLOAT fmax, FAUSTFLOAT step)
        {
            fPathZoneMap[buildPath(label)] = zone;
            fLabelZoneMap[label] = zone;
        }
        void addNumEntry(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT fmin, FAUSTFLOAT fmax, FAUSTFLOAT step)
        {
            fPathZoneMap[buildPath(label)] = zone;
            fLabelZoneMap[label] = zone;
        }
        
        // -- passive widgets
        void addHorizontalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT fmin, FAUSTFLOAT fmax)
        {
            fPathZoneMap[buildPath(label)] = zone;
            fLabelZoneMap[label] = zone;
        }
        void addVerticalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT fmin, FAUSTFLOAT fmax)
        {
            fPathZoneMap[buildPath(label)] = zone;
            fLabelZoneMap[label] = zone;
        }
        
        // -- metadata declarations
        void declare(FAUSTFLOAT* zone, const char* key, const char* val)
        {}
        
        // set/get
        void setParamValue(const std::string& path, FAUSTFLOAT value)
        {
            if (fPathZoneMap.find(path) != fPathZoneMap.end()) {
                *fPathZoneMap[path] = value;
            } else if (fLabelZoneMap.find(path) != fLabelZoneMap.end()) {
                *fLabelZoneMap[path] = value;
            }
        }
        
        FAUSTFLOAT getParamValue(const std::string& path)
        {
            if (fPathZoneMap.find(path) != fPathZoneMap.end()) {
                return *fPathZoneMap[path];
            } else if (fLabelZoneMap.find(path) != fLabelZoneMap.end()) {
                return *fLabelZoneMap[path];
            } else {
                return FAUSTFLOAT(0);
            }
        }
    
        // map access 
        std::map<std::string, FAUSTFLOAT*>& getMap() { return fPathZoneMap; }
        
        int getParamsCount() { return fPathZoneMap.size(); }
        
        std::string getParamAddress(int index)
        { 
            std::map<std::string, FAUSTFLOAT*>::iterator it = fPathZoneMap.begin();
            while (index-- > 0 && it++ != fPathZoneMap.end()) {}
            return (*it).first;
        }
};

#endif // FAUST_MAPUI_H
/************************************************************************
    IMPORTANT NOTE : this file contains two clearly delimited sections :
    the ARCHITECTURE section (in two parts) and the USER section. Each section
    is governed by its own copyright and license. Please check individually
    each section for license and copyright information.
*************************************************************************/

/*******************BEGIN ARCHITECTURE SECTION (part 1/2)****************/

/************************************************************************
    FAUST Architecture File
    Copyright (C) 2003-2011 GRAME, Centre National de Creation Musicale
    ---------------------------------------------------------------------
    This Architecture section is free software; you can redistribute it
    and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 3 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; If not, see <http://www.gnu.org/licenses/>.

    EXCEPTION : As a special exception, you may create a larger work
    that contains this FAUST architecture section and distribute
    that work under terms of your choice, so long as this FAUST
    architecture section is not modified.

 ************************************************************************
 ************************************************************************/

#ifndef __proxy_dsp__
#define __proxy_dsp__

#include <vector>
#include <map>

/************************************************************************
 ************************************************************************
 FAUST compiler
 Copyright (C) 2003-2015 GRAME, Centre National de Creation Musicale
 ---------------------------------------------------------------------
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 ************************************************************************
 ************************************************************************/

#ifndef SIMPLEPARSER_H
#define SIMPLEPARSER_H

// ---------------------------------------------------------------------
//                          Simple Parser
// A parser returns true if it was able to parse what it is
// supposed to parse and advance the pointer. Otherwise it returns false
// and the pointer is not advanced so that another parser can be tried.
// ---------------------------------------------------------------------

#include <vector>
#include <map>
#include <string>
#include <fstream>
#include <iostream>
#include <ctype.h>

using namespace std;

struct itemInfo {
    std::string type;
    std::string label;
    std::string address;
    std::string init;
    std::string min;
    std::string max;
    std::string step;
    std::vector<std::pair<std::string, std::string> > meta;
};

bool parseMenuList(const char*& p, vector<string>& names, vector<double>& values);
bool parseMenuItem(const char*& p, string& name, double& value);

void skipBlank(const char*& p);
bool parseChar(const char*& p, char x);
bool parseWord(const char*& p, const char* w);
bool parseString(const char*& p, char quote, string& s);
bool parseSQString(const char*& p, string& s);
bool parseDQString(const char*& p, string& s);
bool parseDouble(const char*& p, double& x);

// ---------------------------------------------------------------------
//
//                          IMPLEMENTATION
// 
// ---------------------------------------------------------------------

/**
 * @brief parseMenuList, parse a menu list {'low' : 440.0; 'mid' : 880.0; 'hi' : 1760.0}...
 * @param p the string to parse, then the remaining string
 * @param names the vector of names found
 * @param values the vector of values found
 * @return true if a menu list was found
 */
inline bool parseMenuList(const char*& p, vector<string>& names, vector<double>& values)
{
    vector<string> tmpnames;
    vector<double> tmpvalues;

    const char* saved = p;

    if (parseChar(p, '{')) {
        do {
            string n;
            double v;
            if (parseMenuItem(p, n, v)) {
                tmpnames.push_back(n);
                tmpvalues.push_back(v);
            } else {
                p = saved;
                return false;
            }
        } while (parseChar(p, ';'));
        if (parseChar(p, '}')) {
            // we suceeded
            names = tmpnames;
            values = tmpvalues;
            return true;
        }
    }
    p = saved;
    return false;
}

/**
 * @brief parseMenuItem, parse a menu item ...'low':440.0...
 * @param p the string to parse, then the remaining string
 * @param name the name found
 * @param value the value found
 * @return true if a nemu item was found
 */
inline bool parseMenuItem(const char*& p, string& name, double& value)
{
    const char* saved = p;
    if (parseSQString(p, name) && parseChar(p, ':') && parseDouble(p, value)) {
        return true;
    } else {
        p = saved;
        return false;
    }
}

// ---------------------------------------------------------------------
//                          Elementary parsers
// ---------------------------------------------------------------------

// Report a parsing error
static bool parseError(const char*& p, const char* errmsg)
{
    std::cerr << "Parse error : " << errmsg << " here : " << p << std::endl;
    return true;
}

// Parse character x, but don't report error if fails
static bool tryChar(const char*& p, char x)
{
    skipBlank(p);
    if (x == *p) {
        p++;
        return true;
    } else {
        return false;
    }
}

/**
 * @brief skipBlank : advance pointer p to the first non blank character
 * @param p the string to parse, then the remaining string
 */
inline void skipBlank(const char*& p)
{
    while (isspace(*p)) { p++; }
}

/**
 * @brief parseChar : parse a specific character x
 * @param p the string to parse, then the remaining string
 * @param x the character to recognize
 * @return true if x was found at the begin of p
 */
inline bool parseChar(const char*& p, char x)
{
    skipBlank(p);
    if (x == *p) {
        p++;
        return true;
    } else {
        return false;
    }
}

/**
 * @brief parseWord : parse a specific string w
 * @param p the string to parse, then the remaining string
 * @param w the string to recognize
 * @return true if string w was found at the begin of p
 */
inline bool parseWord(const char*& p, const char* w)
{
    skipBlank(p);
    const char* saved = p;
    while ((*w == *p) && (*w)) {++w; ++p;}
    if (*w) {
        p = saved;
        return false;
    } else {
        return true;
    }
}

/**
 * @brief parseDouble : parse number [s]dddd[.dddd] and store the result in x
 * @param p the string to parse, then the remaining string
 * @param x the float number found if any
 * @return true if a float number was found at the begin of p
 */
inline bool parseDouble(const char*& p, double& x)
{
    double sign = +1.0;    // sign of the number
    double ipart = 0;      // integral part of the number
    double dpart = 0;      // decimal part of the number before division
    double dcoef = 1.0;    // division factor for the decimal part

    bool valid = false;   // true if the number contains at least one digit
    skipBlank(p);
    const char* saved = p;  // to restore position if we fail

    if (parseChar(p, '+')) {
        sign = 1.0;
    } else if (parseChar(p, '-')) {
        sign = -1.0;
    }
    while (isdigit(*p)) {
        valid = true;
        ipart = ipart*10 + (*p - '0');
        p++;
    }
    if (parseChar(p, '.')) {
        while (isdigit(*p)) {
            valid = true;
            dpart = dpart*10 + (*p - '0');
            dcoef *= 10.0;
            p++;
        }
    }
    if (valid)  {
        x = sign*(ipart + dpart/dcoef);
    } else {
        p = saved;
    }
    return valid;
}

/**
 * @brief parseString, parse an arbitrary quoted string q...q and store the result in s
 * @param p the string to parse, then the remaining string
 * @param quote the character used to quote the string
 * @param s the (unquoted) string found if any
 * @return true if a string was found at the begin of p
 */
inline bool parseString(const char*& p, char quote, string& s)
{
    string str;
    skipBlank(p);
 
    const char* saved = p;
    if (*p++ == quote) {
        while ((*p != 0) && (*p != quote)) {
            str += *p++;
        }
        if (*p++ == quote) {
            s = str;
            return true;
        }
    }
    p = saved;
    return false;
}

/**
 * @brief parseSQString, parse a single quoted string '...' and store the result in s
 * @param p the string to parse, then the remaining string
 * @param s the (unquoted) string found if any
 * @return true if a string was found at the begin of p
 */
inline bool parseSQString(const char*& p, string& s)
{
    return parseString(p, '\'', s);
}

/**
 * @brief parseDQString, parse a double quoted string "..." and store the result in s
 * @param p the string to parse, then the remaining string
 * @param s the (unquoted) string found if any
 * @return true if a string was found at the begin of p
 */
inline bool parseDQString(const char*& p, string& s)
{
    return parseString(p, '"', s);
}

static bool parseMetaData(const char*& p, std::map<std::string, std::string>& metadatas)
{
    std::string metaKey, metaValue;
    if (parseChar(p, ':') && parseChar(p, '[')) {
        do { 
            if (parseChar(p, '{') && parseDQString(p, metaKey) && parseChar(p, ':') && parseDQString(p, metaValue) && parseChar(p, '}')) {
                metadatas[metaKey] = metaValue;
            }
        } while (tryChar(p, ','));
        return parseChar(p, ']');
    } else {
        return false;
    }
}

static bool parseItemMetaData(const char*& p, std::vector<std::pair<std::string, std::string> >& metadatas)
{
    std::string metaKey, metaValue;
    if (parseChar(p, ':') && parseChar(p, '[')) {
        do { 
            if (parseChar(p, '{') && parseDQString(p, metaKey) && parseChar(p, ':') && parseDQString(p, metaValue) && parseChar(p, '}')) {
                metadatas.push_back(std::make_pair(metaKey, metaValue));
            }
        } while (tryChar(p, ','));
        return parseChar(p, ']');
    } else {
        return false;
    }
}

// ---------------------------------------------------------------------
// Parse metadatas of the interface:
// "name" : "...", "inputs" : "...", "outputs" : "...", ...
// and store the result as key/value
//
static bool parseGlobalMetaData(const char*& p, std::string& key, std::string& value, std::map<std::string, std::string>& metadatas)
{
    if (parseDQString(p, key)) {
        if (key == "meta") {
            return parseMetaData(p, metadatas);
        } else {
            return parseChar(p, ':') && parseDQString(p, value);
        }
    } else {
        return false;
    }
}

// ---------------------------------------------------------------------
// Parse gui:
// "type" : "...", "label" : "...", "address" : "...", ...
// and store the result in uiItems Vector
//
static bool parseUI(const char*& p, std::vector<itemInfo*>& uiItems, int& numItems)
{
    if (parseChar(p, '{')) {
        
        std::string label;
        std::string value;
        
        do {
            if (parseDQString(p, label)) {
                if (label == "type") {
                    if (uiItems.size() != 0) {
                        numItems++;
                    }
                    if (parseChar(p, ':') && parseDQString(p, value)) {   
                        itemInfo* item = new itemInfo;
                        item->type = value;
                        uiItems.push_back(item);
                    }
                }
                
                else if (label == "label") {
                    if (parseChar(p, ':') && parseDQString(p, value)) {
                        itemInfo* item = uiItems[numItems];
                        item->label = value;
                    }
                }
                
                else if (label == "address") {
                    if (parseChar(p, ':') && parseDQString(p, value)) {
                        itemInfo* item = uiItems[numItems];
                        item->address = value;
                    }
                }
                
                else if (label == "meta") {
                    itemInfo* item = uiItems[numItems];
                    if (!parseItemMetaData(p, item->meta)) {
                        return false;
                    }
                }
                
                else if (label == "init") {
                    if (parseChar(p, ':') && parseDQString(p, value)) {
                        itemInfo* item = uiItems[numItems];
                        item->init = value;
                    }
                }
                
                else if (label == "min") {
                    if (parseChar(p, ':') && parseDQString(p, value)) {
                        itemInfo* item = uiItems[numItems];
                        item->min = value;
                    }
                }
                
                else if (label == "max") {
                    if (parseChar(p, ':') && parseDQString(p, value)) {
                        itemInfo* item = uiItems[numItems];
                        item->max = value;
                    }
                }
                
                else if (label == "step"){
                    if (parseChar(p, ':') && parseDQString(p, value)) {
                        itemInfo* item = uiItems[numItems];
                        item->step = value;
                    }
                }
                
                else if (label == "items") {
                    if (parseChar(p, ':') && parseChar(p, '[')) {
                        do { 
                            if (!parseUI(p, uiItems, numItems)) {
                                return false;
                            }
                        } while (tryChar(p, ','));
                        if (parseChar(p, ']')) {
                            itemInfo* item = new itemInfo;
                            item->type = "close";
                            uiItems.push_back(item);
                            numItems++;
                        }
                    }
                }
            } else {
                return false;
            }
            
        } while (tryChar(p, ','));
        
        return parseChar(p, '}');
    } else {
        return false;
    }
}

// ---------------------------------------------------------------------
// Parse full JSON record describing a JSON/Faust interface :
// {"metadatas": "...", "ui": [{ "type": "...", "label": "...", "items": [...], "address": "...","init": "...", "min": "...", "max": "...","step": "..."}]}
//
// and store the result in map Metadatas and vector containing the items of the interface. Returns true if parsing was successfull.
//

inline bool parseJson(const char*& p, std::map<std::string, std::string>& metadatas, std::vector<itemInfo*>& uiItems)
{
    parseChar(p, '{');
    
    do {
        std::string key;
        std::string value;
        if (parseGlobalMetaData(p, key, value, metadatas)) {
            if (key != "meta") {
                // keep "name", "inputs", "outputs" key/value pairs
                metadatas[key] = value;
            }
        } else if (key == "ui") {
            int numItems = 0;
            parseChar(p, '[') && parseUI(p, uiItems, numItems);
        }
    } while (tryChar(p, ','));
    
    return parseChar(p, '}');
}

#endif // SIMPLEPARSER_H

#ifdef _WIN32
#include <windows.h>
#define snprintf _snprintf
#endif

inline FAUSTFLOAT STR2REAL(const std::string& s) { return (strtod(s.c_str(), NULL)); }

//-------------------------------------------------------------------
//  Decode a dsp JSON description and implement 'buildUserInterface'
//-------------------------------------------------------------------

struct JSONUIDecoder {

    std::string fName;
    
    std::map<std::string, std::string> fMetadatas; 
    std::vector<itemInfo*> fUiItems;     
    
    FAUSTFLOAT* fInControl;
    FAUSTFLOAT* fOutControl;
    
    std::string fJSON;
    
    int fNumInputs, fNumOutputs; 
    int fInputItems, fOutputItems; 

    JSONUIDecoder(const std::string& json) 
    {
        fJSON = json;
        const char* p = fJSON.c_str();
        parseJson(p, fMetadatas, fUiItems);
        
        // fMetadatas will contain the "meta" section as well as <name : val>, <inputs : val>, <ouputs : val> pairs
        if (fMetadatas.find("name") != fMetadatas.end()) {
            fName = fMetadatas["name"];
            fMetadatas.erase("name");
        } else {
            fName = "";
        }
         
        if (fMetadatas.find("inputs") != fMetadatas.end()) {
            fNumInputs = atoi(fMetadatas["inputs"].c_str());
            fMetadatas.erase("inputs");
        } else {
            fNumInputs = -1;
        }
        
        if (fMetadatas.find("outputs") != fMetadatas.end()) {
            fNumOutputs = atoi(fMetadatas["outputs"].c_str());
            fMetadatas.erase("outputs");
        } else {
            fNumOutputs = -1;
        }
        
        vector<itemInfo*>::iterator it;
        fInputItems = 0;
        fOutputItems = 0;
        
        for (it = fUiItems.begin(); it != fUiItems.end(); it++) {
            string type = (*it)->type;
            if (type == "vslider" || type == "hslider" || type == "nentry" || type == "button") {
                fInputItems++;
            } else if (type == "hbargraph" || type == "vbargraph") {
                fOutputItems++;          
            }
        }
        
        fInControl = new FAUSTFLOAT[fInputItems];
        fOutControl = new FAUSTFLOAT[fOutputItems];
    }
    
    virtual ~JSONUIDecoder() 
    {
        vector<itemInfo*>::iterator it;
        for (it = fUiItems.begin(); it != fUiItems.end(); it++) {
            delete(*it);
        }
        delete [] fInControl;
        delete [] fOutControl;
    }
    
    void metadata(Meta* m)
    {
        std::map<std::string, std::string>::iterator it;
        for (it = fMetadatas.begin(); it != fMetadatas.end(); it++) {
            m->declare((*it).first.c_str(), (*it).second.c_str());
        }
    }
   
    void buildUserInterface(UI* ui)
    {
        // To be sure the floats are correctly encoded
        char* tmp_local = setlocale(LC_ALL, NULL);
        setlocale(LC_ALL, "C");

        int counterIn = 0;
        int counterOut = 0;
        vector<itemInfo*>::iterator it;
        
        for (it = fUiItems.begin(); it != fUiItems.end(); it++) {
            
            bool isInItem = false;
            bool isOutItem = false;
            string type = (*it)->type;
            
            FAUSTFLOAT init = STR2REAL((*it)->init);
            FAUSTFLOAT min = STR2REAL((*it)->min);
            FAUSTFLOAT max = STR2REAL((*it)->max);
            FAUSTFLOAT step = STR2REAL((*it)->step);
            
            if (type == "vslider" || type == "hslider" || type == "nentry" || type == "button") {
                isInItem = true;
            } else if (type == "hbargraph" || type == "vbargraph") {
                isOutItem = true;        
            }
            
            // Meta data declaration for input items
            if ((*it)->type.find("group") == string::npos && (*it)->type.find("bargraph") == string::npos && (*it)->type != "close") {
                fInControl[counterIn] = init;
                for (int i = 0; i < (*it)->meta.size(); i++) {
                    ui->declare(&fInControl[counterIn], (*it)->meta[i].first.c_str(), (*it)->meta[i].second.c_str());
                }
            }
            // Meta data declaration for output items
            else if ((*it)->type.find("bargraph") != string::npos) {
                fOutControl[counterOut] = init;
                for (int i = 0; i < (*it)->meta.size(); i++) {
                    ui->declare(&fOutControl[counterOut], (*it)->meta[i].first.c_str(), (*it)->meta[i].second.c_str());
                }
            }
            // Meta data declaration for group opening or closing
            else {
                for (int i = 0; i < (*it)->meta.size(); i++) {
                    ui->declare(0, (*it)->meta[i].first.c_str(), (*it)->meta[i].second.c_str());
                }
            }
            
            if (type == "hgroup") {
                ui->openHorizontalBox((*it)->label.c_str());
            } else if (type == "vgroup") { 
                ui->openVerticalBox((*it)->label.c_str());
            } else if (type == "tgroup") {
                ui->openTabBox((*it)->label.c_str());
            } else if (type == "vslider") {
                ui->addVerticalSlider((*it)->label.c_str(), &fInControl[counterIn], init, min, max, step);
            } else if (type == "hslider") {
                ui->addHorizontalSlider((*it)->label.c_str(), &fInControl[counterIn], init, min, max, step);            
            } else if (type == "checkbox") {
                ui->addCheckButton((*it)->label.c_str(), &fInControl[counterIn]);
            } else if (type == "hbargraph") {
                ui->addHorizontalBargraph((*it)->label.c_str(), &fOutControl[counterOut], min, max);
            } else if (type == "vbargraph") {
                ui->addVerticalBargraph((*it)->label.c_str(), &fOutControl[counterOut], min, max);
            } else if (type == "nentry") {
                ui->addNumEntry((*it)->label.c_str(), &fInControl[counterIn], init, min, max, step);
            } else if (type == "button") {
                ui->addButton((*it)->label.c_str(), &fInControl[counterIn]);
            } else if (type == "close") {
                ui->closeBox();
            }
                
            if (isInItem) {
                counterIn++;
            }
                
            if (isOutItem) {
                counterOut++;
            }
        }
        
        setlocale(LC_ALL, tmp_local);
    }
    
};

//----------------------------------------------------------------
//  Proxy dsp definition created from the DSP JSON description
//  This class allows a 'proxy' dsp to control a real dsp 
//  possibly running somewhere else.
//----------------------------------------------------------------

class proxy_dsp : public dsp {

    private:
    
        int fSamplingFreq;
        JSONUIDecoder* fDecoder;
        
    public:
    
        proxy_dsp(const string& json)
        {
            fDecoder = new JSONUIDecoder(json);
            fSamplingFreq = -1;
        }
          
        proxy_dsp(dsp* dsp)
        {
            JSONUI builder(dsp->getNumInputs(), dsp->getNumOutputs());
            dsp->metadata(&builder);
            dsp->buildUserInterface(&builder);
            fSamplingFreq = dsp->getSampleRate();
            fDecoder = new JSONUIDecoder(builder.JSON());
        }
      
        virtual ~proxy_dsp()
        {
            delete fDecoder;
        }
       
        virtual int getNumInputs() 	{ return fDecoder->fNumInputs; }
        virtual int getNumOutputs() { return fDecoder->fNumOutputs; }
        
        virtual void buildUserInterface(UI* ui) { fDecoder->buildUserInterface(ui); }
        
        // To possibly implement in a concrete proxy dsp 
        virtual void init(int samplingRate) { fSamplingFreq = samplingRate; }
        virtual void instanceInit(int samplingRate) {}
        virtual void instanceConstants(int samplingRate) {}
        virtual void instanceResetUserInterface() {}
        virtual void instanceClear() {}
    
        virtual int getSampleRate() { return fSamplingFreq; }
    
        virtual proxy_dsp* clone() { return new proxy_dsp(fDecoder->fJSON); }
        virtual void metadata(Meta* m) { fDecoder->metadata(m); }
    
        virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) {}
        virtual void compute(double date_usec, int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) {} 
        
};

#endif

#define kActiveVoice      0
#define kFreeVoice        -1
#define kReleaseVoice     -2
#define kNoVoice          -3

#define VOICE_STOP_LEVEL  0.001
#define MIX_BUFFER_SIZE   16384

#define FLOAT_MAX(a, b) (((a) < (b)) ? (b) : (a))

// endsWith(<str>,<end>) : returns true if <str> ends with <end>

static inline bool endsWith(std::string const& str, std::string const& end)
{
    size_t l1 = str.length();
    size_t l2 = end.length();
    return (l1 >= l2) && (0 == str.compare(l1 - l2, l2, end));
}

static inline double midiToFreq(double note)
{
    return 440.0 * pow(2.0, (note-69.0)/12.0);
}

static inline unsigned int isPowerOfTwo(unsigned int n)
{
    return !(n & (n - 1));
}

/**
 * Allows to control zones in a grouped manner.
 */

class GroupUI : public GUI, public PathBuilder
{

    private:

        std::map<std::string, uiGroupItem*> fLabelZoneMap;

        void insertMap(std::string label, FAUSTFLOAT* zone)
        {
            if (!endsWith(label, "/gate")
                && !endsWith(label, "/freq")
                && !endsWith(label, "/gain")) {

                // Groups all controller except 'freq', 'gate', and 'gain'
                if (fLabelZoneMap.find(label) != fLabelZoneMap.end()) {
                    fLabelZoneMap[label]->addZone(zone);
                } else {
                    fLabelZoneMap[label] = new uiGroupItem(this, zone);
                }
            }
        }

        uiCallbackItem* fPanic;

    public:

        GroupUI(FAUSTFLOAT* zone, uiCallback cb, void* arg)
        {
            fPanic = new uiCallbackItem(this, zone, cb, arg);
        };
        virtual ~GroupUI()
        {
            // 'fPanic' is kept and deleted in GUI, so do not delete here
        };

        // -- widget's layouts
        void openTabBox(const char* label)
        {
            fControlsLevel.push_back(label);
        }
        void openHorizontalBox(const char* label)
        {
            fControlsLevel.push_back(label);
        }
        void openVerticalBox(const char* label)
        {
            fControlsLevel.push_back(label);
        }
        void closeBox()
        {
            fControlsLevel.pop_back();
        }

        // -- active widgets
        void addButton(const char* label, FAUSTFLOAT* zone)
        {
            insertMap(buildPath(label), zone);
        }
        void addCheckButton(const char* label, FAUSTFLOAT* zone)
        {
            insertMap(buildPath(label), zone);
        }
        void addVerticalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT fmin, FAUSTFLOAT fmax, FAUSTFLOAT step)
        {
            insertMap(buildPath(label), zone);
        }
        void addHorizontalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT fmin, FAUSTFLOAT fmax, FAUSTFLOAT step)
        {
            insertMap(buildPath(label), zone);
        }
        void addNumEntry(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT fmin, FAUSTFLOAT fmax, FAUSTFLOAT step)
        {
            insertMap(buildPath(label), zone);
        }

        // -- passive widgets
        void addHorizontalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT fmin, FAUSTFLOAT fmax)
        {
            insertMap(buildPath(label), zone);
        }
        void addVerticalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT fmin, FAUSTFLOAT fmax)
        {
            insertMap(buildPath(label), zone);
        }

};

/**
 * One voice of polyphony.
 */

struct dsp_voice : public MapUI, public decorator_dsp {

    int fNote;              // Playing note actual pitch
    int fDate;              // KeyOn date
    bool fTrigger;          // True if stolen note and need for envelop trigger
    FAUSTFLOAT fLevel;      // Last audio block level
    std::string fGatePath;  // Path of 'gate' control
    std::string fGainPath;  // Path of 'gain' control
    std::string fFreqPath;  // Path of 'freq' control

    dsp_voice(dsp* dsp):decorator_dsp(dsp)
    {
        dsp->buildUserInterface(this);
        fNote = kFreeVoice;
        fLevel = FAUSTFLOAT(0);
        fDate = 0;
        fTrigger = false;
        extractPaths(fGatePath, fFreqPath, fGainPath);
    }

    void extractPaths(std::string& gate, std::string& freq, std::string& gain)
    {
        // Keep gain, freq and gate labels
        std::map<std::string, FAUSTFLOAT*>::iterator it;
        for (it = getMap().begin(); it != getMap().end(); it++) {
            std::string path = (*it).first;
            if (endsWith(path, "/gate")) {
                gate = path;
            } else if (endsWith(path, "/freq")) {
                freq = path;
            } else if (endsWith(path, "/gain")) {
                gain = path;
            }
        }
    }

    // MIDI velocity [0..127]
    void keyOn(int pitch, int velocity)
    {
        setParamValue(fFreqPath, midiToFreq(pitch));
        setParamValue(fGainPath, float(velocity)/127.f);
        fNote = pitch;
        fTrigger = true; // so that envelop is always re-initialized
    }

    // Normalized MIDI velocity [0..1]
    void keyOn(int pitch, float velocity)
    {
        setParamValue(fFreqPath, midiToFreq(pitch));
        setParamValue(fGainPath, velocity);
        fNote = pitch;
        fTrigger = true; // so that envelop is always re-initialized
    }

    void keyOff(bool hard = false)
    {
        // No use of velocity for now...
        setParamValue(fGatePath, FAUSTFLOAT(0));
        if (hard) {
            // Stop immediately
            fNote = kFreeVoice;
            fTrigger = false;
        } else {
            // Release voice
            fNote = kReleaseVoice;
        }
    }

    void play(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
    {
        if (fTrigger) {
            // New note, so trigger it
            trigger(count, inputs, outputs);
        } else {
            // Compute the voice
            compute(count, inputs, outputs);
        }
    }

    void trigger(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
    {
        setParamValue(fGatePath, FAUSTFLOAT(0));
        computeSlice(0, 1, inputs, outputs);
        setParamValue(fGatePath, FAUSTFLOAT(1));
        computeSlice(1, count - 1, inputs, outputs);
        fTrigger = false;
    }

    void computeSlice(int offset, int slice, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
    {
        if (slice > 0) {
            FAUSTFLOAT** inputs_slice = (FAUSTFLOAT**)alloca(getNumInputs() * sizeof(FAUSTFLOAT*));
            for (int chan = 0; chan < getNumInputs(); chan++) {
                inputs_slice[chan] = &(inputs[chan][offset]);
            }

            FAUSTFLOAT** outputs_slice = (FAUSTFLOAT**)alloca(getNumOutputs() * sizeof(FAUSTFLOAT*));
            for (int chan = 0; chan < getNumOutputs(); chan++) {
                outputs_slice[chan] = &(outputs[chan][offset]);
            }

            compute(slice, inputs_slice, outputs_slice);
        }
    }

};

/**
 * A group of voices.
 */

struct dsp_voice_group {

    GroupUI fGroups;

    std::vector<dsp_voice*> fVoiceTable; // Individual voices
    dsp* fVoiceGroup;                    // Voices group to be used for GUI grouped control

    FAUSTFLOAT fPanic;

    bool fVoiceControl;
    bool fGroupControl;

    dsp_voice_group(uiCallback cb, void* arg, bool control, bool group)
        :fGroups(&fPanic, cb, arg),
        fVoiceGroup(0), fPanic(FAUSTFLOAT(0)),
        fVoiceControl(control), fGroupControl(group)
    {}

    virtual ~dsp_voice_group()
    {
        for (int i = 0; i < fVoiceTable.size(); i++) {
            delete fVoiceTable[i];
        }
        delete fVoiceGroup;
    }

    void addVoice(dsp_voice* voice)
    {
        fVoiceTable.push_back(voice);
    }

    void clearVoices()
    {
        fVoiceTable.clear();
    }

    void init()
    {
        // Groups all uiItem for a given path
        fVoiceGroup = new proxy_dsp(fVoiceTable[0]);
        fVoiceGroup->buildUserInterface(&fGroups);
        for (int i = 0; i < fVoiceTable.size(); i++) {
            fVoiceTable[i]->buildUserInterface(&fGroups);
        }
    }

    void buildUserInterface(UI* ui_interface)
    {
        if (fVoiceTable.size() > 1) {
            ui_interface->openTabBox("Polyphonic");

            // Grouped voices UI
            ui_interface->openVerticalBox("Voices");
            ui_interface->addButton("Panic", &fPanic);
            fVoiceGroup->buildUserInterface(ui_interface);
            ui_interface->closeBox();

            // In not group, also add individual voices UI
            if (!fGroupControl) {
                for (int i = 0; i < fVoiceTable.size(); i++) {
                    char buffer[32];
                    snprintf(buffer, 31, ((fVoiceTable.size() < 8) ? "Voice%d" : "V%d"), i+1);
                    ui_interface->openHorizontalBox(buffer);
                    fVoiceTable[i]->buildUserInterface(ui_interface);
                    ui_interface->closeBox();
                }
            }

            ui_interface->closeBox();
        } else {
            fVoiceTable[0]->buildUserInterface(ui_interface);
        }
    }

};

/**
 * Polyphonic DSP : group a set of DSP to be played together or triggered by MIDI.
 */

class mydsp_poly : public decorator_dsp, public dsp_voice_group, public midi {

    private:

        FAUSTFLOAT** fMixBuffer;
        int fDate;

        inline FAUSTFLOAT mixVoice(int count, FAUSTFLOAT** outputBuffer, FAUSTFLOAT** mixBuffer)
        {
            FAUSTFLOAT level = 0;
            for (int i = 0; i < getNumOutputs(); i++) {
                FAUSTFLOAT* mixChannel = mixBuffer[i];
                FAUSTFLOAT* outChannel = outputBuffer[i];
                for (int j = 0; j < count; j++) {
                    level = FLOAT_MAX(level, (FAUSTFLOAT)fabs(outChannel[j]));
                    mixChannel[j] += outChannel[j];
                }
            }
            return level;
        }

        inline void clearOutput(int count, FAUSTFLOAT** mixBuffer)
        {
            for (int i = 0; i < getNumOutputs(); i++) {
                memset(mixBuffer[i], 0, count * sizeof(FAUSTFLOAT));
            }
        }

        inline int getVoice(int note, bool steal = false)
        {
            for (int i = 0; i < fVoiceTable.size(); i++) {
                if (fVoiceTable[i]->fNote == note) {
                    if (steal) {
                        fVoiceTable[i]->fDate = fDate++;
                    }
                    return i;
                }
            }

            if (steal) {
                int voice_release = kNoVoice;
                int voice_playing = kNoVoice;
                int oldest_date_release = INT_MAX;
                int oldest_date_playing = INT_MAX;

                // Scan all voices
                for (int i = 0; i < fVoiceTable.size(); i++) {
                    if (fVoiceTable[i]->fNote == kReleaseVoice) {
                        // Keeps oldest release voice
                        if (fVoiceTable[i]->fDate < oldest_date_release) {
                            oldest_date_release = fVoiceTable[i]->fDate;
                            voice_release = i;
                        }
                    } else {
                        // Otherwise keeps oldest playing voice
                        if (fVoiceTable[i]->fDate < oldest_date_playing) {
                            oldest_date_playing = fVoiceTable[i]->fDate;
                            voice_playing = i;
                        }
                    }
                }

                // Then decide which one to steal
                if (oldest_date_release != INT_MAX) {
                    std::cout << "Steal release voice : voice_date " << fVoiceTable[voice_release]->fDate << " cur_date = " << fDate << " voice = " << voice_release << std::endl;
                    fVoiceTable[voice_release]->fDate = fDate++;
                    fVoiceTable[voice_release]->fTrigger = true;
                    return voice_release;
                } else if (oldest_date_playing != INT_MAX) {
                    std::cout << "Steal playing voice : voice_date " << fVoiceTable[voice_playing]->fDate << " cur_date = " << fDate << " voice = " << voice_playing << std::endl;
                    fVoiceTable[voice_playing]->fDate = fDate++;
                    fVoiceTable[voice_playing]->fTrigger = true;
                    return voice_playing;
                } else {
                    assert(false);
                    return kNoVoice;
                }

            } else {
                return kNoVoice;
            }
        }

        static void panic(FAUSTFLOAT val, void* arg)
        {
            if (val == FAUSTFLOAT(1)) {
                static_cast<mydsp_poly*>(arg)->allNotesOff(true);
            }
        }

        inline bool checkPolyphony()
        {
            if (fVoiceTable.size() > 0) {
                return true;
            } else {
                std::cout << "DSP is not polyphonic...\n";
                return false;
            }
        }

        // Always returns a voice
        int newVoiceAux()
        {
            int voice = getVoice(kFreeVoice, true);
            assert(voice != kNoVoice);
            fVoiceTable[voice]->fNote = kActiveVoice;
            return voice;
        }

    public:

        /**
         * Constructor.
         *
         * @param dsp - the dsp to be used for one voice. Beware: mydsp_poly will use and finally delete the pointer.
         * @param nvoices - number of polyphony voices
         * @param control - whether voices will be dynamically allocated and controlled (typically by a MIDI controler).
         *                If false all voices are always running.
         * @param group - if true, voices are not individually accessible, a global "Voices" tab will automatically dispatch
         *                a given control on all voices, assuming GUI::updateAllGuis() is called.
         *                If false, all voices can be individually controlled.
         *
         */
        mydsp_poly(dsp* dsp,
                   int nvoices,
                   bool control = false,
                   bool group = true):decorator_dsp(dsp), dsp_voice_group(panic, this, control, group)
        {
            fDate = 0;

            // Create voices
            for (int i = 0; i < nvoices; i++) {
                addVoice(new dsp_voice(dsp->clone()));
            }

            // Init audio output buffers
            fMixBuffer = new FAUSTFLOAT*[getNumOutputs()];
            for (int i = 0; i < getNumOutputs(); i++) {
                fMixBuffer[i] = new FAUSTFLOAT[MIX_BUFFER_SIZE];
            }

            dsp_voice_group::init();
        }

        virtual ~mydsp_poly()
        {
            for (int i = 0; i < getNumOutputs(); i++) {
                delete[] fMixBuffer[i];
            }
            delete[] fMixBuffer;
        }

        // DSP API
    
        void buildUserInterface(UI* ui_interface)
        {
            dsp_voice_group::buildUserInterface(ui_interface);
        }

        void init(int samplingRate)
        {
            // Init voices
            for (int i = 0; i < fVoiceTable.size(); i++) {
                fVoiceTable[i]->init(samplingRate);
            }
        }

        void instanceInit(int samplingRate)
        {
            // Init voices
            for (int i = 0; i < fVoiceTable.size(); i++) {
                fVoiceTable[i]->instanceInit(samplingRate);
            }
        }

        void instanceConstants(int samplingRate)
        {
            // Init voices
            for (int i = 0; i < fVoiceTable.size(); i++) {
                fVoiceTable[i]->instanceConstants(samplingRate);
            }
        }

        void instanceResetUserInterface()
        {
            for (int i = 0; i < fVoiceTable.size(); i++) {
                fVoiceTable[i]->instanceResetUserInterface();
            }
        }

        void instanceClear()
        {
            for (int i = 0; i < fVoiceTable.size(); i++) {
                fVoiceTable[i]->instanceClear();
            }
        }

        virtual mydsp_poly* clone()
        {
            return new mydsp_poly(fDSP->clone(), fVoiceTable.size(), fVoiceControl, fGroupControl);
        }

        void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
        {
            assert(count < MIX_BUFFER_SIZE);

            // First clear the outputs
            clearOutput(count, outputs);

            if (fVoiceControl) {
                // Mix all playing voices
                for (int i = 0; i < fVoiceTable.size(); i++) {
                    dsp_voice* voice = fVoiceTable[i];
                    if (voice->fNote != kFreeVoice) {
                        voice->play(count, inputs, fMixBuffer);
                        // Mix it in result
                        voice->fLevel = mixVoice(count, fMixBuffer, outputs);
                        // Check the level to possibly set the voice in kFreeVoice again
                        if ((voice->fLevel < VOICE_STOP_LEVEL) && (voice->fNote == kReleaseVoice)) {
                            voice->fNote = kFreeVoice;
                        }
                    }
                }
            } else {
                // Mix all voices
                for (int i = 0; i < fVoiceTable.size(); i++) {
                    fVoiceTable[i]->compute(count, inputs, fMixBuffer);
                    mixVoice(count, fMixBuffer, outputs);
                }
            }
        }

        void compute(double date_usec, int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
        {
            compute(count, inputs, outputs);
        }

        // Additional polyphonic API
        MapUI* newVoice()
        {
            return fVoiceTable[newVoiceAux()];
        }

        void deleteVoice(MapUI* voice)
        {
            std::vector<dsp_voice*>::iterator it = find(fVoiceTable.begin(), fVoiceTable.end(), reinterpret_cast<dsp_voice*>(voice));
            if (it != fVoiceTable.end()) {
                (*it)->keyOff();
            } else {
                std::cout << "Voice not found\n";
            }
        }

        // MIDI API
        MapUI* keyOn(int channel, int pitch, int velocity)
        {
            if (checkPolyphony()) {
                int voice = newVoiceAux();
                fVoiceTable[voice]->keyOn(pitch, velocity);
                return fVoiceTable[voice];
            } else {
                return 0;
            }
        }

        void keyOff(int channel, int pitch, int velocity = 127)
        {
            if (checkPolyphony()) {
                int voice = getVoice(pitch);
                if (voice != kNoVoice) {
                    fVoiceTable[voice]->keyOff();
                } else {
                    std::cout << "Playing pitch = " << pitch << " not found\n";
                }
            }
        }

        void pitchWheel(int channel, int wheel)
        {}

        void ctrlChange(int channel, int ctrl, int value)
        {
            if (ctrl == ALL_NOTES_OFF || ctrl == ALL_SOUND_OFF) {
                allNotesOff();
            }
        }

        void progChange(int channel, int pgm)
        {}

        void keyPress(int channel, int pitch, int press)
        {}

        void chanPress(int channel, int press)
        {}

        void ctrlChange14bits(int channel, int ctrl, int value)
        {}

        // Terminate all active voices, gently or immediately (depending of 'hard' value)
        void allNotesOff(bool hard = false)
        {
            for (int i = 0; i < fVoiceTable.size(); i++) {
                fVoiceTable[i]->keyOff(hard);
            }
        }

};

#endif // __poly_dsp__

std::list<GUI*> GUI::fGuiList;
ztimedmap GUI::gTimedZoneMap;

static const char* getCodeSize()
{
    int tmp;
    return (sizeof(&tmp) == 8) ? "64 bits" : "32 bits";
}

class mspUI;

struct Max_Meta1 : Meta
{
    int fCount;
    
    Max_Meta1():fCount(0)
    {}
     
    void declare(const char* key, const char* value)
    {
        if ((strcmp("name", key) == 0) || (strcmp("author", key) == 0)) {
            fCount++;
        }
    }
};

struct Max_Meta2 : Meta
{
    void declare(const char* key, const char* value)
    {
        if ((strcmp("name", key) == 0) || (strcmp("author", key) == 0)) {
            post("%s : %s", key, value);
        }
    }
};

/*--------------------------------------------------------------------------*/
typedef struct faust
{
    t_pxobject m_ob;
    t_atom *m_seen, *m_want;
    map<string, vector <t_object*> > m_output_table;
    short m_where;
    bool m_mute;
    void** m_args;
    mspUI* m_dspUI;
    dsp* m_dsp;
    char* m_json;
    t_systhread_mutex m_mutex;    
    int m_Inputs;
    int m_Outputs;
#ifdef MIDICTRL
    MidiUI* m_midiUI;
    midi_handler* m_midiHandler;
#endif
} t_faust;

void* faust_class;

void faust_create_jsui(t_faust* x);
void faust_make_json(t_faust* x);

/*--------------------------------------------------------------------------*/
class mspUIObject {

	protected:

		string fLabel;
		FAUSTFLOAT* fZone;

		FAUSTFLOAT range(FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT val) {return (val < min) ? min : (val > max) ? max : val;}

	public:

		mspUIObject(const string& label, FAUSTFLOAT* zone):fLabel(label),fZone(zone) {}
		virtual ~mspUIObject() {}

		virtual void setValue(FAUSTFLOAT f) {*fZone = range(0.0,1.0,f);}
        virtual FAUSTFLOAT getValue() { return *fZone; }
		virtual void toString(char* buffer) {}
		virtual string getName() {return fLabel;}
};

/*--------------------------------------------------------------------------*/
class mspCheckButton : public mspUIObject {

	public:

		mspCheckButton(const string& label, FAUSTFLOAT* zone):mspUIObject(label,zone) {}
		virtual ~mspCheckButton() {}

		void toString(char* buffer)
		{
            sprintf(buffer, "CheckButton(double): %s", fLabel.c_str());
		}
};

/*--------------------------------------------------------------------------*/
class mspButton : public mspUIObject {

	public:

		mspButton(const string& label, FAUSTFLOAT* zone):mspUIObject(label,zone) {}
		virtual ~mspButton() {}

		void toString(char* buffer)
		{
            sprintf(buffer, "Button(double): %s", fLabel.c_str());
		}
};

/*--------------------------------------------------------------------------*/
class mspSlider : public mspUIObject {

	private:

		FAUSTFLOAT fInit;
		FAUSTFLOAT fMin;
		FAUSTFLOAT fMax;
		FAUSTFLOAT fStep;

	public:

		mspSlider(const string& label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step)
			:mspUIObject(label,zone),fInit(init),fMin(min),fMax(max),fStep(step) {}
		virtual ~mspSlider() {}

		void toString(char* buffer)
		{
            stringstream s; 
            s << "Slider(double): " << fLabel << " [init=" << fInit << ":min=" << fMin << ":max=" << fMax << ":step=" << fStep << ":cur=" << *fZone << "]";
            strcpy(buffer, s.str().c_str());
		}

		void setValue(FAUSTFLOAT f) {*fZone = range(fMin,fMax,f);}
};

/*--------------------------------------------------------------------------*/
class mspBargraph : public mspUIObject {
    
    private:
        
        FAUSTFLOAT fMin;
        FAUSTFLOAT fMax;
        FAUSTFLOAT fCurrent;
        
    public:
        
        mspBargraph(const string& label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max)
        :mspUIObject(label,zone),fMin(min),fMax(max),fCurrent(*zone) {}
        virtual ~mspBargraph() {}
        
        void toString(char* buffer)
        {
            stringstream s; 
            s << "Bargraph(float): " << fLabel << " [min=" << fMin << ":max=" << fMax << ":cur=" << *fZone << "]";
            strcpy(buffer, s.str().c_str());
        }
        
        virtual FAUSTFLOAT getValue() 
        { 
            if (*fZone != fCurrent) {
                fCurrent = *fZone;
                return fCurrent;
            } else {
                return NAN; 
            }
        }
};

/*--------------------------------------------------------------------------*/

#define MULTI_SIZE  256

class mspUI : public UI
{
	private:

        map<string, mspUIObject*> fUITable1;       // Table using labels
        map<string, mspUIObject*> fUITable2;       // Table using complete path
        map<string, mspUIObject*> fUITable3;       // Table containing bargraph
       
        map<const char*, const char*> fDeclareTable;
        std::vector<std::string> fControlsLevel;
        
        FAUSTFLOAT* fMultiTable[MULTI_SIZE];
        int fMultiIndex;
        int fMultiControl;
        
        std::string buildPath(const std::string& label) 
        {
            std::string res = "/";
            for (size_t i = 0; i < fControlsLevel.size(); i++) {
                res += fControlsLevel[i];
                res += "/";
            }
            res += label;
            replace(res.begin(), res.end(), ' ', '_');
            return res;
        }
    
        string createLabel(const char* label)
        {
            map<const char*, const char*>::reverse_iterator it;
            if (fDeclareTable.size() > 0) {
                unsigned int i = 0;
                string res = string(label);
                char sep = '[';
                for (it = fDeclareTable.rbegin(); it != fDeclareTable.rend(); it++, i++) {
                    res = res + sep + (*it).first + ":" + (*it).second;
                    sep = ',';
                }
                res += ']';
                fDeclareTable.clear();
                return res;
            } else {
                return string(label);
            }
        }

	public:
    
		typedef map<string, mspUIObject*>::iterator iterator;

		mspUI() 
        {
     		for (int i = 0; i < MULTI_SIZE; i++) {
                fMultiTable[i] = 0;
            }
            fMultiIndex = fMultiControl = 0;
        }
		virtual ~mspUI()
		{
            clear();
   		}
      
		void addButton(const char* label, FAUSTFLOAT* zone) 
        {
            mspUIObject* obj = new mspButton(createLabel(label), zone);
            fUITable1[string(label)] = obj;
            fUITable2[buildPath(label)] = obj;
        }
        
        void addCheckButton(const char* label, FAUSTFLOAT* zone) 
        {
            mspUIObject* obj = new mspCheckButton(createLabel(label), zone);
            fUITable1[string(label)] = obj;
            fUITable2[buildPath(label)] = obj; 
        }
        
        void addSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step)
        {
            mspUIObject* obj = new mspSlider(createLabel(label), zone, init, min, max, step);
            fUITable1[string(label)] = obj;
            fUITable2[buildPath(label)] = obj; 
        }
        
        void addVerticalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step)
        {
            addSlider(label, zone, init, min, max, step);
        }
        
        void addHorizontalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step)
        {
            addSlider(label, zone, init, min, max, step);
        }
        
        void addNumEntry(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step)
        {
            mspUIObject* obj = new mspSlider(createLabel(label), zone, init, min, max, step);
            fUITable1[string(label)] = obj;
            fUITable2[buildPath(label)] = obj;
        }
        
        void addHorizontalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max) 
        {   
            fUITable3[buildPath(label)] = new mspBargraph(createLabel(label), zone, min, max);
            fDeclareTable.clear();
        }
        void addVerticalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max) 
        {
            fUITable3[buildPath(label)] = new mspBargraph(createLabel(label), zone, min, max);
            fDeclareTable.clear();
        }
    
        void openTabBox(const char* label) {fControlsLevel.push_back(label); fDeclareTable.clear();}
        void openHorizontalBox(const char* label) {fControlsLevel.push_back(label); fDeclareTable.clear();}
        void openVerticalBox(const char* label) {fControlsLevel.push_back(label); fDeclareTable.clear();}
        void closeBox() {fControlsLevel.pop_back(); fDeclareTable.clear();}

        virtual void declare(FAUSTFLOAT* zone, const char* key, const char* val)
        {
            if (strcmp(key,"multi") == 0) {
                int index = atoi(val);
                if (index >= 0 && index < MULTI_SIZE) {
                    fMultiTable[index] = zone;
                    fMultiControl++;
                } else {
                    post("Invalid multi index = %d", index);
                }
            }
            
            fDeclareTable[key] = val;
        }
        
        void setMultiValues(FAUSTFLOAT* multi, int buffer_size)
		{
            for (int read = 0; read < buffer_size; read++) {
                int write = (fMultiIndex + read) & (MULTI_SIZE - 1);
                if (fMultiTable[write]) {
                    *fMultiTable[write] = multi[read];
                }
            }
            fMultiIndex += buffer_size;
		}
        
        bool isMulti() { return fMultiControl > 0; }
    
        bool isValue(string name) 
        {
            return (fUITable1.count(name) || fUITable2.count(name));
        }
        bool isOutputValue(string name) 
        {
            return fUITable3.count(name);
        }
        bool isInputValue(string name) 
        {
            return fUITable2.count(name);
        }
        bool setValue(string name, FAUSTFLOAT f)
        {
            if (fUITable1.count(name)) {
                fUITable1[name]->setValue(f);
                return true;
            } else if (fUITable2.count(name)) {
                fUITable2[name]->setValue(f);
                return true;
            } else {
                return false;
            }
        }
		FAUSTFLOAT getOutputValue(string name) { return fUITable3[name]->getValue(); }
          
        iterator begin1()	{ return fUITable1.begin(); }
        iterator end1()		{ return fUITable1.end(); }
        
        iterator begin2()	{ return fUITable2.begin(); }
        iterator end2()		{ return fUITable2.end(); }

        int itemsCount() { return fUITable1.size(); }
        void clear() 
        { 
            iterator it;
            for (it = begin1(); it != end1(); it++) {
                delete (*it).second;
            }
            fUITable1.clear(); 
            fUITable2.clear(); 
        }
};

//--------------------------------------------------------------------------
static bool check_digit(const string& name)
{
    for (int i = name.size() - 1; i >= 0; i--) {
        if (isdigit(name[i])) { return true; }
    }
    return false;
}

static int count_digit(const string& name)
{
    int count = 0;
    for (int i = name.size() - 1; i >= 0; i--) {
        if (isdigit(name[i])) { count++; }
    }
    return count;
}

/*--------------------------------------------------------------------------*/
void faust_anything(t_faust* obj, t_symbol* s, short ac, t_atom* av)
{
    if (ac < 0) return;
    
    bool res = false;
    string name = string((s)->s_name);
    
    // Check if no argument is there, consider it is a toggle message for a button
    if (ac == 0 && obj->m_dspUI->isValue(name)) {
        
        string name = string((s)->s_name);
        float off = 0.0f;
        float on = 1.0f;
        obj->m_dspUI->setValue(name, off);
        obj->m_dspUI->setValue(name, on);
        
        av[0].a_type = A_FLOAT;
        av[0].a_w.w_float = off;
        faust_anything(obj, s, 1, av);
        
        return;
    }
    
    // List of values
    if (check_digit(name)) {
        
        int ndigit = 0;
        int pos;
        
        for (pos = name.size() - 1; pos >= 0; pos--) {
            if (isdigit(name[pos]) || name[pos] == ' ') {
                ndigit++;
            } else {
                break;
            }
        }
        pos++;
        
        string prefix = name.substr(0, pos);
        string num_base = name.substr(pos);
        int num = atoi(num_base.c_str());
        
        int i;
        t_atom* ap;
       
        // Increment ap each time to get to the next atom
        for (i = 0, ap = av; i < ac; i++, ap++) {
            float value;
            switch (atom_gettype(ap)) {
                case A_LONG: 
                    value = (float)ap[0].a_w.w_long;
                    break;
                
                case A_FLOAT:
                    value = ap[0].a_w.w_float;
                    break;
                    
                default:
                    post("Invalid argument in parameter setting"); 
                    return;         
            }
            
            stringstream num_val;
            num_val << num + i;
            char param_name[256];
            
            switch (ndigit - count_digit(num_val.str())) {
                case 0: 
                    sprintf(param_name, "%s%s", prefix.c_str(), num_val.str().c_str());
                    break;
                case 1: 
                    sprintf(param_name, "%s %s", prefix.c_str(), num_val.str().c_str());
                    break;
                case 2: 
                    sprintf(param_name, "%s  %s", prefix.c_str(), num_val.str().c_str());
                    break;
            }
            
            // Try special naming scheme for list of parameters
            res = obj->m_dspUI->setValue(param_name, value); 
            
            // Otherwise try standard name
            if (!res) {
                res = obj->m_dspUI->setValue(name, value);
            }
            
            if (!res) {
                post("Unknown parameter : %s", (s)->s_name);
            }
        }
    } else {
        // Standard parameter name
        float value = (av[0].a_type == A_LONG) ? (float)av[0].a_w.w_long : av[0].a_w.w_float;
        res = obj->m_dspUI->setValue(name, value);
    }
    
    if (!res) {
        post("Unknown parameter : %s", (s)->s_name);
    }
}

/*--------------------------------------------------------------------------*/
void faust_polyphony(t_faust* obj, t_symbol* s, short ac, t_atom* av)
{
    if (systhread_mutex_lock(obj->m_mutex) == MAX_ERR_NONE) {
        // Delete old
        delete obj->m_dsp;
        obj->m_dspUI->clear();
        mydsp_poly* dsp_poly = NULL;
        // Allocate new one
        if (av[0].a_w.w_long > 0) {
            post("polyphonic DSP voices = %d", av[0].a_w.w_long);
            dsp_poly = new mydsp_poly(new mydsp(), av[0].a_w.w_long, true, true);
        #ifdef POLY2
            obj->m_dsp = new dsp_sequencer(dsp_poly, new effect());
        #else
            obj->m_dsp = dsp_poly;
        #endif
        } else {
            obj->m_dsp = new mydsp();
            post("monophonic DSP");
        }
        // Initialize User Interface (here connnection with controls)
        obj->m_dsp->buildUserInterface(obj->m_dspUI);
    #ifdef MIDICTRL
        obj->m_midiHandler->addMidiIn(dsp_poly);
        obj->m_dsp->buildUserInterface(obj->m_midiUI);
    #endif
        // Initialize at the system's sampling rate
        obj->m_dsp->init(long(sys_getsr()));
        
        // Prepare JSON
        faust_make_json(obj);
        
        // Send JSON to JS script
        faust_create_jsui(obj);
        
        systhread_mutex_unlock(obj->m_mutex);
    } else {
        post("Mutex lock cannot be taken...");
    }
}

/*--------------------------------------------------------------------------*/
#ifdef MIDICTRL
void faust_midievent(t_faust* obj, t_symbol* s, short ac, t_atom* av) 
{
    if (ac > 0) {
        int type = (int)av[0].a_w.w_long & 0xf0;
        int channel = (int)av[0].a_w.w_long & 0x0f;
                
        if (ac == 1) {
            obj->m_midiHandler->handleSync(0.0, av[0].a_w.w_long);
        } else if (ac == 2) {
            obj->m_midiHandler->handleData1(0.0, type, channel, av[1].a_w.w_long);
        } else if (ac == 3) {
            obj->m_midiHandler->handleData2(0.0, type, channel, av[1].a_w.w_long, av[2].a_w.w_long);
        }
    }
}
#endif

/*--------------------------------------------------------------------------*/
void faust_create_jsui(t_faust* x)
{
    t_object *patcher, *box, *obj;
    object_obex_lookup((t_object*)x, gensym("#P"), &patcher);
    
    for (box = jpatcher_get_firstobject(patcher); box; box = jbox_get_nextobject(box)) {
        obj = jbox_get_object(box);
        // Notify JSON
        if (obj && strcmp(object_classname(obj)->s_name, "js") == 0) {
            t_atom json;
            atom_setsym(&json, gensym(x->m_json));
            object_method_typed(obj, gensym("anything"), 1, &json, 0);
        }
    }
        
    // Keep all outputs
    x->m_output_table.clear();
    for (box = jpatcher_get_firstobject(patcher); box; box = jbox_get_nextobject(box)) {
        obj = jbox_get_object(box);
        t_symbol* scriptingname = jbox_get_varname(obj); // scripting name
        // Keep control outputs
        if (scriptingname && x->m_dspUI->isOutputValue(scriptingname->s_name)) {
            x->m_output_table[scriptingname->s_name].push_back(obj);
        }
    }
}

void faust_update_outputs(t_faust* x)
{
    map<string, vector<t_object*> >::iterator it1;
    vector<t_object*>::iterator it2;
    for (it1 = x->m_output_table.begin(); it1 != x->m_output_table.end(); it1++) {
        FAUSTFLOAT value = x->m_dspUI->getOutputValue((*it1).first);
        if (value != NAN) {
            t_atom at_value;
            atom_setfloat(&at_value, value);
            for (it2 = (*it1).second.begin(); it2 != (*it1).second.end(); it2++) {
                object_method_typed((*it2), gensym("float"), 1, &at_value, 0);
            }
        }
    }
}

/*--------------------------------------------------------------------------*/
void faust_make_json(t_faust* x)
{
    // Prepare JSON
    if (x->m_json) free(x->m_json);
    JSONUI builder(x->m_dsp->getNumInputs(), x->m_dsp->getNumOutputs());
    x->m_dsp->metadata(&builder);
    x->m_dsp->buildUserInterface(&builder);
    x->m_json = strdup(builder.JSON().c_str());
}

/*--------------------------------------------------------------------------*/
void* faust_new(t_symbol* s, short ac, t_atom* av)
{
    bool midi_sync = false;
    int nvoices = 0;
    mydsp_poly* dsp_poly = NULL;
    
    mydsp* tmp_dsp = new mydsp();
    MidiMeta::analyse(tmp_dsp, midi_sync, nvoices);
    delete tmp_dsp;
    
    t_faust* x = (t_faust*)newobject(faust_class);

    x->m_json = 0;
    x->m_mute = false;
    
#ifdef MIDICTRL
    x->m_midiHandler = new midi_handler();
    x->m_midiUI = new MidiUI(x->m_midiHandler);
#endif
    
    if (nvoices > 0) {
        post("polyphonic DSP voices = %d", nvoices);
        dsp_poly = new mydsp_poly(new mydsp(), nvoices, true, true);
    #ifdef POLY2
        x->m_dsp = new dsp_sequencer(dsp_poly, new effect());
    #else
        x->m_dsp = dsp_poly;
    #endif
        
    #ifdef MIDICTRL
        x->m_midiHandler->addMidiIn(dsp_poly);
        x->m_dsp->buildUserInterface(x->m_midiUI);
    #endif
    } else {
        post("monophonic DSP");
        x->m_dsp = new mydsp();
    }
    
    x->m_Inputs = x->m_dsp->getNumInputs();
    x->m_Outputs = x->m_dsp->getNumOutputs();
   
    x->m_dspUI = new mspUI();

    x->m_dsp->init(long(sys_getsr()));
    x->m_dsp->buildUserInterface(x->m_dspUI);
    
    t_max_err err = systhread_mutex_new(&x->m_mutex, SYSTHREAD_MUTEX_NORMAL);
    if (err != MAX_ERR_NONE) {
        post("Cannot allocate mutex...");
    }
    
    // Prepare JSON
    faust_make_json(x);
    
    int num_input;
    
    if (x->m_dspUI->isMulti()) {
        num_input = x->m_dsp->getNumInputs() + 1;
    } else {
        num_input = x->m_dsp->getNumInputs();
    }
    
    x->m_args = (void**)calloc((num_input + x->m_dsp->getNumOutputs()) + 2, sizeof(void*));
    /* Multi in */
    dsp_setup((t_pxobject*)x, num_input);

    /* Multi out */
    for (int i = 0; i< x->m_dsp->getNumOutputs(); i++) {
        outlet_new((t_pxobject*)x, (char*)"signal");
    }

    ((t_pxobject*)x)->z_misc = Z_NO_INPLACE; // To assure input and output buffers are actually different
    
    // Send JSON to JS script
    faust_create_jsui(x);
    return x;
}

/*--------------------------------------------------------------------------*/
void faust_dblclick(t_faust* x, long inlet)
{
    post((char*)"------------------");
    for (mspUI::iterator it = x->m_dspUI->begin1(); it != x->m_dspUI->end1(); ++it) {
        char param[1024];
        it->second->toString(param);
        post(param);
    }
}

/*--------------------------------------------------------------------------*/
//11/13/2015 : faust_assist is actually called at each click in the patcher... to we now use 'faust_dblclick' to display the parameters...
void faust_assist(t_faust* x, void* b, long msg, long a, char* dst)
{
    if (msg == ASSIST_INLET) {
        if (a == 0) {
            if (x->m_dsp->getNumInputs() == 0) {
                sprintf(dst, "(signal) : Unused Input");
            } else {
                sprintf(dst, "(signal) : Audio Input %ld", (a+1));
			}
            /*
			post((char*)"------------------");
			for (mspUI::iterator it = x->m_dspUI->begin1(); it != x->m_dspUI->end1(); ++it) {
				char param[1024];
				it->second->toString(param);
				post(param);
			}
            */
        } else if (a < x->m_dsp->getNumInputs()) {
            sprintf(dst, "(signal) : Audio Input %ld", (a+1));
        }
    } else if (msg == ASSIST_OUTLET) {
        sprintf(dst, "(signal) : Audio Output %ld", (a+1));
    }
}

/*--------------------------------------------------------------------------*/
void faust_mute(t_faust* obj, t_symbol* s, short ac, t_atom* at)
{
    if (atom_gettype(at) == A_LONG) {
        obj->m_mute = atom_getlong(at);
    }
}

/*--------------------------------------------------------------------------*/
void faust_free(t_faust* x)
{
	dsp_free((t_pxobject*)x);
	delete x->m_dsp;
	delete x->m_dspUI;
	if (x->m_args) free(x->m_args);
    if (x->m_json) free(x->m_json);
    systhread_mutex_free(x->m_mutex);
#ifdef MIDICTRL
    delete x->m_midiHandler;
    delete x->m_midiUI;
#endif
}

/*--------------------------------------------------------------------------*/
void faust_perform64(t_faust* x, t_object* dsp64, double** ins, long numins, double** outs, long numouts, long sampleframes, long flags, void* userparam)
{
    AVOIDDENORMALS;
    if (!x->m_mute && systhread_mutex_trylock(x->m_mutex) == MAX_ERR_NONE) {
        if (x->m_dsp) {
            if (x->m_dspUI->isMulti()) {
                x->m_dspUI->setMultiValues(ins[0], sampleframes);
                x->m_dsp->compute(sampleframes, ++ins, outs);
            } else {
                x->m_dsp->compute(sampleframes, ins, outs);
            }
            faust_update_outputs(x);
        }
    #ifdef MIDICTRL
        GUI::updateAllGuis();
    #endif
         systhread_mutex_unlock(x->m_mutex);
    } else {
        // Write null buffers to outs
        for (int i = 0; i < numouts; i++) {
             memset(outs[i], 0, sizeof(double) * sampleframes);
        }
    }
}

/*--------------------------------------------------------------------------*/
void faust_dsp64(t_faust* x, t_object* dsp64, short* count, double samplerate, long maxvectorsize, long flags)
{
    object_method(dsp64, gensym("dsp_add64"), x, faust_perform64, 0, NULL);
}

/*--------------------------------------------------------------------------*/
extern "C" int main(void)
{
	setup((t_messlist**)&faust_class, (method)faust_new, (method)faust_free,
		(short)sizeof(t_faust), 0L, A_DEFFLOAT, 0);

    dsp* tmp_dsp = new mydsp();
    mspUI m_dspUI;
    tmp_dsp->buildUserInterface(&m_dspUI);

    // 03/11/14 : use 'anything' to handle all parameter changes
    addmess((method)faust_anything, (char*)"anything", A_GIMME, 0);
    addmess((method)faust_polyphony, (char*)"polyphony", A_GIMME, 0);
#ifdef MIDICTRL
    addmess((method)faust_midievent, (char*)"midievent", A_GIMME, 0);
#endif
    addmess((method)faust_dsp64, (char*)"dsp64", A_CANT, 0);
    addmess((method)faust_dblclick, (char*)"dblclick", A_CANT, 0);
    addmess((method)faust_assist, (char*)"assist", A_CANT, 0);
    addmess((method)faust_mute, (char*)"mute", A_GIMME, 0);
    dsp_initclass();

    post((char*)"Faust DSP object v%s (sample = 64 bits code = %s)", EXTERNAL_VERSION, getCodeSize());
    post((char*)"Copyright (c) 2012-2017 Grame");
    Max_Meta1 meta1;
    tmp_dsp->metadata(&meta1);
    if (meta1.fCount > 0) {
        Max_Meta2 meta2;
        post("------------------------------");
        tmp_dsp->metadata(&meta2);
        post("------------------------------");
    }
    
    delete(tmp_dsp);
    return 0;
}

/********************END ARCHITECTURE SECTION (part 2/2)****************/




